/*
 	File:		TranslationExtensions.h
 
 	Copyright:	 1984-1994 by Apple Computer, Inc.
 				All rights reserved.
 
 	Version:	Universal Interfaces 2.0a1.  ETO #15, MPW prerelease.  Sunday, July 17, 1994. 
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*/

#ifndef __TRANSLATIONEXTENSIONS__
#define __TRANSLATIONEXTENSIONS__


#ifdef __cplusplus
extern "C" {
#endif

#if GENERATINGPOWERPC
#pragma options align=mac68k
#endif

#ifdef __CFM68K__
#pragma lib_export on
#endif

#define kSupportsFileTranslation 1
#define kSupportsScrapTranslation 2
#define kTranslatorCanGenerateFilename 4
#ifndef REZ

#ifndef __MEMORY__
#include <Memory.h>
#endif
/*	#include <Types.h>											*/
/*		#include <ConditionalMacros.h>							*/
/*	#include <MixedMode.h>										*/

#ifndef __FILES__
#include <Files.h>
#endif
/*	#include <OSUtils.h>										*/

#ifndef __QUICKDRAW__
#include <Quickdraw.h>
#endif
/*	#include <QuickdrawText.h>									*/

#ifndef __COMPONENTS__
#include "Components.h"
#endif
typedef OSType FileType;

typedef ResType ScrapType;

typedef unsigned long TranslationAttributes;


enum {
	taDstDocNeedsResourceFork	= 1,
	taDstIsAppTranslation		= 2
};

struct FileTypeSpec {
	FileType						format;
	long							hint;
	TranslationAttributes			flags;
	OSType							catInfoType;
	OSType							catInfoCreator;
};
typedef struct FileTypeSpec FileTypeSpec;

struct FileTranslationList {
	unsigned long					modDate;
	unsigned long					groupCount;
};
typedef struct FileTranslationList FileTranslationList;

typedef FileTranslationList *FileTranslationListPtr, **FileTranslationListHandle;

struct ScrapTypeSpec {
	ScrapType						format;
	long							hint;
};
typedef struct ScrapTypeSpec ScrapTypeSpec;

struct ScrapTranslationList {
	unsigned long					modDate;
	unsigned long					groupCount;
};
typedef struct ScrapTranslationList ScrapTranslationList;

typedef ScrapTranslationList *ScrapTranslationListPtr, **ScrapTranslationListHandle;

typedef long TranslationRefNum;

extern pascal OSErr SetTranslationAdvertisement(TranslationRefNum refNum, PicHandle advertisement)
 TWOWORDINLINE(0x7002, 0xABFC);
extern pascal OSErr UpdateTranslationProgress(TranslationRefNum refNum, short percentDone, Boolean *canceled)
 TWOWORDINLINE(0x7001, 0xABFC);

enum {
	kTranslateGetFileTranslationList = 0,
	kTranslateIdentifyFile,
	kTranslateTranslateFile,
	kTranslateGetTranslatedFilename,
	kTranslateGetScrapTranslationList = 10,
	kTranslateIdentifyScrap,
	kTranslateTranslateScrap
};

typedef pascal ComponentResult (*DoGetFileTranslationListProcPtr)(ComponentInstance self, FileTranslationListHandle translationList);
typedef pascal ComponentResult (*DoIdentifyFileProcPtr)(ComponentInstance self, const FSSpec *theDocument, FileType *docType);
typedef pascal ComponentResult (*DoTranslateFileProcPtr)(ComponentInstance self, TranslationRefNum refNum, const FSSpec *sourceDocument, FileType srcType, long srcTypeHint, const FSSpec *dstDoc, FileType dstType, long dstTypeHint);
typedef pascal ComponentResult (*DoGetTranslatedFilenameProcPtr)(ComponentInstance self, FileType dstType, long dstTypeHint, FSSpec *theDocument);
typedef pascal ComponentResult (*DoGetScrapTranslationListProcPtr)(ComponentInstance self, ScrapTranslationListHandle list);
typedef pascal ComponentResult (*DoIdentifyScrapProcPtr)(ComponentInstance self, const void *dataPtr, Size dataLength, ScrapType *dataFormat);
typedef pascal ComponentResult (*DoTranslateScrapProcPtr)(ComponentInstance self, TranslationRefNum refNum, const void *srcDataPtr, Size srcDataLength, ScrapType srcType, long srcTypeHint, Handle dstData, ScrapType dstType, long dstTypeHint);
#endif

#ifdef __CFM68K__
#pragma lib_export off
#endif

#if GENERATINGPOWERPC
#pragma options align=reset
#endif

#ifdef __cplusplus
}
#endif

#endif /* __TRANSLATIONEXTENSIONS__ */
