{
 	File:		MediaHandlers.p
 
 	Copyright:	 1984-1994 by Apple Computer, Inc.
 				All rights reserved.
 
 	Version:	Universal Interfaces 2.0a1.  ETO #15, MPW prerelease.  Sunday, July 17, 1994. 
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
}

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT MediaHandlers;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __MEDIAHANDLERS__}
{$SETC __MEDIAHANDLERS__ := 1}

{$I+}
{$SETC MediaHandlersIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}


{$IFC UNDEFINED __MEMORY__}
{$I Memory.p}
{$ENDC}
{	Types.p														}
{		ConditionalMacros.p										}
{	MixedMode.p													}

{$IFC UNDEFINED __IMAGECOMPRESSION__}
{$I ImageCompression.p}
{$ENDC}
{	Quickdraw.p													}
{		QuickdrawText.p											}
{	QDOffscreen.p												}
{		Errors.p												}
{	Components.p												}
{	Windows.p													}
{		Events.p												}
{			OSUtils.p											}
{		Controls.p												}
{			Menus.p												}
{	StandardFile.p												}
{		Dialogs.p												}
{			TextEdit.p											}
{		Files.p													}

{$IFC UNDEFINED __MOVIES__}
{$I Movies.p}
{$ENDC}
{	Aliases.p													}
{		AppleTalk.p												}

{$PUSH}
{$ALIGN MAC68K}
{$LibExport+}

CONST
	handlerHasSpatial			= 1 * (2**(0));
	handlerCanClip				= 1 * (2**(1));
	handlerCanMatte				= 1 * (2**(2));
	handlerCanTransferMode		= 1 * (2**(3));
	handlerNeedsBuffer			= 1 * (2**(4));
	handlerNoIdle				= 1 * (2**(5));
	handlerNoScheduler			= 1 * (2**(6));
	handlerWantsTime			= 1 * (2**(7));
	handlerCGrafPortOnly		= 1 * (2**(8));

	mMustDraw					= 1 * (2**(3));
	mAtEnd						= 1 * (2**(4));
	mPreflightDraw				= 1 * (2**(5));

	mDidDraw					= 1 * (2**(0));
	mNeedsToDraw				= 1 * (2**(2));
	mPartialDraw				= 1 * (2**(4));

	forceUpdateRedraw			= 1 * (2**(0));
	forceUpdateNewBuffer		= 1 * (2**(1));


TYPE
	GetMovieCompleteParams = RECORD
		version:				INTEGER;
		theMovie:				Movie;
		theTrack:				Track;
		theMedia:				Media;
		movieScale:				TimeScale;
		mediaScale:				TimeScale;
		movieDuration:			TimeValue;
		trackDuration:			TimeValue;
		mediaDuration:			TimeValue;
		effectiveRate:			Fixed;
		timeBase:				TimeBase;
		volume:					INTEGER;
		width:					Fixed;
		height:					Fixed;
		trackMovieMatrix:		MatrixRecord;
		moviePort:				CGrafPtr;
		movieGD:				GDHandle;
		trackMatte:				PixMapHandle;
	END;

CONST
	kMediaInitializeSelect		= $501;
	kMediaSetHandlerCapabilitiesSelect = $502;
	kMediaIdleSelect			= $503;
	kMediaGetMediaInfoSelect	= $504;
	kMediaPutMediaInfoSelect	= $505;
	kMediaSetActiveSelect		= $506;
	kMediaSetRateSelect			= $507;
	kMediaGGetStatusSelect		= $508;
	kMediaTrackEditedSelect		= $509;
	kMediaSetMediaTimeScaleSelect = $50A;
	kMediaSetMovieTimeScaleSelect = $50B;
	kMediaSetGWorldSelect		= $50C;
	kMediaSetDimensionsSelect	= $50D;
	kMediaSetClipSelect			= $50E;
	kMediaSetMatrixSelect		= $50F;
	kMediaGetTrackOpaqueSelect	= $510;
	kMediaSetGraphicsModeSelect	= $511;
	kMediaGetGraphicsModeSelect	= $512;
	kMediaGSetVolumeSelect		= $513;
	kMediaSetSoundBalanceSelect	= $514;
	kMediaGetSoundBalanceSelect	= $515;
	kMediaGetNextBoundsChangeSelect = $516;
	kMediaGetSrcRgnSelect		= $517;
	kMediaPrerollSelect			= $518;
	kMediaSampleDescriptionChangedSelect = $519;
	kMediaHasCharacteristicSelect = $51A;
	kMediaGetOffscreenBufferSizeSelect = $51B;
	kMediaSetHintsSelect		= $51C;
	kMediaGetNameSelect			= $51D;
	kMediaForceUpdateSelect		= $51E;
	kMediaGetDrawingRgnSelect	= $521;


FUNCTION MediaInitialize(ci: ComponentInstance; VAR gmc: GetMovieCompleteParams): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $4, $501, $7000, $A82A;
	{$ENDC}
FUNCTION MediaSetHandlerCapabilities(ci: ComponentInstance; flags: LONGINT; flagsMask: LONGINT): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $8, $502, $7000, $A82A;
	{$ENDC}
FUNCTION MediaIdle(ci: ComponentInstance; atMediaTime: TimeValue; flagsIn: LONGINT; VAR flagsOut: LONGINT; movieTime: TimeRecord): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $10, $503, $7000, $A82A;
	{$ENDC}
FUNCTION MediaGetMediaInfo(ci: ComponentInstance; h: Handle): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $4, $504, $7000, $A82A;
	{$ENDC}
FUNCTION MediaPutMediaInfo(ci: ComponentInstance; h: Handle): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $4, $505, $7000, $A82A;
	{$ENDC}
FUNCTION MediaSetActive(ci: ComponentInstance; enableMedia: BOOLEAN): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $2, $506, $7000, $A82A;
	{$ENDC}
FUNCTION MediaSetRate(ci: ComponentInstance; rate: Fixed): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $4, $507, $7000, $A82A;
	{$ENDC}
FUNCTION MediaGGetStatus(ci: ComponentInstance; VAR statusErr: ComponentResult): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $4, $508, $7000, $A82A;
	{$ENDC}
FUNCTION MediaTrackEdited(ci: ComponentInstance): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $0, $509, $7000, $A82A;
	{$ENDC}
FUNCTION MediaSetMediaTimeScale(ci: ComponentInstance; newTimeScale: TimeScale): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $4, $50A, $7000, $A82A;
	{$ENDC}
FUNCTION MediaSetMovieTimeScale(ci: ComponentInstance; newTimeScale: TimeScale): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $4, $50B, $7000, $A82A;
	{$ENDC}
FUNCTION MediaSetGWorld(ci: ComponentInstance; aPort: CGrafPtr; aGD: GDHandle): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $8, $50C, $7000, $A82A;
	{$ENDC}
FUNCTION MediaSetDimensions(ci: ComponentInstance; width: Fixed; height: Fixed): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $8, $50D, $7000, $A82A;
	{$ENDC}
FUNCTION MediaSetClip(ci: ComponentInstance; theClip: RgnHandle): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $4, $50E, $7000, $A82A;
	{$ENDC}
FUNCTION MediaSetMatrix(ci: ComponentInstance; VAR trackMovieMatrix: MatrixRecord): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $4, $50F, $7000, $A82A;
	{$ENDC}
FUNCTION MediaGetTrackOpaque(ci: ComponentInstance; VAR trackIsOpaque: BOOLEAN): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $4, $510, $7000, $A82A;
	{$ENDC}
FUNCTION MediaSetGraphicsMode(ci: ComponentInstance; mode: LONGINT; VAR opColor: RGBColor): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $8, $511, $7000, $A82A;
	{$ENDC}
FUNCTION MediaGetGraphicsMode(ci: ComponentInstance; VAR mode: LONGINT; VAR opColor: RGBColor): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $8, $512, $7000, $A82A;
	{$ENDC}
FUNCTION MediaGSetVolume(ci: ComponentInstance; volume: INTEGER): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $2, $513, $7000, $A82A;
	{$ENDC}
FUNCTION MediaSetSoundBalance(ci: ComponentInstance; balance: INTEGER): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $2, $514, $7000, $A82A;
	{$ENDC}
FUNCTION MediaGetSoundBalance(ci: ComponentInstance; VAR balance: INTEGER): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $4, $515, $7000, $A82A;
	{$ENDC}
FUNCTION MediaGetNextBoundsChange(ci: ComponentInstance; VAR when: TimeValue): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $4, $516, $7000, $A82A;
	{$ENDC}
FUNCTION MediaGetSrcRgn(ci: ComponentInstance; rgn: RgnHandle; atMediaTime: TimeValue): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $8, $517, $7000, $A82A;
	{$ENDC}
FUNCTION MediaPreroll(ci: ComponentInstance; time: TimeValue; rate: Fixed): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $8, $518, $7000, $A82A;
	{$ENDC}
FUNCTION MediaSampleDescriptionChanged(ci: ComponentInstance; index: LONGINT): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $4, $519, $7000, $A82A;
	{$ENDC}
FUNCTION MediaHasCharacteristic(ci: ComponentInstance; characteristic: OSType; VAR hasIt: BOOLEAN): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $8, $51A, $7000, $A82A;
	{$ENDC}
FUNCTION MediaGetOffscreenBufferSize(ci: ComponentInstance; VAR bounds: Rect; depth: INTEGER; ctab: CTabHandle): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $A, $51B, $7000, $A82A;
	{$ENDC}
FUNCTION MediaSetHints(ci: ComponentInstance; hints: LONGINT): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $4, $51C, $7000, $A82A;
	{$ENDC}
FUNCTION MediaGetName(ci: ComponentInstance; VAR name: Str255; requestedLanguage: LONGINT; VAR actualLanguage: LONGINT): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $C, $51D, $7000, $A82A;
	{$ENDC}
FUNCTION MediaForceUpdate(ci: ComponentInstance; forceUpdateFlags: LONGINT): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $4, $51E, $7000, $A82A;
	{$ENDC}
FUNCTION MediaGetDrawingRgn(ci: ComponentInstance; VAR partialRgn: RgnHandle): ComponentResult;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $4, $521, $7000, $A82A;
	{$ENDC}

{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := MediaHandlersIncludes}

{$ENDC} {__MEDIAHANDLERS__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
