
(in-package :TRAPS)             ; ***********************************************************
; 
; Created: Monday, November 8, 1993 12:03PM
;  OCEStandardMail.p
;  Pascal Interface to the Macintosh Libraries
; 
;   Copyright Apple Computer, Inc. 1990-1993
;   All rights reserved
; 
; ***********************************************************

; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes:= 0
; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED UsingOCEStandardMail
; $SETC UsingOCEStandardMail:= 1

; $I+
; $SETC OCEStandardMailIncludes:= UsingIncludes
; $SETC UsingIncludes:= 1

; $IFC UNDEFINED UsingAppleEvents

(require-interface 'APPLEEVENTS); $I $$Shell(PInterfaces)AppleEvents.p
; $ENDC

; $IFC UNDEFINED UsingFiles

(require-interface 'FILES)      ; $I $$Shell(PInterfaces)Files.p
; $ENDC

; $IFC UNDEFINED UsingOCEAuthDir
; $I OCEAuthDir.p
; $ENDC

; $IFC UNDEFINED UsingOCEMail
; $I OCEMail.p
; $ENDC

; $IFC UNDEFINED UsingWindows

(require-interface 'WINDOWS)    ; $I $$Shell(PInterfaces)Windows.p
; $ENDC

; $IFC UNDEFINED UsingDialogs

(require-interface 'DIALOGS)    ; $I $$Shell(PInterfaces)Dialogs.p
; $ENDC

; $SETC UsingIncludes:= OCEStandardMailIncludes

(defconstant $gestaltSMPMailerVersion :|malr|)
(defconstant $gestaltSMPSPSendLetterVersion :|spsl|)

(defconstant $kSMPNativeFormatName :|natv|)

(defconstant $kSMPVersion 1)

(defrecord LetterSpec 
   (spec (:ARRAY :SIGNED-LONG (- 3 1 -1)))
   )

(defconstant $typeLetterSpec :|lttr|)

;  Wildcard used for filtering letter types. 

(defconstant $FilterAnyLetter :|ltr*|)
(defconstant $FilterAppleLetterContent :|ltc*|)
(defconstant $FilterImageContent :|lti*|)

(defrecord LetterDescriptor 
   (onDisk :BOOLEAN)
   (:variant 
      ((fileSpec :FSSPEC))
      ((mailboxSpec :LETTERSPEC))
      ))

; 
; SMPPSendAs values.  You may add the following values together to determine how the
; file is sent, but you may not set both kSMPSendAsEnclosureMask and kSMPSendFileOnlyMask.  This
; will allow you to send the letter as an image so that it will work with fax gateways
; and send as an enclosure as well.
; 

(defconstant $kSMPSendAsEnclosureBit 0);  Appears as letter with enclosures 
(defconstant $kSMPSendFileOnlyBit 1);  Appears as a file in mailbox. 
(defconstant $kSMPSendAsImageBit 2);  Content imaged in letter 

;  Values of SMPPSendAs 
(defconstant $kSMPSendAsEnclosureMask #X1); 1<<kSMPSendAsEnclosureBit
(defconstant $kSMPSendFileOnlyMask #X2); 1<<kSMPSendFileOnlyBit
(defconstant $kSMPSendAsImageMask #X4); 1<<kSMPSendAsImageBit

(def-mactype :SMPPSENDAS (find-mactype :UNSIGNED-BYTE))

;  Send Package Structures 

(def-mactype :SMPDRAWIMAGEPROCPTR (find-mactype :POINTER))
;  FUNCTION SMPDrawImageProcPtr(refcon: LONGINT; inColor: BOOLEAN): void;

(defrecord SMPRecipientDescriptor 
   (next (:POINTER :SMPRECIPIENTDESCRIPTOR));   Q-Link. 
   (result :SIGNED-INTEGER)     ;   result code when using the object. 
   (recipient (:POINTER :OCEPACKEDRECIPIENT));   Pointer to a Packed Address. 
   (size :SIGNED-LONG)          ;   length of recipient in bytes. 
   (theAddress :OCERECIPIENT)   ;   structure points into recipient and theRID. 
   (theRID :RECORDID)           ;   structure points into recipient. 
   )

(def-mactype :SMPRECIPIENTDESCRIPTORPTR (find-mactype :POINTER))

(defrecord SMPEnclosureDescriptor 
   (next (:POINTER :SMPENCLOSUREDESCRIPTOR))
   (result :SIGNED-INTEGER)
   (fileSpec :FSSPEC)
   (fileCreator :OSTYPE)        ;   Creator of this enclosure. 
   (fileType :OSTYPE)           ;   File Type of this enclosure. 
   )

(def-mactype :SMPENCLOSUREDESCRIPTORPTR (find-mactype :POINTER))

(defrecord SMPLetterPB 
   (result :SIGNED-INTEGER)     ;  result of operation 
   (subject (:POINTER :RSTRING));  RString 
   (senderIdentity :SIGNED-LONG);  Letter is sent from this Identity 
   (toList (:POINTER :SMPRECIPIENTDESCRIPTOR));  Pointer to linked list 
   (ccList (:POINTER :SMPRECIPIENTDESCRIPTOR));  Pointer to linked list 
   (bccList (:POINTER :SMPRECIPIENTDESCRIPTOR));  Pointer to linked list 
   (script :SIGNED-INTEGER)     ;  Identifier for language 
   (textSize :SIZE)             ;  length of body data 
   (textBuffer :POINTER)        ;  body of the letter 
   (sendAs :UNSIGNED-BYTE)      ;  Send as Letter, Enclosure, Image 
   (padByte :UNSIGNED-BYTE)
   (enclosures (:POINTER :SMPENCLOSUREDESCRIPTOR));  files to be enclosed 
   (drawImageProc :POINTER)     ;  For imaging 
   (imageRefCon :SIGNED-LONG)   ;  For imaging 

; ERROR!! Record field SUPPORTSCOLOR declared PACKED BOOLEAN !
   (supportsColor :BOOLEAN)     ;  For imaging - set to true if you application supports color imaging 
   )

(def-mactype :SMPLETTERPBPTR (find-mactype :POINTER))

(defconstant $kSMPAppMustHandleEventBit 0)
(defconstant $kSMPAppShouldIgnoreEventBit 1)
(defconstant $kSMPContractedBit 2)
(defconstant $kSMPExpandedBit 3)
(defconstant $kSMPMailerBecomesTargetBit 4)
(defconstant $kSMPAppBecomesTargetBit 5)
(defconstant $kSMPCursorOverMailerBit 6)
(defconstant $kSMPCreateCopyWindowBit 7)
(defconstant $kSMPDisposeCopyWindowBit 8)
;  Values of SMPMailerResult 
(defconstant $kSMPAppMustHandleEventMask #X1); 1<<kSMPAppMustHandleEventBit
(defconstant $kSMPAppShouldIgnoreEventMask #X2); 1<<kSMPAppShouldIgnoreEventBit
(defconstant $kSMPContractedMask #X4); 1<<kSMPContractedBit
(defconstant $kSMPExpandedMask #X8); 1<<kSMPExpandedBit
(defconstant $kSMPMailerBecomesTargetMask #X10); 1<<kSMPMailerBecomesTargetBit
(defconstant $kSMPAppBecomesTargetMask #X20); 1<<kSMPAppBecomesTargetBit
(defconstant $kSMPCursorOverMailerMask #X40); 1<<kSMPCursorOverMailerBit
(defconstant $kSMPCreateCopyWindowMask #X80); 1<<kSMPCreateCopyWindowBit
(defconstant $kSMPDisposeCopyWindowMask #X100); 1<<kSMPDisposeCopyWindowBit

(def-mactype :SMPMAILERRESULT (find-mactype :SIGNED-LONG))

;  Values of SMPMailerComponent
(defconstant $kSMPOther -1)
(defconstant $kSMPFrom 32)
(defconstant $kSMPTo 20)
(defconstant $kSMPRegarding 22)
(defconstant $kSMPSendDateTime 29)
(defconstant $kSMPAttachments 26)
(defconstant $kSMPAddressOMatic 16)

(def-mactype :SMPMAILERCOMPONENT (find-mactype :SIGNED-LONG))

(defconstant $kSMPToAddress #$KMAILTOBIT)
(defconstant $kSMPCCAddress #$KMAILCCBIT)
(defconstant $kSMPBCCAddress #$KMAILBCCBIT)

(def-mactype :SMPADDRESSTYPE (find-mactype :SIGNED-INTEGER))

(defconstant $kSMPUndoCommand 0)
(defconstant $kSMPCutCommand 1)
(defconstant $kSMPCopyCommand 2)
(defconstant $kSMPPasteCommand 3)
(defconstant $kSMPClearCommand 4)
(defconstant $kSMPSelectAllCommand 5)

(def-mactype :SMPEDITCOMMAND (find-mactype :SIGNED-INTEGER))

(defconstant $kSMPUndoDisabled 0)
(defconstant $kSMPAppMayUndo 1)
(defconstant $kSMPMailerUndo 2)

(def-mactype :SMPUNDOSTATE (find-mactype :SIGNED-INTEGER))

; 
; SMPSendFormatMask:
; 
; Bitfield indicating which combinations of formats are included in,
; should be included or, or can be included in a letter.
; 

(defconstant $kSMPNativeBit 0)
(defconstant $kSMPImageBit 1)
(defconstant $kSMPStandardInterchangeBit 2)

;  Values of SMPSendFormatMask 

(defconstant $kSMPNativeMask #X1); 1<<kSMPNativeBit
(defconstant $kSMPImageMask #X2); 1<<kSMPImageBit
(defconstant $kSMPStandardInterchangeMask #X4); 1<<kSMPStandardInterchangeBit

(def-mactype :SMPSENDFORMATMASK (find-mactype :SIGNED-LONG))

; 
; 	Pseudo-events passed to the clients filter proc for initialization and cleanup.
; 

(defconstant $kSMPSendOptionsStart -1)
(defconstant $kSMPSendOptionsEnd -2)

; 
; SMPSendFormatMask:
; 
; Structure describing the format of a letter.  If kSMPNativeMask bit is set, the whichNativeFormat field indicates which of the client-defined formats to use.
; 

(defrecord SMPSendFormat 
   (whichFormats :SIGNED-LONG)
   (whichNativeFormat :SIGNED-INTEGER);  0 based 
   )

(defrecord SMPLetterInfo 
   (letterCreator :OSTYPE)
   (letterType :OSTYPE)
   (subject :RSTRING32)
   (sender :RSTRING32)
   )

(defconstant $kSMPSave 0)
(defconstant $kSMPSaveAs 1)
(defconstant $kSMPSaveACopy 2)

(def-mactype :SMPSAVETYPE (find-mactype :SIGNED-INTEGER))

(def-mactype :FRONTWINDOWPROCPTR (find-mactype :POINTER))
;  FUNCTION FrontWindowProcPtr(clientData: LONGINT): WindowPtr;

(def-mactype :PREPAREMAILERFORDRAWINGPROCPTR (find-mactype :POINTER))
;  FUNCTION PrepareMailerForDrawingProcPtr(
; 		window: WindowPtr; clientData: LONGINT): void;

(def-mactype :SENDOPTIONSFILTERPROC (find-mactype :POINTER))
;  FUNCTION SendOptionsFilterProc(theDialog: DialogPtr; VAR theEvent: EventRecord;
; 		itemHit: INTEGER; clientData: LONGINT): BOOLEAN;

(defconstant $kSMPGetDimensions 4700)
(defconstant $kSMPNewMailer 4701)
(defconstant $kSMPDisposeMailer 4702)
(defconstant $kSMPMailerEvent 4703)
(defconstant $kSMPMailerEditCommand 4704)
(defconstant $kSMPMailerForward 4705)
(defconstant $kSMPMailerReply 4706)
(defconstant $kSMPGetMailerState 4707)
(defconstant $kSMPPrepareCoverPages 4708)
(defconstant $kSMPDrawNthCoverPage 4709)
(defconstant $kSMPBeginSave 4710)
(defconstant $kSMPBeginSend 4711)
(defconstant $kSMPOpenLetter 4712)
(defconstant $kSMPDrawMailer 4713)
(defconstant $kSMPMoveMailer 4714)
(defconstant $kSMPSetSubject 4715)
(defconstant $kSMPSetFromIdentity 4716)
(defconstant $kSMPAddAddress 4717)
(defconstant $kSMPAddAttachment 4718)
(defconstant $kSMPContentChanged 4719)
(defconstant $kSMPEndSave 4720)
(defconstant $kSMPEndSend 4721)
(defconstant $kSMPExpandOrContract 4722)
(defconstant $kSMPBecomeTarget 4723)
(defconstant $kSMPGetTabInfo 4724)
(defconstant $kSMPClearUndo 4725)
(defconstant $kSMPAttachDialog 4726)
(defconstant $kSMPGetComponentSize 4727)
(defconstant $kSMPGetComponentInfo 4728)
(defconstant $kSMPGetListItemInfo 4729)
(defconstant $kSMPAddContent 4730)
(defconstant $kSMPReadContent 4731)
(defconstant $kSMPGetFontNameFromLetter 4732)
(defconstant $kSMPAddMainEnclosure 4733)
(defconstant $kSMPGetMainEnclosureFSSpec 4734)
(defconstant $kSMPAddBlock 4735)
(defconstant $kSMPReadBlock 4736)
(defconstant $kSMPEnumerateBlocks 4737)
(defconstant $kSMPImage 4738)
(defconstant $kSMPInitMailer 4741)
(defconstant $kSMPGetNextLetter 4742)
(defconstant $kSMPPrepareToClose 4743)
(defconstant $kSMPCloseOptionsDialog 4744)
(defconstant $kSMPPrepareToChange 4745)
(defconstant $kSMPGetLetterInfo 4746)
(defconstant $kSMPTagDialog 4747)
(defconstant $kSMPSendOptionsDialog 5000)

(defrecord SMPMailerState 
   (mailerCount :SIGNED-INTEGER)
   (currentMailer :SIGNED-INTEGER)
   (upperLeft :POINT)
   (hasBeenReceived :BOOLEAN)
   (isTarget :BOOLEAN)
   (isExpanded :BOOLEAN)
   (canMoveToTrash :BOOLEAN)
   (canTag :BOOLEAN)
; padByte2: Byte;
   (changeCount :SIGNED-LONG)
   (targetComponent :SIGNED-LONG)
   (canCut :BOOLEAN)
   (canCopy :BOOLEAN)
   (canPaste :BOOLEAN)
   (canClear :BOOLEAN)
   (canSelectAll :BOOLEAN)
; padByte3: Byte;
   (undoState :SIGNED-INTEGER)
   (undoWhat (:STRING 63))
   )

(defrecord SMPSendOptions 
   (signWhenSent :BOOLEAN)

; ERROR!! Record field PRIORITY declared Non-PACKED BYTE !
   (priority :UNSIGNED-BYTE)
   )

(def-mactype :SMPSENDOPTIONSPTR (find-mactype :POINTER))
(def-mactype :SMPSENDOPTIONSHANDLE (find-mactype :HANDLE))

(defrecord SMPCloseOptions 
   (moveToTrash :BOOLEAN)
   (addTag :BOOLEAN)
   (tag :RSTRING32)
   )

(def-mactype :SMPCLOSEOPTIONSPTR (find-mactype :POINTER))

; ----------------------------------------------------------------------------------------
; 	Send Package Routines
; ----------------------------------------------------------------------------------------

(defconstant $kSMPSendLetter 500)
(defconstant $kSMPResolveToRecipient 1100)

(defconstant $kSMPNewPage 2100)
(defconstant $kSMPImageErr 2101)


(deftrap _smpsendletter ((theletter (:pointer :smpletterpb)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 2 16) 500) theletter))


(deftrap _smpnewpage ((newheader (:pointer :opencpicparams)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 2 16) 2100) newheader))


(deftrap _smpimageerr nil
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 0 16) 2101)))


(deftrap _smpresolvetorecipient ((dsspec (:pointer :packeddsspec)) (recipientlist (:pointer (:pointer :smprecipientdescriptor))) (identity :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 6 16) 1100) dsspec recipientlist identity))


(deftrap _smpinitmailer ((mailerversion :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 2 16) 4741) mailerversion))


(deftrap _smpgetdimensions ((width (:pointer :signed-integer)) (contractedheight (:pointer :signed-integer)) (expandedheight (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 6 16) 4700) width contractedheight expandedheight))


(deftrap _smpgettabinfo ((firsttab (:pointer :signed-long)) (lasttab (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 4724) firsttab lasttab))


(deftrap _smpnewmailer ((window (:pointer :grafport)) (upperleft :point) (cancontract :boolean) (initiallyexpanded :boolean) (identity :signed-long) (preparemailerfordrawingcb :pointer) (clientdata :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 12 16) 4701) window upperleft cancontract initiallyexpanded identity preparemailerfordrawingcb clientdata))


(deftrap _smppreparetoclose ((window (:pointer :grafport)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 2 16) 4743) window))


(deftrap _smpcloseoptionsdialog ((window (:pointer :grafport)) (closeoptions (:pointer :smpcloseoptions)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 4744) window closeoptions))


(deftrap _smptagdialog ((window (:pointer :grafport)) (thetag (:pointer :rstring32)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 4747) window thetag))


(deftrap _smpdisposemailer ((window (:pointer :grafport)) (closeoptions (:pointer :smpcloseoptions)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 4702) window closeoptions))


(deftrap _smpmailerevent ((event :eventrecord) (whathappened (:pointer :signed-long)) (frontwindowcb :pointer) (clientdata :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 8 16) 4703) event whathappened frontwindowcb clientdata))


(deftrap _smpclearundo ((window (:pointer :grafport)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 2 16) 4725) window))


(deftrap _smpmailereditcommand ((window (:pointer :grafport)) (command :signed-integer) (whathappened (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 5 16) 4704) window command whathappened))


(deftrap _smpmailerforward ((window (:pointer :grafport)) (from :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 4705) window from))


(deftrap _smpmailerreply ((originalletter (:pointer :grafport)) (newletter (:pointer :grafport)) (replytoall :boolean) (upperleft :point) (cancontract :boolean) (initiallyexpanded :boolean) (identity :signed-long) (preparemailerfordrawingcb :pointer) (clientdata :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 15 16) 4706) originalletter newletter replytoall upperleft cancontract initiallyexpanded identity preparemailerfordrawingcb clientdata))


(deftrap _smpgetmailerstate ((window (:pointer :grafport)) (itsstate (:pointer :smpmailerstate)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 4707) window itsstate))


(deftrap _smpsendoptionsdialog ((window (:pointer :grafport)) (documentname (:string 255)) (nativeformatnames (:pointer (:pointer (:string 255)))) (namecount :signed-integer) (cansend :signed-long) (currentformat (:pointer :smpsendformat)) (filterproc :pointer) (clientdata :signed-long) (shouldsend (:pointer :smpsendformat)) (sendoptions (:pointer :smpsendoptions)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 19 16) 5000) window documentname nativeformatnames namecount cansend currentformat filterproc clientdata shouldsend sendoptions))


(deftrap _smppreparecoverpages ((window (:pointer :grafport)) (pagecount (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 4708) window pagecount))


(deftrap _smpdrawnthcoverpage ((window (:pointer :grafport)) (pagenumber :signed-integer) (donedrawingcoverpages :boolean))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 4709) window pagenumber donedrawingcoverpages))


(deftrap _smppreparetochange ((window (:pointer :grafport)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 2 16) 4745) window))


(deftrap _smpcontentchanged ((window (:pointer :grafport)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 2 16) 4719) window))


(deftrap _smpbeginsave ((window (:pointer :grafport)) (diskletter :fsspec) (creator :ostype) (filetype :ostype) (savetype :signed-integer) (mustaddcontent (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 11 16) 4710) window diskletter creator filetype savetype mustaddcontent))


(deftrap _smpendsave ((window (:pointer :grafport)) (oktosave :boolean))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 3 16) 4720) window oktosave))


(deftrap _smpbeginsend ((window (:pointer :grafport)) (creator :ostype) (filetype :ostype) (sendoptions (:pointer :smpsendoptions)) (mustaddcontent (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 10 16) 4711) window creator filetype sendoptions mustaddcontent))


(deftrap _smpendsend ((window (:pointer :grafport)) (oktosend :boolean))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 3 16) 4721) window oktosend))


(deftrap _smpopenletter ((letter :letterdescriptor) (window (:pointer :grafport)) (upperleft :point) (cancontract :boolean) (initiallyexpanded :boolean) (preparemailerfordrawingcb :pointer) (clientdata :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 12 16) 4712) letter window upperleft cancontract initiallyexpanded preparemailerfordrawingcb clientdata))


(deftrap _smpaddmainenclosure ((window (:pointer :grafport)) (enclosure :fsspec))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 4733) window enclosure))


(deftrap _smpgetmainenclosurefsspec ((window (:pointer :grafport)) (enclosuredir (:pointer :fsspec)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 4734) window enclosuredir))


(deftrap _smpaddcontent ((window (:pointer :grafport)) (segmenttype :signed-integer) (appendflag :boolean) (buffer :pointer) (buffersize :signed-long) (textscrap :stscrpptr) (startnewscript :boolean) (script :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 12 16) 4730) window segmenttype appendflag buffer buffersize textscrap startnewscript script))


(deftrap _smpreadcontent ((window (:pointer :grafport)) (segmenttypemask :signed-integer) (buffer :pointer) (buffersize :signed-long) (datasize (:pointer :signed-long)) (textscrap (:pointer :stscrprec)) (script (:pointer :signed-integer)) (segmenttype (:pointer :signed-integer)) (endofscript (:pointer :boolean)) (endofsegment (:pointer :boolean)) (endofcontent (:pointer :boolean)) (segmentlength (:pointer :signed-long)) (segmentid (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 25 16) 4731) window segmenttypemask buffer buffersize datasize textscrap script segmenttype endofscript endofsegment endofcontent segmentlength segmentid))


(deftrap _smpgetfontnamefromletter ((window (:pointer :grafport)) (fontnum :signed-integer) (fontname (:string 255)) (donewithfonttable :boolean))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 6 16) 4732) window fontnum fontname donewithfonttable))


(deftrap _smpaddblock ((window (:pointer :grafport)) (blocktype :ocecreatortype) (append :boolean) (buffer :pointer) (buffersize :signed-long) (mode :signed-integer) (offset :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 12 16) 4735) window blocktype append buffer buffersize mode offset))


(deftrap _smpreadblock ((window (:pointer :grafport)) (blocktype :ocecreatortype) (blockindex :signed-integer) (buffer :pointer) (buffersize :signed-long) (dataoffset :signed-long) (datasize (:pointer :signed-long)) (endofblock (:pointer :boolean)) (remaining (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 17 16) 4736) window blocktype blockindex buffer buffersize dataoffset datasize endofblock remaining))


(deftrap _smpenumerateblocks ((window (:pointer :grafport)) (startindex :signed-integer) (buffer :pointer) (buffersize :signed-long) (datasize (:pointer :signed-long)) (nextindex (:pointer :signed-integer)) (more (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 13 16) 4737) window startindex buffer buffersize datasize nextindex more))


(deftrap _smpdrawmailer ((window (:pointer :grafport)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 2 16) 4713) window))


(deftrap _smpsetsubject ((window (:pointer :grafport)) (text :rstring))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 4715) window text))


(deftrap _smpsetfromidentity ((window (:pointer :grafport)) (from :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 4716) window from))


(deftrap _smpaddaddress ((window (:pointer :grafport)) (addrtype :signed-integer) (address (:pointer :ocepackedrecipient)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 5 16) 4717) window addrtype address))


(deftrap _smpaddattachment ((window (:pointer :grafport)) (attachment :fsspec))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 4718) window attachment))


(deftrap _smpattachdialog ((window (:pointer :grafport)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 2 16) 4726) window))


(deftrap _smpexpandorcontract ((window (:pointer :grafport)) (expand :boolean))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 3 16) 4722) window expand))


(deftrap _smpmovemailer ((window (:pointer :grafport)) (dh :signed-integer) (dv :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 4714) window dh dv))


(deftrap _smpbecometarget ((window (:pointer :grafport)) (becometarget :boolean) (whichfield :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 5 16) 4723) window becometarget whichfield))


(deftrap _smpgetcomponentsize ((window (:pointer :grafport)) (whichmailer :signed-integer) (whichfield :signed-long) (size (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 7 16) 4727) window whichmailer whichfield size))


(deftrap _smpgetcomponentinfo ((window (:pointer :grafport)) (whichmailer :signed-integer) (whichfield :signed-long) (buffer :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 7 16) 4728) window whichmailer whichfield buffer))


(deftrap _smpgetlistiteminfo ((window (:pointer :grafport)) (whichmailer :signed-integer) (whichfield :signed-long) (buffer :pointer) (bufferlength :signed-long) (startitem :signed-integer) (itemcount (:pointer :signed-integer)) (nextitem (:pointer :signed-integer)) (more (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 16 16) 4729) window whichmailer whichfield buffer bufferlength startitem itemcount nextitem more))


(deftrap _smpimage ((window (:pointer :grafport)) (drawimageproc :pointer) (imagerefcon :signed-long) (supportscolor :boolean))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 7 16) 4738) window drawimageproc imagerefcon supportscolor))


(deftrap _smpgetnextletter ((typeslist (:pointer :ostype)) (numtypes :signed-integer) (adjacentletter (:pointer :letterdescriptor)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 5 16) 4742) typeslist numtypes adjacentletter))


(deftrap _smpgetletterinfo ((mailboxspec (:pointer :letterspec)) (info (:pointer :smpletterinfo)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 4746) mailboxspec info))

; $ENDC                         ;  UsingOCEStandardMail 

; $IFC NOT UsingIncludes

; $ENDC

(export '($KSMPIMAGEERR $KSMPNEWPAGE $KSMPRESOLVETORECIPIENT $KSMPSENDLETTER
          $KSMPSENDOPTIONSDIALOG $KSMPTAGDIALOG $KSMPGETLETTERINFO
          $KSMPPREPARETOCHANGE $KSMPCLOSEOPTIONSDIALOG $KSMPPREPARETOCLOSE
          $KSMPGETNEXTLETTER $KSMPINITMAILER $KSMPIMAGE $KSMPENUMERATEBLOCKS
          $KSMPREADBLOCK $KSMPADDBLOCK $KSMPGETMAINENCLOSUREFSSPEC
          $KSMPADDMAINENCLOSURE $KSMPGETFONTNAMEFROMLETTER $KSMPREADCONTENT
          $KSMPADDCONTENT $KSMPGETLISTITEMINFO $KSMPGETCOMPONENTINFO
          $KSMPGETCOMPONENTSIZE $KSMPATTACHDIALOG $KSMPCLEARUNDO
          $KSMPGETTABINFO $KSMPBECOMETARGET $KSMPEXPANDORCONTRACT $KSMPENDSEND
          $KSMPENDSAVE $KSMPCONTENTCHANGED $KSMPADDATTACHMENT $KSMPADDADDRESS
          $KSMPSETFROMIDENTITY $KSMPSETSUBJECT $KSMPMOVEMAILER $KSMPDRAWMAILER
          $KSMPOPENLETTER $KSMPBEGINSEND $KSMPBEGINSAVE $KSMPDRAWNTHCOVERPAGE
          $KSMPPREPARECOVERPAGES $KSMPGETMAILERSTATE $KSMPMAILERREPLY
          $KSMPMAILERFORWARD $KSMPMAILEREDITCOMMAND $KSMPMAILEREVENT
          $KSMPDISPOSEMAILER $KSMPNEWMAILER $KSMPGETDIMENSIONS $KSMPSAVEACOPY
          $KSMPSAVEAS $KSMPSAVE $KSMPSENDOPTIONSEND $KSMPSENDOPTIONSSTART
          $KSMPSTANDARDINTERCHANGEMASK $KSMPIMAGEMASK $KSMPNATIVEMASK
          $KSMPSTANDARDINTERCHANGEBIT $KSMPIMAGEBIT $KSMPNATIVEBIT
          $KSMPMAILERUNDO $KSMPAPPMAYUNDO $KSMPUNDODISABLED
          $KSMPSELECTALLCOMMAND $KSMPCLEARCOMMAND $KSMPPASTECOMMAND
          $KSMPCOPYCOMMAND $KSMPCUTCOMMAND $KSMPUNDOCOMMAND $KSMPBCCADDRESS
          $KSMPCCADDRESS $KSMPTOADDRESS $KSMPADDRESSOMATIC $KSMPATTACHMENTS
          $KSMPSENDDATETIME $KSMPREGARDING $KSMPTO $KSMPFROM $KSMPOTHER
          $KSMPDISPOSECOPYWINDOWMASK $KSMPCREATECOPYWINDOWMASK
          $KSMPCURSOROVERMAILERMASK $KSMPAPPBECOMESTARGETMASK
          $KSMPMAILERBECOMESTARGETMASK $KSMPEXPANDEDMASK $KSMPCONTRACTEDMASK
          $KSMPAPPSHOULDIGNOREEVENTMASK $KSMPAPPMUSTHANDLEEVENTMASK
          $KSMPDISPOSECOPYWINDOWBIT $KSMPCREATECOPYWINDOWBIT
          $KSMPCURSOROVERMAILERBIT $KSMPAPPBECOMESTARGETBIT
          $KSMPMAILERBECOMESTARGETBIT $KSMPEXPANDEDBIT $KSMPCONTRACTEDBIT
          $KSMPAPPSHOULDIGNOREEVENTBIT $KSMPAPPMUSTHANDLEEVENTBIT
          $KSMPSENDASIMAGEMASK $KSMPSENDFILEONLYMASK $KSMPSENDASENCLOSUREMASK
          $KSMPSENDASIMAGEBIT $KSMPSENDFILEONLYBIT $KSMPSENDASENCLOSUREBIT
          $FILTERIMAGECONTENT $FILTERAPPLELETTERCONTENT $FILTERANYLETTER
          $TYPELETTERSPEC $KSMPVERSION $KSMPNATIVEFORMATNAME
          $GESTALTSMPSPSENDLETTERVERSION $GESTALTSMPMAILERVERSION))
(provide-interface 'OCEStandardMail)