
(in-package :TRAPS)
; 
; Created: Tuesday, October 13, 1992 at 12:36 PM
;  Movies.p
;  Pascal Interface to the Macintosh Libraries
; 
;   Copyright Apple Computer, Inc. 1991,1992
;   All rights reserved
; 
; 

; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED UsingMovies
; $SETC UsingMovies := 1

; $I+
; $SETC MoviesIncludes := UsingIncludes
; $SETC UsingIncludes := 1
; $IFC UNDEFINED UsingQuickDraw

(require-interface 'QUICKDRAW)  ; $I $$Shell(PInterfaces)QuickDraw.p
; $ENDC
; $IFC UNDEFINED UsingAliases

(require-interface 'ALIASES)    ; $I $$Shell(PInterfaces)Aliases.p
; $ENDC
; $IFC UNDEFINED UsingEvents

(require-interface 'EVENTS)     ; $I $$Shell(PInterfaces)Events.p
; $ENDC
; $IFC UNDEFINED UsingMenus

(require-interface 'MENUS)      ; $I $$Shell(PInterfaces)Menus.p
; $ENDC
; $IFC UNDEFINED UsingComponents

(require-interface 'COMPONENTS) ; $I $$Shell(PInterfaces)Components.p
; $ENDC
; $IFC UNDEFINED UsingImageCompression

(require-interface 'IMAGECOMPRESSION); $I $$Shell(PInterfaces)ImageCompression.p
; $ENDC

; $SETC UsingIncludes := MoviesIncludes

(defconstant $kFix1 #X10000)

(defconstant $gestaltQuickTime :|qtim|)

(defconstant $MovieFileType :|MooV|)

(defconstant $MediaHandlerType :|mhlr|)
(defconstant $DataHandlerType :|dhlr|)

(defconstant $VideoMediaType :|vide|)
(defconstant $SoundMediaType :|soun|)
(defconstant $TextMediaType :|text|)
(defconstant $GenericMediaType :|gnrc|)

(defconstant $DoTheRightThing 0)

(defconstant $kFullVolume #X100);  8.8 format 
(defconstant $kNoVolume 0)

(def-mactype :MOVIE (find-mactype :POINTER))
(defrecord MovieRecord 
   (data (:ARRAY :SIGNED-LONG 1))
   )

(def-mactype :TRACK (find-mactype :POINTER))
(defrecord TrackRecord 
   (data (:ARRAY :SIGNED-LONG 1))
   )

(def-mactype :MEDIA (find-mactype :POINTER))
(defrecord MediaRecord 
   (data (:ARRAY :SIGNED-LONG 1))
   )

(def-mactype :USERDATA (find-mactype :POINTER))
(defrecord UserDataRecord 
   (data (:ARRAY :SIGNED-LONG 1))
   )

(def-mactype :TRACKEDITSTATE (find-mactype :POINTER))
(defrecord TrackEditStateRecord 
   (data (:ARRAY :SIGNED-LONG 1))
   )

(def-mactype :MOVIEEDITSTATE (find-mactype :POINTER))
(defrecord MovieEditStateRecord 
   (data (:ARRAY :SIGNED-LONG 1))
   )

(def-mactype :SAMPLEDESCRIPTIONPTR (find-mactype :POINTER))
(def-mactype :SAMPLEDESCRIPTIONHANDLE (find-mactype :HANDLE))
(defrecord (SampleDescription :handle) 
   (descSize :SIGNED-LONG)
   (dataFormat :SIGNED-LONG)
   (resvd1 :SIGNED-LONG)
   (resvd2 :SIGNED-INTEGER)
   (dataRefIndex :SIGNED-INTEGER)
   )

(def-mactype :SOUNDDESCRIPTIONPTR (find-mactype :POINTER))
(def-mactype :SOUNDDESCRIPTIONHANDLE (find-mactype :HANDLE))
(defrecord (SoundDescription :handle) 
   (descSize :SIGNED-LONG)      ;  total size of SoundDescription including extra data 
   (dataFormat :SIGNED-LONG)
   (resvd1 :SIGNED-LONG)        ;  reserved for apple use 
   (resvd2 :SIGNED-INTEGER)
   (dataRefIndex :SIGNED-INTEGER)
   (version :SIGNED-INTEGER)    ;  which version is this data 
   (revlevel :SIGNED-INTEGER)   ;  what version of that codec did this 
   (vendor :SIGNED-LONG)        ;  whose  codec compressed this data 
   (numChannels :SIGNED-INTEGER);  number of channels of sound 
   (sampleSize :SIGNED-INTEGER) ;  number of bits per sample 
   (compressionID :SIGNED-INTEGER);  sound compression used, 0 if none 
   (packetSize :SIGNED-INTEGER) ;  packet size for compression, 0 if no compression 
   (sampleRate :SIGNED-LONG)    ;  sample rate sound is captured at 
   )

(def-mactype :TEXTDESCRIPTIONPTR (find-mactype :POINTER))
(def-mactype :TEXTDESCRIPTIONHANDLE (find-mactype :HANDLE))
(defrecord (TextDescription :handle) 
   (descSize :SIGNED-LONG)
   (dataFormat :SIGNED-LONG)

   (resvd1 :SIGNED-LONG)
   (resvd2 :SIGNED-INTEGER)
   (dataRefIndex :SIGNED-INTEGER)

   (displayFlags :SIGNED-LONG)
   (textJustification :SIGNED-LONG)

   (bgColor :RGBCOLOR)

   (defaultTextBox :RECT)
   (defaultStyle :SCRPSTELEMENT)
   )

(defconstant $dfDontDisplay 1)  ;  Don't display the text
(defconstant $dfDontAutoScale 2);  Don't scale text as track bounds grows or shrinks
(defconstant $dfClipToTextBox 4);  Clip update to the textbox
(defconstant $dfUseMovieBGColor 8);  Set text background to movie's background color
(defconstant $dfShrinkTextBoxToFit 16);  Compute minimum box to fit the sample
(defconstant $dfScrollIn 32)    ;  Scroll text in until last of text is in view 
(defconstant $dfScrollOut 64)   ;  Scroll text out until last of text is gone (if both set, scroll in then out)
(defconstant $dfHorizScroll 128);  Scroll text horizontally (otherwise it's vertical)
(defconstant $dfReverseScroll 256);  vert: scroll down rather than up; horiz: scroll backwards (justfication dependent)

;  progress messages 
(defconstant $movieProgressOpen 0)
(defconstant $movieProgressUpdatePercent 1)
(defconstant $movieProgressClose 2)

;  progress operations 
(defconstant $progressOpFlatten 1)
(defconstant $progressOpInsertTrackSegment 2)
(defconstant $progressOpInsertMovieSegment 3)
(defconstant $progressOpPaste 4)
(defconstant $progressOpAddMovieSelection 5)
(defconstant $progressOpCopy 6)
(defconstant $progressOpCut 7)
(defconstant $progressOpLoadMovieIntoRam 8)
(defconstant $progressOpLoadTrackIntoRam 9)
(defconstant $progressOpLoadMediaIntoRam 10)
(defconstant $progressOpImportMovie 11)
(defconstant $progressOpExportMovie 12)

;  media quality settings 
(defconstant $mediaQualityDraft #X0)
(defconstant $mediaQualityNormal #X40)
(defconstant $mediaQualityBetter #X80)
(defconstant $mediaQualityBest #XC0)

(def-mactype :MOVIERGNCOVERPROC (find-mactype :POINTER))
(def-mactype :MOVIEPROGRESSPROCPTR (find-mactype :POINTER))

(def-mactype :MEDIAHANDLER (find-mactype :POINTER))
(def-mactype :MEDIAHANDLERCOMPONENT (find-mactype :POINTER))
(def-mactype :DATAHANDLER (find-mactype :POINTER))
(def-mactype :DATAHANDLERCOMPONENT (find-mactype :POINTER))
(def-mactype :HANDLERERROR (find-mactype :SIGNED-LONG))

(def-mactype :TIMEVALUE (find-mactype :SIGNED-LONG))
(def-mactype :TIMESCALE (find-mactype :SIGNED-LONG))

(defrecord Int64 
   (hi :SIGNED-LONG)
   (lo :SIGNED-LONG)
   )

(%define-record :COMPTIMEVALUE (find-record-descriptor :INT64))

(defconstant $loopTimeBase 1)
(defconstant $palindromeLoopTimeBase 2)

;  TimeBase Routines 
(def-mactype :TIMEBASEFLAGS (find-mactype :SIGNED-LONG))

(def-mactype :TIMEBASE (find-mactype :POINTER))
(defrecord TimeBaseRecord 
   (data (:ARRAY :SIGNED-LONG 1))
   )

(def-mactype :QTCALLBACK (find-mactype :POINTER))
(defrecord CallBackRecord 
   (data (:ARRAY :SIGNED-LONG 1))
   )

(defrecord TimeRecord 
   (value :INT64)
   (scale :SIGNED-LONG)
   (base (:POINTER :TIMEBASERECORD))
   )

(defconstant $triggerTimeFwd #X1);  when curTime exceeds triggerTime going forward 
(defconstant $triggerTimeBwd #X2);  when curTime exceeds triggerTime going backwards 
(defconstant $triggerTimeEither #X3);  when curTime exceeds triggerTime going either direction 
(defconstant $triggerRateLT #X4);  when rate changes to less than trigger value 
(defconstant $triggerRateGT #X8);  when rate changes to greater than trigger value 
(defconstant $triggerRateEqual #X10);  when rate changes to equal trigger value 
(defconstant $triggerRateLTE #X14)
(defconstant $triggerRateGTE #X18)
(defconstant $triggerRateNotEqual #X1C)
(defconstant $triggerRateChange 0)
(defconstant $triggerAtStart #X1)
(defconstant $triggerAtStop #X2)

(def-mactype :QTCALLBACKFLAGS (find-mactype :UNSIGNED-BYTE))

(defconstant $timeBaseBeforeStartTime 1)
(defconstant $timeBaseAfterStopTime 2)

(def-mactype :TIMEBASESTATUS (find-mactype :SIGNED-LONG))

(defconstant $callBackAtTime 1)
(defconstant $callBackAtRate 2)
(defconstant $callBackAtTimeJump 3)
(defconstant $callBackAtExtremes 4)
(defconstant $callBackAtInterrupt #X8000)

(def-mactype :QTCALLBACKTYPE (find-mactype :UNSIGNED-BYTE))
(def-mactype :QTCALLBACKPROC (find-mactype :POINTER))

(defconstant $qtcbNeedsRateChanges 1)
(defconstant $qtcbNeedsTimeChanges 2)
(defconstant $qtcbNeedsStartStopChanges 4)

;  CallBack equates 
(defrecord QTCallBackHeader 
   (callBackFlags :SIGNED-LONG)
   (reserved1 :SIGNED-LONG)
   (qtPrivate (:ARRAY :UNSIGNED-BYTE 40))
   )

;  loadintoram flags 
(defconstant $keepInRam 1)
(defconstant $unkeepInRam 2)
(defconstant $flushFromRam 4)
(defconstant $loadForwardTrackEdits 8)
(defconstant $loadBackwardTrackEdits 16)

(def-mactype :MOVIEPREVIEWCALLOUTPROC (find-mactype :POINTER))
(def-mactype :MOVIECONTROLLER (find-mactype :POINTER))

(defconstant $newMovieActive #X1)
(defconstant $newMovieDontResolveDataRefs #X2)
(defconstant $newMovieDontAskUnresolvedDataRefs #X4)
(defconstant $newMovieDontAutoAlternates #X8)

(defconstant $trackUsageInMovie #X2)
(defconstant $trackUsageInPreview #X4)
(defconstant $trackUsageInPoster #X8)

(defconstant $mediaSampleNotSync 1)
(defconstant $mediaSampleShadowSync 2)

(defconstant $pasteInParallel 1)

(defconstant $nextTimeMediaSample #X1)
(defconstant $nextTimeMediaEdit #X2)
(defconstant $nextTimeTrackEdit #X4)
(defconstant $nextTimeSyncSample #X8)
(defconstant $nextTimeEdgeOK #X2000)
(defconstant $nextTimeIgnoreActiveSegment #X4000)

(def-mactype :NEXTTIMEFLAGSENUM (find-mactype :UNSIGNED-BYTE))

(defconstant $createMovieFileDeleteCurFile #X80000000)
(defconstant $createMovieFileDontCreateMovie #X40000000)
(defconstant $createMovieFileDontOpenFile #X20000000)

(def-mactype :CREATEMOVIEFILEFLAGSENUM (find-mactype :SIGNED-LONG))

(defconstant $flattenAddMovieToDataFork #X1)
(defconstant $flattenActiveTracksOnly #X4)
(defconstant $flattenDontInterleaveFlatten #X8)

(def-mactype :MOVIEFLATTENFLAGSENUM (find-mactype :SIGNED-LONG))

(defconstant $movieInDataForkResID -1);  magic res id 

(defconstant $movieScrapDontZeroScrap #X1)
(defconstant $movieScrapOnlyPutMovie #X2)

(defconstant $hintsScrubMode #X1)
(defconstant $hintsUseScreenBuffer #X20)
(defconstant $hintsAllowInterlace #X40)
(defconstant $hintsUseSoundLerp #X80)

(def-mactype :PLAYHINTSENUM (find-mactype :SIGNED-LONG))

(defconstant $mediaHandlerFlagGenericClient 1)

(def-mactype :MEDIAHANDLERFLAGSENUM (find-mactype :SIGNED-LONG))

;   Initialization Routines  

(deftrap _ENTERMOVIES NIL
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 1))

(deftrap _EXITMOVIES NIL
   NIL
   (:STACK-TRAP #xAAAA :D0 2))

;   error Routines  

(def-mactype :ERRORPROCPTR (find-mactype :POINTER))


(deftrap _GETMOVIESERROR NIL
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 3))

(deftrap _CLEARMOVIESSTICKYERROR NIL
   NIL
   (:STACK-TRAP #xAAAA :D0 222))

(deftrap _GETMOVIESSTICKYERROR NIL
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 4))

(deftrap _SETMOVIESERRORPROC ((ERRPROC :POINTER) (REFCON :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 239 ERRPROC REFCON))

;   Idle Routines  

(deftrap _MOVIESTASK ((M (:POINTER :MOVIERECORD)) (MAXMILLISECTOUSE :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 5 M MAXMILLISECTOUSE))

(deftrap _PREROLLMOVIE ((M (:POINTER :MOVIERECORD)) (TIME :SIGNED-LONG) (RATE :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 6 M TIME RATE))

(deftrap _LOADMOVIEINTORAM ((M (:POINTER :MOVIERECORD)) (TIME :SIGNED-LONG) (DURATION :SIGNED-LONG) (FLAGS :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 7 M TIME DURATION FLAGS))

(deftrap _LOADTRACKINTORAM ((Track (:POINTER :TRACKRECORD)) (TIME :SIGNED-LONG) (DURATION :SIGNED-LONG) (FLAGS :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 366 Track TIME DURATION FLAGS))

(deftrap _LOADMEDIAINTORAM ((M (:POINTER :MEDIARECORD)) (TIME :SIGNED-LONG) (DURATION :SIGNED-LONG) (FLAGS :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 8 M TIME DURATION FLAGS))


(deftrap _SETMOVIEACTIVE ((M (:POINTER :MOVIERECORD)) (ACTIVE :BOOLEAN))
   NIL
   (:STACK-TRAP #xAAAA :D0 9 M ACTIVE))

(deftrap _GETMOVIEACTIVE ((M (:POINTER :MOVIERECORD)))
   (:STACK :BOOLEAN)
   (:STACK-TRAP #xAAAA :D0 10 M))

;  Calls for playing movies 

(deftrap _STARTMOVIE ((M (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 11 M))

(deftrap _STOPMOVIE ((M (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 12 M))

(deftrap _GOTOBEGINNINGOFMOVIE ((M (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 13 M))

(deftrap _GOTOENDOFMOVIE ((M (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 14 M))

(deftrap _ISMOVIEDONE ((M (:POINTER :MOVIERECORD)))
   (:STACK :BOOLEAN)
   (:STACK-TRAP #xAAAA :D0 221 M))


(deftrap _GETMOVIEPREVIEWMODE ((M (:POINTER :MOVIERECORD)))
   (:STACK :BOOLEAN)
   (:STACK-TRAP #xAAAA :D0 15 M))

(deftrap _SETMOVIEPREVIEWMODE ((M (:POINTER :MOVIERECORD)) (USEPREVIEW :BOOLEAN))
   NIL
   (:STACK-TRAP #xAAAA :D0 16 M USEPREVIEW))

(deftrap _SHOWMOVIEPOSTER ((M (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 17 M))

(deftrap _PLAYMOVIEPREVIEW ((M (:POINTER :MOVIERECORD)) (CALLOUTPROC :POINTER) (REFCON :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 242 M CALLOUTPROC REFCON))

;  calls for controlling movies & tracks which are playing 
;   movie TimeBase Routines  

(deftrap _GETMOVIETIMEBASE ((M (:POINTER :MOVIERECORD)))
   (:STACK (:POINTER :TIMEBASERECORD))
   (:STACK-TRAP #xAAAA :D0 18 M))


(deftrap _SETMOVIEMASTERTIMEBASE ((M (:POINTER :MOVIERECORD)) (TB (:POINTER :TIMEBASERECORD)) (SLAVEZERO :TIMERECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 359 M TB SLAVEZERO))

(deftrap _SETMOVIEMASTERCLOCK ((M (:POINTER :MOVIERECORD)) (CLOCKMEISTER (:POINTER :PRIVATECOMPONENTRECORD)) (SLAVEZERO :TIMERECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 360 M CLOCKMEISTER SLAVEZERO))


(deftrap _GETMOVIEGWORLD ((M (:POINTER :MOVIERECORD)) (PORT (:POINTER (:POINTER :CGRAFPORT))) (GDH (:POINTER (:HANDLE :GDEVICE))))
   NIL
   (:STACK-TRAP #xAAAA :D0 21 M PORT GDH))

(deftrap _SETMOVIEGWORLD ((M (:POINTER :MOVIERECORD)) (PORT (:POINTER :CGRAFPORT)) (GDH (:HANDLE :GDEVICE)))
   NIL
   (:STACK-TRAP #xAAAA :D0 22 M PORT GDH))

;   Movie PICT Routines  

(deftrap _GETMOVIEPICT ((M (:POINTER :MOVIERECORD)) (TIME :SIGNED-LONG))
   (:STACK (:HANDLE :PICTURE))
   (:STACK-TRAP #xAAAA :D0 29 M TIME))

(deftrap _GETTRACKPICT ((Track (:POINTER :TRACKRECORD)) (TIME :SIGNED-LONG))
   (:STACK (:HANDLE :PICTURE))
   (:STACK-TRAP #xAAAA :D0 30 Track TIME))


(deftrap _GETMOVIEPOSTERPICT ((M (:POINTER :MOVIERECORD)))
   (:STACK (:HANDLE :PICTURE))
   (:STACK-TRAP #xAAAA :D0 247 M))


(deftrap _UPDATEMOVIE ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 31 M))

;   spatial movie Routines  

(deftrap _GETMOVIEBOX ((M (:POINTER :MOVIERECORD)) (BOXRECT (:POINTER :RECT)))
   NIL
   (:STACK-TRAP #xAAAA :D0 249 M BOXRECT))

(deftrap _SETMOVIEBOX ((M (:POINTER :MOVIERECORD)) (BOXRECT :RECT))
   NIL
   (:STACK-TRAP #xAAAA :D0 250 M BOXRECT))

;   movie display clip  

(deftrap _GETMOVIEDISPLAYCLIPRGN ((M (:POINTER :MOVIERECORD)))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xAAAA :D0 252 M))

(deftrap _SETMOVIEDISPLAYCLIPRGN ((M (:POINTER :MOVIERECORD)) (THECLIP (:HANDLE :REGION)))
   NIL
   (:STACK-TRAP #xAAAA :D0 253 M THECLIP))

;   movie clip  

(deftrap _GETMOVIECLIPRGN ((M (:POINTER :MOVIERECORD)))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xAAAA :D0 256 M))

(deftrap _SETMOVIECLIPRGN ((M (:POINTER :MOVIERECORD)) (THECLIP (:HANDLE :REGION)))
   NIL
   (:STACK-TRAP #xAAAA :D0 257 M THECLIP))

;   track clip  

(deftrap _GETTRACKCLIPRGN ((Track (:POINTER :TRACKRECORD)))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xAAAA :D0 258 Track))

(deftrap _SETTRACKCLIPRGN ((Track (:POINTER :TRACKRECORD)) (THECLIP (:HANDLE :REGION)))
   NIL
   (:STACK-TRAP #xAAAA :D0 259 Track THECLIP))

;   bounds in display space  

(deftrap _GETMOVIEDISPLAYBOUNDSRGN ((M (:POINTER :MOVIERECORD)))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xAAAA :D0 251 M))

(deftrap _GETTRACKDISPLAYBOUNDSRGN ((Track (:POINTER :TRACKRECORD)))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xAAAA :D0 274 Track))

;   bounds in movie space  

(deftrap _GETMOVIEBOUNDSRGN ((M (:POINTER :MOVIERECORD)))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xAAAA :D0 254 M))

(deftrap _GETTRACKMOVIEBOUNDSRGN ((Track (:POINTER :TRACKRECORD)))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xAAAA :D0 255 Track))

;   bounds in track space  

(deftrap _GETTRACKBOUNDSRGN ((Track (:POINTER :TRACKRECORD)))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xAAAA :D0 273 Track))

;   mattes - always in track space  

(deftrap _GETTRACKMATTE ((Track (:POINTER :TRACKRECORD)))
   (:STACK (:HANDLE :PIXMAP))
   (:STACK-TRAP #xAAAA :D0 277 Track))

(deftrap _SETTRACKMATTE ((Track (:POINTER :TRACKRECORD)) (THEMATTE (:HANDLE :PIXMAP)))
   NIL
   (:STACK-TRAP #xAAAA :D0 278 Track THEMATTE))

(deftrap _DISPOSEMATTE ((THEMATTE (:HANDLE :PIXMAP)))
   NIL
   (:STACK-TRAP #xAAAA :D0 330 THEMATTE))


(deftrap _NEWMOVIE ((NEWMOVIEFLAGS :SIGNED-LONG))
   (:STACK (:POINTER :MOVIERECORD))
   (:STACK-TRAP #xAAAA :D0 391 NEWMOVIEFLAGS))

(deftrap _PUTMOVIEINTOHANDLE ((M (:POINTER :MOVIERECORD)) (H :HANDLE))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 34 M H))

(deftrap _PUTMOVIEINTODATAFORK ((M (:POINTER :MOVIERECORD)) (FREFNUM :SIGNED-INTEGER) (OFFSET :SIGNED-LONG) (MAXSIZE :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 436 M FREFNUM OFFSET MAXSIZE))

(deftrap _DISPOSEMOVIE ((M (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 35 M))

;   Movie Routines  

(deftrap _GETMOVIECREATIONTIME ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 38 M))

(deftrap _GETMOVIEMODIFICATIONTIME ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 39 M))


(deftrap _GETMOVIETIMESCALE ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 41 M))

(deftrap _SETMOVIETIMESCALE ((M (:POINTER :MOVIERECORD)) (TIMESCALE :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 42 M TIMESCALE))


(deftrap _GETMOVIEDURATION ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 43 M))


(deftrap _GETMOVIERATE ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 44 M))

(deftrap _SETMOVIERATE ((M (:POINTER :MOVIERECORD)) (RATE :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 45 M RATE))


(deftrap _GETMOVIEPREFERREDRATE ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 243 M))

(deftrap _SETMOVIEPREFERREDRATE ((M (:POINTER :MOVIERECORD)) (RATE :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 244 M RATE))


(deftrap _GETMOVIEPREFERREDVOLUME ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 245 M))

(deftrap _SETMOVIEPREFERREDVOLUME ((M (:POINTER :MOVIERECORD)) (VOLUME :SIGNED-INTEGER))
   NIL
   (:STACK-TRAP #xAAAA :D0 246 M VOLUME))


(deftrap _GETMOVIEVOLUME ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 46 M))

(deftrap _SETMOVIEVOLUME ((M (:POINTER :MOVIERECORD)) (VOLUME :SIGNED-INTEGER))
   NIL
   (:STACK-TRAP #xAAAA :D0 47 M VOLUME))


(deftrap _GETMOVIEMATRIX ((M (:POINTER :MOVIERECORD)) (MATRIX (:POINTER :MATRIXRECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 49 M MATRIX))

(deftrap _SETMOVIEMATRIX ((M (:POINTER :MOVIERECORD)) (MATRIX :MATRIXRECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 50 M MATRIX))


(deftrap _GETMOVIEPREVIEWTIME ((M (:POINTER :MOVIERECORD)) (PREVIEWTIME (:POINTER :SIGNED-LONG)) (PREVIEWDURATION (:POINTER :SIGNED-LONG)))
   NIL
   (:STACK-TRAP #xAAAA :D0 51 M PREVIEWTIME PREVIEWDURATION))

(deftrap _SETMOVIEPREVIEWTIME ((M (:POINTER :MOVIERECORD)) (PREVIEWTIME :SIGNED-LONG) (PREVIEWDURATION :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 52 M PREVIEWTIME PREVIEWDURATION))


(deftrap _GETMOVIEPOSTERTIME ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 53 M))

(deftrap _SETMOVIEPOSTERTIME ((M (:POINTER :MOVIERECORD)) (POSTERTIME :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 54 M POSTERTIME))


(deftrap _GETMOVIESELECTION ((M (:POINTER :MOVIERECORD)) (SELECTIONTIME (:POINTER :SIGNED-LONG)) (SELECTIONDURATION (:POINTER :SIGNED-LONG)))
   NIL
   (:STACK-TRAP #xAAAA :D0 55 M SELECTIONTIME SELECTIONDURATION))

(deftrap _SETMOVIESELECTION ((M (:POINTER :MOVIERECORD)) (SELECTIONTIME :SIGNED-LONG) (SELECTIONDURATION :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 56 M SELECTIONTIME SELECTIONDURATION))


(deftrap _SETMOVIEACTIVESEGMENT ((M (:POINTER :MOVIERECORD)) (STARTTIME :SIGNED-LONG) (DURATION :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 348 M STARTTIME DURATION))

(deftrap _GETMOVIEACTIVESEGMENT ((M (:POINTER :MOVIERECORD)) (STARTTIME (:POINTER :SIGNED-LONG)) (DURATION (:POINTER :SIGNED-LONG)))
   NIL
   (:STACK-TRAP #xAAAA :D0 349 M STARTTIME DURATION))


(deftrap _GETMOVIETIME ((M (:POINTER :MOVIERECORD)) (CURRENTTIME (:POINTER :TIMERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 57 M CURRENTTIME))

(deftrap _SETMOVIETIME ((M (:POINTER :MOVIERECORD)) (NEWTIME :TIMERECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 60 M NEWTIME))

(deftrap _SETMOVIETIMEVALUE ((M (:POINTER :MOVIERECORD)) (NEWTIME :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 61 M NEWTIME))

(deftrap _GETMOVIEUSERDATA ((M (:POINTER :MOVIERECORD)))
   (:STACK (:POINTER :USERDATARECORD))
   (:STACK-TRAP #xAAAA :D0 62 M))

;   Movie/Track/Media finding Routines  

(deftrap _GETMOVIETRACKCOUNT ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 63 M))

(deftrap _GETMOVIETRACK ((M (:POINTER :MOVIERECORD)) (TRACKID :SIGNED-LONG))
   (:STACK (:POINTER :TRACKRECORD))
   (:STACK-TRAP #xAAAA :D0 64 M TRACKID))


(deftrap _GETMOVIEINDTRACK ((M (:POINTER :MOVIERECORD)) (INDEX :SIGNED-LONG))
   (:STACK (:POINTER :TRACKRECORD))
   (:STACK-TRAP #xAAAA :D0 279 M INDEX))


(deftrap _GETTRACKID ((Track (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 295 Track))


(deftrap _GETTRACKMOVIE ((Track (:POINTER :TRACKRECORD)))
   (:STACK (:POINTER :MOVIERECORD))
   (:STACK-TRAP #xAAAA :D0 208 Track))

;   Track creation Routines  

(deftrap _NEWMOVIETRACK ((M (:POINTER :MOVIERECORD)) (WIDTH :SIGNED-LONG) (HEIGHT :SIGNED-LONG) (TRACKVOLUME :SIGNED-INTEGER))
   (:STACK (:POINTER :TRACKRECORD))
   (:STACK-TRAP #xAAAA :D0 392 M WIDTH HEIGHT TRACKVOLUME))

(deftrap _DISPOSEMOVIETRACK ((Track (:POINTER :TRACKRECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 66 Track))

;   Track Routines  

(deftrap _GETTRACKCREATIONTIME ((Track (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 67 Track))

(deftrap _GETTRACKMODIFICATIONTIME ((Track (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 68 Track))


(deftrap _GETTRACKENABLED ((Track (:POINTER :TRACKRECORD)))
   (:STACK :BOOLEAN)
   (:STACK-TRAP #xAAAA :D0 69 Track))

(deftrap _SETTRACKENABLED ((Track (:POINTER :TRACKRECORD)) (ISENABLED :BOOLEAN))
   NIL
   (:STACK-TRAP #xAAAA :D0 70 Track ISENABLED))


(deftrap _GETTRACKUSAGE ((Track (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 71 Track))

(deftrap _SETTRACKUSAGE ((Track (:POINTER :TRACKRECORD)) (USAGE :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 72 Track USAGE))


(deftrap _GETTRACKDURATION ((Track (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 75 Track))


(deftrap _GETTRACKOFFSET ((Track (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 76 Track))

(deftrap _SETTRACKOFFSET ((Track (:POINTER :TRACKRECORD)) (OFFSET :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 77 Track OFFSET))


(deftrap _GETTRACKLAYER ((Track (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 80 Track))

(deftrap _SETTRACKLAYER ((Track (:POINTER :TRACKRECORD)) (LAYER :SIGNED-INTEGER))
   NIL
   (:STACK-TRAP #xAAAA :D0 81 Track LAYER))


(deftrap _GETTRACKALTERNATE ((Track (:POINTER :TRACKRECORD)))
   (:STACK (:POINTER :TRACKRECORD))
   (:STACK-TRAP #xAAAA :D0 82 Track))

(deftrap _SETTRACKALTERNATE ((Track (:POINTER :TRACKRECORD)) (ALTERNATET (:POINTER :TRACKRECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 83 Track ALTERNATET))


(deftrap _SETAUTOTRACKALTERNATESENABLED ((M (:POINTER :MOVIERECORD)) (ENABLE :BOOLEAN))
   NIL
   (:STACK-TRAP #xAAAA :D0 350 M ENABLE))

(deftrap _SELECTMOVIEALTERNATES ((M (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 351 M))


(deftrap _GETTRACKVOLUME ((Track (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 84 Track))

(deftrap _SETTRACKVOLUME ((Track (:POINTER :TRACKRECORD)) (VOLUME :SIGNED-INTEGER))
   NIL
   (:STACK-TRAP #xAAAA :D0 85 Track VOLUME))


(deftrap _GETTRACKMATRIX ((Track (:POINTER :TRACKRECORD)) (MATRIX (:POINTER :MATRIXRECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 86 Track MATRIX))

(deftrap _SETTRACKMATRIX ((Track (:POINTER :TRACKRECORD)) (MATRIX :MATRIXRECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 87 Track MATRIX))


(deftrap _GETTRACKDIMENSIONS ((Track (:POINTER :TRACKRECORD)) (WIDTH (:POINTER :SIGNED-LONG)) (HEIGHT (:POINTER :SIGNED-LONG)))
   NIL
   (:STACK-TRAP #xAAAA :D0 93 Track WIDTH HEIGHT))

(deftrap _SETTRACKDIMENSIONS ((Track (:POINTER :TRACKRECORD)) (WIDTH :SIGNED-LONG) (HEIGHT :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 94 Track WIDTH HEIGHT))


(deftrap _GETTRACKUSERDATA ((Track (:POINTER :TRACKRECORD)))
   (:STACK (:POINTER :USERDATARECORD))
   (:STACK-TRAP #xAAAA :D0 95 Track))

;   Media creation Routines  

(deftrap _NEWTRACKMEDIA ((Track (:POINTER :TRACKRECORD)) (MEDIATYPE :OSTYPE) (TIMESCALE :SIGNED-LONG) (DATAREF :HANDLE) (DATAREFTYPE :OSTYPE))
   (:STACK (:POINTER :MEDIARECORD))
   (:STACK-TRAP #xAAAA :D0 398 Track MEDIATYPE TIMESCALE DATAREF DATAREFTYPE))

(deftrap _DISPOSETRACKMEDIA ((M (:POINTER :MEDIARECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 97 M))

(deftrap _GETTRACKMEDIA ((Track (:POINTER :TRACKRECORD)))
   (:STACK (:POINTER :MEDIARECORD))
   (:STACK-TRAP #xAAAA :D0 98 Track))

(deftrap _GETMEDIATRACK ((M (:POINTER :MEDIARECORD)))
   (:STACK (:POINTER :TRACKRECORD))
   (:STACK-TRAP #xAAAA :D0 197 M))

;   Media Routines  

(deftrap _GETMEDIACREATIONTIME ((M (:POINTER :MEDIARECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 102 M))

(deftrap _GETMEDIAMODIFICATIONTIME ((M (:POINTER :MEDIARECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 103 M))


(deftrap _GETMEDIATIMESCALE ((M (:POINTER :MEDIARECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 104 M))

(deftrap _SETMEDIATIMESCALE ((M (:POINTER :MEDIARECORD)) (TIMESCALE :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 105 M TIMESCALE))


(deftrap _GETMEDIADURATION ((M (:POINTER :MEDIARECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 106 M))


(deftrap _GETMEDIALANGUAGE ((M (:POINTER :MEDIARECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 107 M))

(deftrap _SETMEDIALANGUAGE ((M (:POINTER :MEDIARECORD)) (LANGUAGE :SIGNED-INTEGER))
   NIL
   (:STACK-TRAP #xAAAA :D0 108 M LANGUAGE))


(deftrap _GETMEDIAQUALITY ((M (:POINTER :MEDIARECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 109 M))

(deftrap _SETMEDIAQUALITY ((M (:POINTER :MEDIARECORD)) (QUALITY :SIGNED-INTEGER))
   NIL
   (:STACK-TRAP #xAAAA :D0 110 M QUALITY))

(deftrap _GETMEDIAHANDLERDESCRIPTION ((M (:POINTER :MEDIARECORD)) (MEDIATYPE (:POINTER :OSTYPE)) (CREATORNAME (:POINTER (:STRING 255))) (CREATORMANUFACTURER (:POINTER :OSTYPE)))
   NIL
   (:STACK-TRAP #xAAAA :D0 111 M MEDIATYPE CREATORNAME CREATORMANUFACTURER))


(deftrap _GETMEDIAUSERDATA ((M (:POINTER :MEDIARECORD)))
   (:STACK (:POINTER :USERDATARECORD))
   (:STACK-TRAP #xAAAA :D0 112 M))

;   Media Handler Routines  

(deftrap _GETMEDIAHANDLER ((M (:POINTER :MEDIARECORD)))
   (:STACK (:POINTER :PRIVATECOMPONENTINSTANCERECORD))
   (:STACK-TRAP #xAAAA :D0 113 M))

(deftrap _SETMEDIAHANDLER ((M (:POINTER :MEDIARECORD)) (MH (:POINTER :PRIVATECOMPONENTRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 400 M MH))

;  Media's Data Routines 

(deftrap _BEGINMEDIAEDITS ((M (:POINTER :MEDIARECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 114 M))

(deftrap _ENDMEDIAEDITS ((M (:POINTER :MEDIARECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 115 M))

(deftrap _GETMEDIADATAHANDLERDESCRIPTION ((M (:POINTER :MEDIARECORD)) (INDEX :SIGNED-INTEGER) (DHTYPE (:POINTER :OSTYPE)) (CREATORNAME (:POINTER (:STRING 255))) (CREATORMANUFACTURER (:POINTER :OSTYPE)))
   NIL
   (:STACK-TRAP #xAAAA :D0 414 M INDEX DHTYPE CREATORNAME CREATORMANUFACTURER))
;   Media data handler Routines  

(deftrap _GETMEDIADATAHANDLER ((M (:POINTER :MEDIARECORD)) (INDEX :SIGNED-INTEGER))
   (:STACK (:POINTER :PRIVATECOMPONENTINSTANCERECORD))
   (:STACK-TRAP #xAAAA :D0 415 M INDEX))

(deftrap _SETMEDIADATAHANDLER ((M (:POINTER :MEDIARECORD)) (INDEX :SIGNED-INTEGER) (DATAHANDLER (:POINTER :PRIVATECOMPONENTRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 416 M INDEX DATAHANDLER))

;   Media sample Routines  

(deftrap _GETMEDIASAMPLEDESCRIPTIONCOUNT ((M (:POINTER :MEDIARECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 119 M))

(deftrap _GETMEDIASAMPLEDESCRIPTION ((M (:POINTER :MEDIARECORD)) (INDEX :SIGNED-LONG) (DESCH (:HANDLE :SAMPLEDESCRIPTION)))
   NIL
   (:STACK-TRAP #xAAAA :D0 120 M INDEX DESCH))

(deftrap _GETMEDIASAMPLECOUNT ((M (:POINTER :MEDIARECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 121 M))

(deftrap _SAMPLENUMTOMEDIATIME ((M (:POINTER :MEDIARECORD)) (LOGICALSAMPLENUM :SIGNED-LONG) (SAMPLETIME (:POINTER :SIGNED-LONG)) (SAMPLEDURATION (:POINTER :SIGNED-LONG)))
   NIL
   (:STACK-TRAP #xAAAA :D0 122 M LOGICALSAMPLENUM SAMPLETIME SAMPLEDURATION))

(deftrap _MEDIATIMETOSAMPLENUM ((M (:POINTER :MEDIARECORD)) (TIME :SIGNED-LONG) (SAMPLENUM (:POINTER :SIGNED-LONG)) (SAMPLETIME (:POINTER :SIGNED-LONG)) (SAMPLEDURATION (:POINTER :SIGNED-LONG)))
   NIL
   (:STACK-TRAP #xAAAA :D0 123 M TIME SAMPLENUM SAMPLETIME SAMPLEDURATION))

(deftrap _ADDMEDIASAMPLE ((M (:POINTER :MEDIARECORD)) (DATAIN :HANDLE) (INOFFSET :SIGNED-LONG) (SIZE :SIGNED-LONG) (DURATIONPERSAMPLE :SIGNED-LONG) (SAMPLEDESCRIPTIONH (:HANDLE :SAMPLEDESCRIPTION)) (NUMBEROFSAMPLES :SIGNED-LONG) (SAMPLEFLAGS :SIGNED-INTEGER) (SAMPLETIME (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 124 M DATAIN INOFFSET SIZE DURATIONPERSAMPLE SAMPLEDESCRIPTIONH NUMBEROFSAMPLES SAMPLEFLAGS SAMPLETIME))

(deftrap _ADDMEDIASAMPLEREFERENCE ((M (:POINTER :MEDIARECORD)) (DATAOFFSET :SIGNED-LONG) (SIZE :SIGNED-LONG) (DURATIONPERSAMPLE :SIGNED-LONG) (SAMPLEDESCRIPTIONH (:HANDLE :SAMPLEDESCRIPTION)) (NUMBEROFSAMPLES :SIGNED-LONG) (SAMPLEFLAGS :SIGNED-INTEGER) (SAMPLETIME (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 125 M DATAOFFSET SIZE DURATIONPERSAMPLE SAMPLEDESCRIPTIONH NUMBEROFSAMPLES SAMPLEFLAGS SAMPLETIME))

(deftrap _GETMEDIASAMPLE ((M (:POINTER :MEDIARECORD)) (DATAOUT :HANDLE) (MAXSIZETOGROW :SIGNED-LONG) (SIZE (:POINTER :SIGNED-LONG)) (TIME :SIGNED-LONG) (SAMPLETIME (:POINTER :SIGNED-LONG)) (DURATIONPERSAMPLE (:POINTER :SIGNED-LONG)) (SAMPLEDESCRIPTIONH (:HANDLE :SAMPLEDESCRIPTION)) (SAMPLEDESCRIPTIONINDEX (:POINTER :SIGNED-LONG)) (MAXNUMBEROFSAMPLES :SIGNED-LONG) (NUMBEROFSAMPLES (:POINTER :SIGNED-LONG)) (SAMPLEFLAGS (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 126 M DATAOUT MAXSIZETOGROW SIZE TIME SAMPLETIME DURATIONPERSAMPLE SAMPLEDESCRIPTIONH SAMPLEDESCRIPTIONINDEX MAXNUMBEROFSAMPLES NUMBEROFSAMPLES SAMPLEFLAGS))

(deftrap _GETMEDIASAMPLEREFERENCE ((M (:POINTER :MEDIARECORD)) (DATAOFFSET (:POINTER :SIGNED-LONG)) (SIZE (:POINTER :SIGNED-LONG)) (TIME :SIGNED-LONG) (SAMPLETIME (:POINTER :SIGNED-LONG)) (DURATIONPERSAMPLE (:POINTER :SIGNED-LONG)) (SAMPLEDESCRIPTIONH (:HANDLE :SAMPLEDESCRIPTION)) (SAMPLEDESCRIPTIONINDEX (:POINTER :SIGNED-LONG)) (MAXNUMBEROFSAMPLES :SIGNED-LONG) (NUMBEROFSAMPLES (:POINTER :SIGNED-LONG)) (SAMPLEFLAGS (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 127 M DATAOFFSET SIZE TIME SAMPLETIME DURATIONPERSAMPLE SAMPLEDESCRIPTIONH SAMPLEDESCRIPTIONINDEX MAXNUMBEROFSAMPLES NUMBEROFSAMPLES SAMPLEFLAGS))


(deftrap _SETMEDIASHADOWSYNC ((M (:POINTER :MEDIARECORD)) (FRAMEDIFFSAMPLENUM :SIGNED-LONG) (SYNCSAMPLENUM :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 289 M FRAMEDIFFSAMPLENUM SYNCSAMPLENUM))

(deftrap _GETMEDIASHADOWSYNC ((M (:POINTER :MEDIARECORD)) (FRAMEDIFFSAMPLENUM :SIGNED-LONG) (SYNCSAMPLENUM (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 290 M FRAMEDIFFSAMPLENUM SYNCSAMPLENUM))

;   low-level Editing Routines  

(deftrap _INSERTMEDIAINTOTRACK ((Track (:POINTER :TRACKRECORD)) (TRACKSTART :SIGNED-LONG) (MEDIATIME :SIGNED-LONG) (MEDIADURATION :SIGNED-LONG) (MEDIARATE :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 387 Track TRACKSTART MEDIATIME MEDIADURATION MEDIARATE))

;   Middle-level Editing Routines  

(deftrap _INSERTTRACKSEGMENT ((SRCTRACK (:POINTER :TRACKRECORD)) (DSTTRACK (:POINTER :TRACKRECORD)) (SRCIN :SIGNED-LONG) (SRCDURATION :SIGNED-LONG) (DSTIN :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 133 SRCTRACK DSTTRACK SRCIN SRCDURATION DSTIN))

(deftrap _INSERTMOVIESEGMENT ((SRCMOVIE (:POINTER :MOVIERECORD)) (DSTMOVIE (:POINTER :MOVIERECORD)) (SRCIN :SIGNED-LONG) (SRCDURATION :SIGNED-LONG) (DSTIN :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 134 SRCMOVIE DSTMOVIE SRCIN SRCDURATION DSTIN))

(deftrap _INSERTEMPTYTRACKSEGMENT ((DSTTRACK (:POINTER :TRACKRECORD)) (DSTIN :SIGNED-LONG) (DSTDURATION :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 135 DSTTRACK DSTIN DSTDURATION))

(deftrap _INSERTEMPTYMOVIESEGMENT ((DSTMOVIE (:POINTER :MOVIERECORD)) (DSTIN :SIGNED-LONG) (DSTDURATION :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 136 DSTMOVIE DSTIN DSTDURATION))

(deftrap _DELETETRACKSEGMENT ((Track (:POINTER :TRACKRECORD)) (DSTIN :SIGNED-LONG) (DURATION :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 137 Track DSTIN DURATION))

(deftrap _DELETEMOVIESEGMENT ((M (:POINTER :MOVIERECORD)) (DSTIN :SIGNED-LONG) (DURATION :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 138 M DSTIN DURATION))

(deftrap _SCALETRACKSEGMENT ((Track (:POINTER :TRACKRECORD)) (DSTIN :SIGNED-LONG) (OLDDURATION :SIGNED-LONG) (NEWDURATION :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 139 Track DSTIN OLDDURATION NEWDURATION))

(deftrap _SCALEMOVIESEGMENT ((M (:POINTER :MOVIERECORD)) (DSTIN :SIGNED-LONG) (OLDDURATION :SIGNED-LONG) (NEWDURATION :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 140 M DSTIN OLDDURATION NEWDURATION))

;   High level editing Routines  

(deftrap _CUTMOVIESELECTION ((M (:POINTER :MOVIERECORD)))
   (:STACK (:POINTER :MOVIERECORD))
   (:STACK-TRAP #xAAAA :D0 141 M))

(deftrap _COPYMOVIESELECTION ((M (:POINTER :MOVIERECORD)))
   (:STACK (:POINTER :MOVIERECORD))
   (:STACK-TRAP #xAAAA :D0 142 M))

(deftrap _PASTEMOVIESELECTION ((M (:POINTER :MOVIERECORD)) (SRC (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 143 M SRC))

(deftrap _ADDMOVIESELECTION ((M (:POINTER :MOVIERECORD)) (SRC (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 338 M SRC))

(deftrap _CLEARMOVIESELECTION ((M (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 225 M))

(deftrap _PASTEHANDLEINTOMOVIE ((H :HANDLE) (HANDLETYPE :OSTYPE) (M (:POINTER :MOVIERECORD)) (FLAGS :SIGNED-LONG) (USERCOMP (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 203 H HANDLETYPE M FLAGS USERCOMP))

(deftrap _PUTMOVIEINTOTYPEDHANDLE ((M (:POINTER :MOVIERECORD)) (TARGETTRACK (:POINTER :TRACKRECORD)) (HANDLETYPE :OSTYPE) (PUBLICMOVIE :HANDLE) (START :SIGNED-LONG) (DUR :SIGNED-LONG) (FLAGS :SIGNED-LONG) (USERCOMP (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 461 M TARGETTRACK HANDLETYPE PUBLICMOVIE START DUR FLAGS USERCOMP))

(deftrap _ISSCRAPMOVIE ((TARGETTRACK (:POINTER :TRACKRECORD)))
   (:STACK (:POINTER :PRIVATECOMPONENTRECORD))
   (:STACK-TRAP #xAAAA :D0 204 TARGETTRACK))


(deftrap _COPYTRACKSETTINGS ((SRCTRACK (:POINTER :TRACKRECORD)) (DSTTRACK (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 339 SRCTRACK DSTTRACK))

(deftrap _COPYMOVIESETTINGS ((SRCMOVIE (:POINTER :MOVIERECORD)) (DSTMOVIE (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 340 SRCMOVIE DSTMOVIE))

;   movie & track edit state Routines  

(deftrap _NEWMOVIEEDITSTATE ((M (:POINTER :MOVIERECORD)))
   (:STACK (:POINTER :MOVIEEDITSTATERECORD))
   (:STACK-TRAP #xAAAA :D0 260 M))

(deftrap _USEMOVIEEDITSTATE ((M (:POINTER :MOVIERECORD)) (TOSTATE (:POINTER :MOVIEEDITSTATERECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 261 M TOSTATE))

(deftrap _DISPOSEMOVIEEDITSTATE ((STATE (:POINTER :MOVIEEDITSTATERECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 262 STATE))


(deftrap _NEWTRACKEDITSTATE ((Track (:POINTER :TRACKRECORD)))
   (:STACK (:POINTER :TRACKEDITSTATERECORD))
   (:STACK-TRAP #xAAAA :D0 263 Track))

(deftrap _USETRACKEDITSTATE ((Track (:POINTER :TRACKRECORD)) (STATE (:POINTER :TRACKEDITSTATERECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 264 Track STATE))

(deftrap _DISPOSETRACKEDITSTATE ((STATE (:POINTER :TRACKEDITSTATERECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 265 STATE))


(deftrap _CONVERTFILETOMOVIEFILE ((INPUTFILE :FSSPEC) (OUTPUTFILE :FSSPEC) (CREATOR :OSTYPE) (SCRIPTTAG :SIGNED-INTEGER) (RESID (:POINTER :SIGNED-INTEGER)) (FLAGS :SIGNED-LONG) (USERCOMP (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (PROC :POINTER) (REFCON :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 459 INPUTFILE OUTPUTFILE CREATOR SCRIPTTAG RESID FLAGS USERCOMP PROC REFCON))

(deftrap _CONVERTMOVIETOFILE ((THEMOVIE (:POINTER :MOVIERECORD)) (ONLYTRACK (:POINTER :TRACKRECORD)) (OUTPUTFILE :FSSPEC) (FILETYPE :OSTYPE) (CREATOR :OSTYPE) (SCRIPTTAG :SIGNED-INTEGER) (RESID (:POINTER :SIGNED-INTEGER)) (FLAGS :SIGNED-LONG) (USERCOMP (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 460 THEMOVIE ONLYTRACK OUTPUTFILE FILETYPE CREATOR SCRIPTTAG RESID FLAGS USERCOMP))

;   Miscellaneous Routines  

(deftrap _TRACKTIMETOMEDIATIME ((VALUE :SIGNED-LONG) (Track (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 150 VALUE Track))

(deftrap _GETTRACKEDITRATE ((Track (:POINTER :TRACKRECORD)) (ATTIME :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 291 Track ATTIME))


(deftrap _GETMOVIEDATASIZE ((M (:POINTER :MOVIERECORD)) (STARTTIME :SIGNED-LONG) (DURATION :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 152 M STARTTIME DURATION))

(deftrap _GETTRACKDATASIZE ((Track (:POINTER :TRACKRECORD)) (STARTTIME :SIGNED-LONG) (DURATION :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 329 Track STARTTIME DURATION))

(deftrap _GETMEDIADATASIZE ((M (:POINTER :MEDIARECORD)) (STARTTIME :SIGNED-LONG) (DURATION :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 153 M STARTTIME DURATION))


(deftrap _PTINMOVIE ((M (:POINTER :MOVIERECORD)) (PT :POINT))
   (:STACK :BOOLEAN)
   (:STACK-TRAP #xAAAA :D0 154 M PT))

(deftrap _PTINTRACK ((Track (:POINTER :TRACKRECORD)) (PT :POINT))
   (:STACK :BOOLEAN)
   (:STACK-TRAP #xAAAA :D0 155 Track PT))

;   Alternate Group Selection Routines  

(deftrap _SETMOVIELANGUAGE ((M (:POINTER :MOVIERECORD)) (LANGUAGE :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 156 M LANGUAGE))

;   UserData Routines  

(deftrap _GETUSERDATA ((U (:POINTER :USERDATARECORD)) (DATA :HANDLE) (UDTYPE :OSTYPE) (INDEX :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 158 U DATA UDTYPE INDEX))

(deftrap _ADDUSERDATA ((U (:POINTER :USERDATARECORD)) (DATA :HANDLE) (UDTYPE :OSTYPE))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 159 U DATA UDTYPE))

(deftrap _REMOVEUSERDATA ((U (:POINTER :USERDATARECORD)) (UDTYPE :OSTYPE) (INDEX :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 160 U UDTYPE INDEX))

(deftrap _COUNTUSERDATATYPE ((USERDATAH (:POINTER :USERDATARECORD)) (UDTYPE :OSTYPE))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 331 USERDATAH UDTYPE))
;  New UserData routines 

(deftrap _GETNEXTUSERDATATYPE ((USERDATAH (:POINTER :USERDATARECORD)) (UDTYPE :OSTYPE))
   (:STACK :OSTYPE)
   (:STACK-TRAP #xAAAA :D0 421 USERDATAH UDTYPE))

(deftrap _GETUSERDATAITEM ((USERDATAH (:POINTER :USERDATARECORD)) (DATA :POINTER) (SIZE :SIGNED-LONG) (DATATYPE :OSTYPE) (INDEX :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 294 USERDATAH DATA SIZE DATATYPE INDEX))

(deftrap _SETUSERDATAITEM ((USERDATAH (:POINTER :USERDATARECORD)) (DATA :POINTER) (SIZE :SIGNED-LONG) (DATATYPE :OSTYPE) (INDEX :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 302 USERDATAH DATA SIZE DATATYPE INDEX))


(deftrap _ADDUSERDATATEXT ((U (:POINTER :USERDATARECORD)) (DATA :HANDLE) (UDTYPE :OSTYPE) (INDEX :SIGNED-LONG) (ITLREGIONTAG :SIGNED-INTEGER))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 332 U DATA UDTYPE INDEX ITLREGIONTAG))

(deftrap _GETUSERDATATEXT ((U (:POINTER :USERDATARECORD)) (DATA :HANDLE) (UDTYPE :OSTYPE) (INDEX :SIGNED-LONG) (ITLREGIONTAG :SIGNED-INTEGER))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 333 U DATA UDTYPE INDEX ITLREGIONTAG))

(deftrap _REMOVEUSERDATATEXT ((U (:POINTER :USERDATARECORD)) (UDTYPE :OSTYPE) (INDEX :SIGNED-LONG) (ITLREGIONTAG :SIGNED-INTEGER))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 334 U UDTYPE INDEX ITLREGIONTAG))


(deftrap _NEWUSERDATA ((UD (:POINTER (:POINTER :USERDATARECORD))))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 303 UD))

(deftrap _DISPOSEUSERDATA ((UD (:POINTER :USERDATARECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 304 UD))

(deftrap _NEWUSERDATAFROMHANDLE ((H :HANDLE) (UD (:POINTER (:POINTER :USERDATARECORD))))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 305 H UD))

(deftrap _PUTUSERDATAINTOHANDLE ((UD (:POINTER :USERDATARECORD)) (H :HANDLE))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 306 UD H))

;   interesting time Routines  

(deftrap _GETMEDIANEXTINTERESTINGTIME ((M (:POINTER :MEDIARECORD)) (INTERESTINGTIMEFLAGS :SIGNED-INTEGER) (TIME :SIGNED-LONG) (RATE :SIGNED-LONG) (INTERESTINGTIME (:POINTER :SIGNED-LONG)) (INTERESTINGDURATION (:POINTER :SIGNED-LONG)))
   NIL
   (:STACK-TRAP #xAAAA :D0 365 M INTERESTINGTIMEFLAGS TIME RATE INTERESTINGTIME INTERESTINGDURATION))

(deftrap _GETTRACKNEXTINTERESTINGTIME ((Track (:POINTER :TRACKRECORD)) (INTERESTINGTIMEFLAGS :SIGNED-INTEGER) (TIME :SIGNED-LONG) (RATE :SIGNED-LONG) (INTERESTINGTIME (:POINTER :SIGNED-LONG)) (INTERESTINGDURATION (:POINTER :SIGNED-LONG)))
   NIL
   (:STACK-TRAP #xAAAA :D0 226 Track INTERESTINGTIMEFLAGS TIME RATE INTERESTINGTIME INTERESTINGDURATION))

(deftrap _GETMOVIENEXTINTERESTINGTIME ((M (:POINTER :MOVIERECORD)) (INTERESTINGTIMEFLAGS :SIGNED-INTEGER) (NUMMEDIATYPES :SIGNED-INTEGER) (WHICHMEDIATYPES :POINTER) (TIME :SIGNED-LONG) (RATE :SIGNED-LONG) (INTERESTINGTIME (:POINTER :SIGNED-LONG)) (INTERESTINGDURATION (:POINTER :SIGNED-LONG)))
   NIL
   (:STACK-TRAP #xAAAA :D0 270 M INTERESTINGTIMEFLAGS NUMMEDIATYPES WHICHMEDIATYPES TIME RATE INTERESTINGTIME INTERESTINGDURATION))

;   movie file Routines  

(deftrap _CREATEMOVIEFILE ((FILESPEC :FSSPEC) (CREATOR :OSTYPE) (SCRIPTTAG :SIGNED-INTEGER) (CREATEMOVIEFILEFLAGS :SIGNED-LONG) (RESREFNUM (:POINTER :SIGNED-INTEGER)) (NEWMOVIE (:POINTER (:POINTER :MOVIERECORD))))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 401 FILESPEC CREATOR SCRIPTTAG CREATEMOVIEFILEFLAGS RESREFNUM NEWMOVIE))


(deftrap _OPENMOVIEFILE ((FILESPEC :FSSPEC) (RESREFNUM (:POINTER :SIGNED-INTEGER)) (PERMS :SIGNED-BYTE))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 402 FILESPEC RESREFNUM PERMS))

(deftrap _CLOSEMOVIEFILE ((RESREFNUM :SIGNED-INTEGER))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 213 RESREFNUM))


(deftrap _DELETEMOVIEFILE ((FILESPEC :FSSPEC))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 373 FILESPEC))


(deftrap _NEWMOVIEFROMFILE ((M (:POINTER (:POINTER :MOVIERECORD))) (RESREFNUM :SIGNED-INTEGER) (RESID (:POINTER :SIGNED-INTEGER)) (RESNAME (:STRING 255)) (NEWMOVIEFLAGS :SIGNED-INTEGER) (DATAREFWASCHANGED (:POINTER :BOOLEAN)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 240 M RESREFNUM RESID RESNAME NEWMOVIEFLAGS DATAREFWASCHANGED))
;   movie creation Routines  

(deftrap _NEWMOVIEFROMHANDLE ((M (:POINTER (:POINTER :MOVIERECORD))) (H :HANDLE) (NEWMOVIEFLAGS :SIGNED-INTEGER) (DATAREFWASCHANGED (:POINTER :BOOLEAN)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 241 M H NEWMOVIEFLAGS DATAREFWASCHANGED))

(deftrap _NEWMOVIEFROMDATAFORK ((M (:POINTER (:POINTER :MOVIERECORD))) (FREFNUM :SIGNED-INTEGER) (FILEOFFSET :SIGNED-LONG) (FLAGS :SIGNED-INTEGER) (DATAREFWASCHANGED (:POINTER :BOOLEAN)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 272 M FREFNUM FILEOFFSET FLAGS DATAREFWASCHANGED))


(deftrap _ADDMOVIERESOURCE ((M (:POINTER :MOVIERECORD)) (RESREFNUM :SIGNED-INTEGER) (RESID (:POINTER :SIGNED-INTEGER)) (RESNAME (:STRING 255)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 215 M RESREFNUM RESID RESNAME))

(deftrap _REMOVEMOVIERESOURCE ((RESREFNUM :SIGNED-INTEGER) (RESID :SIGNED-INTEGER))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 374 RESREFNUM RESID))

(deftrap _UPDATEMOVIERESOURCE ((M (:POINTER :MOVIERECORD)) (RESREFNUM :SIGNED-INTEGER) (RESID :SIGNED-INTEGER) (RESNAME (:STRING 255)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 216 M RESREFNUM RESID RESNAME))


(deftrap _HASMOVIECHANGED ((M (:POINTER :MOVIERECORD)))
   (:STACK :BOOLEAN)
   (:STACK-TRAP #xAAAA :D0 217 M))

(deftrap _CLEARMOVIECHANGED ((M (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 275 M))


(deftrap _SETMOVIEDEFAULTDATAREF ((THEMOVIE (:POINTER :MOVIERECORD)) (DATAREF :HANDLE) (DATAREFTYPE :OSTYPE))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 449 THEMOVIE DATAREF DATAREFTYPE))

(deftrap _GETMOVIEDEFAULTDATAREF ((THEMOVIE (:POINTER :MOVIERECORD)) (DATAREF (:POINTER :HANDLE)) (DATAREFTYPE (:POINTER :OSTYPE)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 466 THEMOVIE DATAREF DATAREFTYPE))


(deftrap _FLATTENMOVIE ((M (:POINTER :MOVIERECORD)) (MOVIEFLATTENFLAGS :SIGNED-LONG) (THEFILE :FSSPEC) (CREATOR :OSTYPE) (SCRIPTTAG :SIGNED-INTEGER) (CREATEMOVIEFILEFLAGS :SIGNED-LONG) (RESID (:POINTER :SIGNED-INTEGER)) (RESNAME (:STRING 255)))
   NIL
   (:STACK-TRAP #xAAAA :D0 411 M MOVIEFLATTENFLAGS THEFILE CREATOR SCRIPTTAG CREATEMOVIEFILEFLAGS RESID RESNAME))

(deftrap _FLATTENMOVIEDATA ((M (:POINTER :MOVIERECORD)) (MOVIEFLATTENFLAGS :SIGNED-LONG) (THEFILE :FSSPEC) (CREATOR :OSTYPE) (SCRIPTTAG :SIGNED-INTEGER) (CREATEMOVIEFILEFLAGS :SIGNED-LONG))
   (:STACK (:POINTER :MOVIERECORD))
   (:STACK-TRAP #xAAAA :D0 412 M MOVIEFLATTENFLAGS THEFILE CREATOR SCRIPTTAG CREATEMOVIEFILEFLAGS))

(deftrap _SETMOVIEPROGRESSPROC ((M (:POINTER :MOVIERECORD)) (P :POINTER) (REFCON :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 410 M P REFCON))

;   Video Media Routines  

(deftrap _GETVIDEOMEDIAGRAPHICSMODE ((MH (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (GRAPHICSMODE (:POINTER :SIGNED-LONG)) (OPCOLOR (:POINTER :RGBCOLOR)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MH GRAPHICSMODE OPCOLOR ((+ (ASH 8 16) 257) :SIGNED-LONGINT)))

(deftrap _SETVIDEOMEDIAGRAPHICSMODE ((MH (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (GRAPHICSMODE :SIGNED-LONG) (OPCOLOR :RGBCOLOR))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MH GRAPHICSMODE OPCOLOR ((+ (ASH 8 16) 258) :SIGNED-LONGINT)))

;   Sound Media Routines  

(deftrap _GETSOUNDMEDIABALANCE ((MH (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BALANCE (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MH BALANCE ((+ (ASH 4 16) 257) :SIGNED-LONGINT)))

(deftrap _SETSOUNDMEDIABALANCE ((MH (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BALANCE :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MH BALANCE ((+ (ASH 2 16) 258) :SIGNED-LONGINT)))

(defconstant $txtProcDefaultDisplay 0)
(defconstant $txtProcDontDisplay 1)
(defconstant $txtProcDoDisplay 2)

;   Text Media Routines  

(deftrap _SETTEXTPROC ((MH (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (TEXTPROC :POINTER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MH TEXTPROC ((+ (ASH 8 16) 257) :SIGNED-LONGINT)))

(deftrap _ADDTEXTSAMPLE ((MH (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (TEXT :POINTER) (SIZE :SIGNED-LONG) (FONTNUMBER :SIGNED-INTEGER) (FONTSIZE :SIGNED-INTEGER) (TEXTFACE :UNSIGNED-BYTE) (TEXTCOLOR :RGBCOLOR) (BACKCOLOR :RGBCOLOR) (TEXTJUSTIFICATION :SIGNED-LONG) (TEXTBOX :RECT) (DISPLAYFLAGS :SIGNED-LONG) (SHRINKTEXTBOXTOFIT :BOOLEAN) (SELSTART :SIGNED-LONG) (SELEND :SIGNED-LONG) (DURATION :SIGNED-LONG) (SAMPLETIME (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MH TEXT SIZE FONTNUMBER FONTSIZE TEXTFACE TEXTCOLOR BACKCOLOR TEXTJUSTIFICATION TEXTBOX DISPLAYFLAGS SHRINKTEXTBOXTOFIT SELSTART SELEND DURATION SAMPLETIME ((+ (ASH 52 16) 258) :SIGNED-LONGINT)))

(deftrap _ADDTESAMPLE ((MH (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (HTE (:HANDLE :TEREC)) (BACKCOLOR :RGBCOLOR) (TEXTJUSTIFICATION :SIGNED-LONG) (TEXTBOX :RECT) (DISPLAYFLAGS :SIGNED-LONG) (SHRINKTEXTBOXTOFIT :BOOLEAN) (SELSTART :SIGNED-LONG) (SELEND :SIGNED-LONG) (DURATION :SIGNED-LONG) (SAMPLETIME (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MH HTE BACKCOLOR TEXTJUSTIFICATION TEXTBOX DISPLAYFLAGS SHRINKTEXTBOXTOFIT SELSTART SELEND DURATION SAMPLETIME ((+ (ASH 38 16) 259) :SIGNED-LONGINT)))

(deftrap _ADDHILITESAMPLE ((MH (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SELSTART :SIGNED-LONG) (SELEND :SIGNED-LONG) (DURATION :SIGNED-LONG) (SAMPLETIME (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MH SELSTART SELEND DURATION SAMPLETIME ((+ (ASH 16 16) 260) :SIGNED-LONGINT)))

(defconstant $findTextEdgeOK 1) ;  Okay to find text at specified sample time 
(defconstant $findTextCaseSensitive 2);  Case sensitive search 
(defconstant $findTextReverseSearch 4);  Search from sampleTime backwards 
(defconstant $findTextWrapAround 8);  Wrap search when beginning or end of movie is hit 


(deftrap _FINDNEXTTEXT ((MH (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (TEXT :POINTER) (SIZE :SIGNED-LONG) (FINDFLAGS :SIGNED-INTEGER) (STARTTIME :SIGNED-LONG) (FOUNDTIME (:POINTER :SIGNED-LONG)) (FOUNDDURATION (:POINTER :SIGNED-LONG)) (OFFSET (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MH TEXT SIZE FINDFLAGS STARTTIME FOUNDTIME FOUNDDURATION OFFSET ((+ (ASH 26 16) 261) :SIGNED-LONGINT)))


(deftrap _HILITETEXTSAMPLE ((MH (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SAMPLETIME :SIGNED-LONG) (HILITESTART :SIGNED-INTEGER) (HILITEEND :SIGNED-INTEGER) (RGBHILITECOLOR (:POINTER :RGBCOLOR)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MH SAMPLETIME HILITESTART HILITEEND RGBHILITECOLOR ((+ (ASH 12 16) 262) :SIGNED-LONGINT)))

;   movie poster box  

(deftrap _GETPOSTERBOX ((M (:POINTER :MOVIERECORD)) (BOXRECT (:POINTER :RECT)))
   NIL
   (:STACK-TRAP #xAAAA :D0 367 M BOXRECT))

(deftrap _SETPOSTERBOX ((M (:POINTER :MOVIERECORD)) (BOXRECT :RECT))
   NIL
   (:STACK-TRAP #xAAAA :D0 368 M BOXRECT))

;   movie/track bounds over a range of time  

(deftrap _GETMOVIESEGMENTDISPLAYBOUNDSRGN ((M (:POINTER :MOVIERECORD)) (TIME :SIGNED-LONG) (DURATION :SIGNED-LONG))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xAAAA :D0 364 M TIME DURATION))

(deftrap _GETTRACKSEGMENTDISPLAYBOUNDSRGN ((Track (:POINTER :TRACKRECORD)) (TIME :SIGNED-LONG) (DURATION :SIGNED-LONG))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xAAAA :D0 363 Track TIME DURATION))


(deftrap _SETMOVIECOVERPROCS ((M (:POINTER :MOVIERECORD)) (UNCOVERPROC :POINTER) (COVERPROC :POINTER) (REFCON :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 377 M UNCOVERPROC COVERPROC REFCON))


(deftrap _GETTRACKSTATUS ((Track (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 370 Track))

(deftrap _GETMOVIESTATUS ((M (:POINTER :MOVIERECORD)) (FIRSTPROBLEMTRACK (:POINTER (:POINTER :TRACKRECORD))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 371 M FIRSTPROBLEMTRACK))

;   target management  

(deftrap _NEWMOVIECONTROLLER ((M (:POINTER :MOVIERECORD)) (MOVIERECT :RECT) (CONTROLLERCREATIONFLAGS :SIGNED-LONG))
   (:STACK (:POINTER :PRIVATECOMPONENTINSTANCERECORD))
   (:STACK-TRAP #xAAAA :D0 394 M MOVIERECT CONTROLLERCREATIONFLAGS))

(deftrap _DISPOSEMOVIECONTROLLER ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 395 MC))


(deftrap _PUTMOVIEONSCRAP ((M (:POINTER :MOVIERECORD)) (MOVIESCRAPFLAGS :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 396 M MOVIESCRAPFLAGS))

(deftrap _NEWMOVIEFROMSCRAP ((NEWMOVIEFLAGS :SIGNED-LONG))
   (:STACK (:POINTER :MOVIERECORD))
   (:STACK-TRAP #xAAAA :D0 397 NEWMOVIEFLAGS))

(defconstant $dataRefSelfReference 1)
(defconstant $dataRefWasNotResolved 2)

(def-mactype :DATAREFATTRIBUTESFLAGS (find-mactype :SIGNED-LONG))

;   Media dataRef Routines  

(deftrap _GETMEDIADATAREF ((M (:POINTER :MEDIARECORD)) (INDEX :SIGNED-INTEGER) (DATAREF (:POINTER :HANDLE)) (DATAREFTYPE (:POINTER :OSTYPE)) (DATAREFATTRIBUTES (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 407 M INDEX DATAREF DATAREFTYPE DATAREFATTRIBUTES))

(deftrap _ADDMEDIADATAREF ((M (:POINTER :MEDIARECORD)) (INDEX (:POINTER :SIGNED-INTEGER)) (DATAREF :HANDLE) (DATAREFTYPE :OSTYPE))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 408 M INDEX DATAREF DATAREFTYPE))

(deftrap _SETMEDIADATAREF ((M (:POINTER :MEDIARECORD)) (INDEX :SIGNED-INTEGER) (BLOB :HANDLE) (BLOBTYPE :OSTYPE))
   (:STACK :OSTYPE)
   (:STACK-TRAP #xAAAA :D0 457 M INDEX BLOB BLOBTYPE))

(deftrap _SETMEDIADATAREFATTRIBUTES ((M (:POINTER :MEDIARECORD)) (INDEX :SIGNED-INTEGER) (ATTRIBUTES :SIGNED-LONG))
   (:STACK :OSTYPE)
   (:STACK-TRAP #xAAAA :D0 458 M INDEX ATTRIBUTES))

(deftrap _GETMEDIADATAREFCOUNT ((M (:POINTER :MEDIARECORD)) (COUNT (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 409 M COUNT))


(deftrap _SETMEDIAPLAYHINTS ((MOVIE (:POINTER :MOVIERECORD)) (FLAGS :SIGNED-LONG) (FLAGSMASK :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 418 MOVIE FLAGS FLAGSMASK))

(deftrap _SETMOVIEPLAYHINTS ((MOVIE (:POINTER :MOVIERECORD)) (FLAGS :SIGNED-LONG) (FLAGSMASK :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 417 MOVIE FLAGS FLAGSMASK))

(defconstant $firstMoviesError -2000)
(defconstant $couldNotResolveDataRef -2000)
(defconstant $badImageDescription -2001)
(defconstant $badPublicMovieAtom -2002)
(defconstant $cantFindHandler -2003)
(defconstant $cantOpenHandler -2004)
(defconstant $badComponentType -2005)
(defconstant $noMediaHandler -2006)
(defconstant $noDataHandler -2007)
(defconstant $invalidMedia -2008)
(defconstant $invalidTrack -2009)
(defconstant $invalidMovie -2010)
(defconstant $invalidSampleTable -2011)
(defconstant $invalidDataRef -2012)
(defconstant $invalidHandler -2013)
(defconstant $invalidDuration -2014)
(defconstant $invalidTime -2015)
(defconstant $cantPutPublicMovieAtom -2016)
(defconstant $badEditList -2017)
(defconstant $mediaTypesDontMatch -2018)
(defconstant $progressProcAborted -2019)
(defconstant $movieToolboxUninitialized -2020)
(defconstant $wfFileNotFound -2021)
(defconstant $cantCreateSingleForkFile -2022)
(defconstant $invalidEditState -2023)
(defconstant $nonMatchingEditState -2024)
(defconstant $staleEditState -2025)
(defconstant $userDataItemNotFound -2026)
(defconstant $maxSizeToGrowTooSmall -2027)
(defconstant $badTrackIndex -2028)
(defconstant $trackIDNotFound -2029)
(defconstant $trackNotInMovie -2030)
(defconstant $timeNotInTrack -2031)
(defconstant $timeNotInMedia -2032)
(defconstant $badEditIndex -2033)
(defconstant $internalQuickTimeError -2034)
(defconstant $cantEnableTrack -2035)
(defconstant $invalidRect -2036)
(defconstant $invalidSampleNum -2037)
(defconstant $invalidChunkNum -2038)
(defconstant $invalidSampleDescIndex -2039)
(defconstant $invalidChunkCache -2040)
(defconstant $invalidSampleDescription -2041)

;  this should probably be in its own range for data handlers 
(defconstant $dataNotOpenForRead -2042)
(defconstant $dataNotOpenForWrite -2043)
(defconstant $dataAlreadyOpenForWrite -2044)
(defconstant $dataAlreadyClosed -2045)
(defconstant $endOfDataReached -2046)
(defconstant $dataNoDataRef -2047)

(defconstant $noMovieFound -2048)
(defconstant $invalidDataRefContainer -2049)
(defconstant $badDataRefIndex -2050)
(defconstant $noDefaultDataRef -2051)
(defconstant $couldNotUseAnExistingSample -2052)
(defconstant $featureUnsupported -2053)
(defconstant $unsupportedAuxiliaryImportData -2057)
(defconstant $lastMoviesError -2056)
(defconstant $noRecordOfApp #$MOVIETOOLBOXUNINITIALIZED); replica 

;  Movie Controller Routines 
(defconstant $MovieControllerComponentType :|play|)

(defconstant $mcTopLeftMovie #X1)
(defconstant $mcScaleMovieToFit #X2)
(defconstant $mcWithBadge #X4)
(defconstant $mcNotVisible #X8)
(defconstant $mcWithFrame #X10)

(defconstant $mcActionIdle 1)
(defconstant $mcActionDraw 2)
(defconstant $mcActionActivate 3)
(defconstant $mcActionDeactivate 4)
(defconstant $mcActionMouseDown 5)
(defconstant $mcActionKey 6)
(defconstant $mcActionPlay 8)
(defconstant $mcActionGoToTime 12)
(defconstant $mcActionSetVolume 14)
(defconstant $mcActionGetVolume 15)
(defconstant $mcActionStep 18)
(defconstant $mcActionSetLooping 21)
(defconstant $mcActionGetLooping 22)
(defconstant $mcActionSetLoopIsPalindrome 23)
(defconstant $mcActionGetLoopIsPalindrome 24)
(defconstant $mcActionSetGrowBoxBounds 25)
(defconstant $mcActionControllerSizeChanged 26)
(defconstant $mcActionSetSelectionBegin 29)
(defconstant $mcActionSetSelectionDuration 30)
(defconstant $mcActionSetPosterTime 31)
(defconstant $mcActionSetKeysEnabled 32)
(defconstant $mcActionGetKeysEnabled 33)
(defconstant $mcActionSetPlaySelection 34)
(defconstant $mcActionGetPlaySelection 35)
(defconstant $mcActionSetUseBadge 36)
(defconstant $mcActionGetUseBadge 37)
(defconstant $mcActionSetFlags 38)
(defconstant $mcActionGetFlags 39)
(defconstant $mcActionSetPlayEveryFrame 40)
(defconstant $mcActionGetPlayEveryFrame 41)
(defconstant $mcActionGetPlayRate 42)
(defconstant $mcActionShowBalloon 43)
(defconstant $mcActionBadgeClick 44)
(defconstant $mcActionMovieClick 45);  param is pointer to event record. change what to nullEvt to kill click 
(defconstant $mcActionSuspend 46);  no param 
(defconstant $mcActionResume 47);  no param 

(def-mactype :MCACTION (find-mactype :SIGNED-INTEGER))

(defconstant $mcFlagSuppressMovieFrame 1)
(defconstant $mcFlagSuppressStepButtons 2)
(defconstant $mcFlagSuppressSpeakerButton 4)
(defconstant $mcFlagsUseWindowPalette 8)

(defconstant $mcPositionDontInvalidate 32)

(def-mactype :MCFLAGS (find-mactype :SIGNED-LONG))
(def-mactype :MCACTIONFILTER (find-mactype :POINTER))
(def-mactype :MCACTIONFILTERWITHREFCON (find-mactype :POINTER))

(defconstant $mcInfoUndoAvailable #X1)
(defconstant $mcInfoCutAvailable #X2)
(defconstant $mcInfoCopyAvailable #X4)
(defconstant $mcInfoPasteAvailable #X8)
(defconstant $mcInfoClearAvailable #X10)
(defconstant $mcInfoHasSound #X20)
(defconstant $mcInfoIsPlaying #X40)
(defconstant $mcInfoIsLooping #X80)
(defconstant $mcInfoIsInPalindrome #X100)
(defconstant $mcInfoEditingEnabled #X200)

;  menu item codes 
(defconstant $mcMenuUndo 1)
(defconstant $mcMenuCut 3)
(defconstant $mcMenuCopy 4)
(defconstant $mcMenuPaste 5)
(defconstant $mcMenuClear 6)

;  movie controller error codes 
(defconstant $cannotMoveAttachedController -9999)
(defconstant $controllerHasFixedHeight -9998)
(defconstant $cannotSetWidthOfAttachedController -9997)
(defconstant $controllerBoundsNotExact -9996)
(defconstant $editingNotAllowed -9995)
(defconstant $badControllerHeight -9994)


(deftrap _MCSETMOVIE ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (M (:POINTER :MOVIERECORD)) (MOVIEWINDOW (:POINTER :GRAFPORT)) (WHERE :POINT))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC M MOVIEWINDOW WHERE ((+ (ASH 12 16) 2) :SIGNED-LONGINT)))

#| Not in ROM - INLINE =  #x4267 #x2F3C #x0002 #x0005 #x7000 #xA82A |#
; #x4267 = (clr.w -@sp) not recognized by translator
(deftrap _MCGETMOVIE ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK (:POINTER :MOVIERECORD))
   (:STACK-TRAP #xa82a :d0 0 mc (0 :signed-word) (#x020005 :signed-longint)))

(deftrap _MCREMOVEMOVIE ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 6) :SIGNED-LONGINT)))

;   event handling etc.  

(deftrap _MCISPLAYEREVENT ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (E :EVENTRECORD))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC E ((+ (ASH 4 16) 7) :SIGNED-LONGINT)))

(deftrap _MCSETACTIONFILTER ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (FILTER :POINTER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC FILTER ((+ (ASH 4 16) 8) :SIGNED-LONGINT)))

(deftrap _MCDOACTION ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (ACTION :SIGNED-INTEGER) (PARAMS :POINTER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC ACTION PARAMS ((+ (ASH 6 16) 9) :SIGNED-LONGINT)))

;   state type things  

(deftrap _MCSETCONTROLLERATTACHED ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (ATTACH :BOOLEAN))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC ATTACH ((+ (ASH 2 16) 10) :SIGNED-LONGINT)))

(deftrap _MCISCONTROLLERATTACHED ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 11) :SIGNED-LONGINT)))

(deftrap _MCSETCONTROLLERPORT ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (GP (:POINTER :CGRAFPORT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC GP ((+ (ASH 4 16) 12) :SIGNED-LONGINT)))

(deftrap _MCGETCONTROLLERPORT ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK (:POINTER :CGRAFPORT))
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 13) :SIGNED-LONGINT)))


(deftrap _MCSETVISIBLE ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SHOW :BOOLEAN))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC SHOW ((+ (ASH 2 16) 14) :SIGNED-LONGINT)))

(deftrap _MCGETVISIBLE ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 15) :SIGNED-LONGINT)))


(deftrap _MCGETCONTROLLERBOUNDSRECT ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BOUNDS (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC BOUNDS ((+ (ASH 4 16) 16) :SIGNED-LONGINT)))

(deftrap _MCSETCONTROLLERBOUNDSRECT ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BOUNDS :RECT))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC BOUNDS ((+ (ASH 4 16) 17) :SIGNED-LONGINT)))

(deftrap _MCGETCONTROLLERBOUNDSRGN ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 18) :SIGNED-LONGINT)))

(deftrap _MCGETWINDOWRGN ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (W (:POINTER :GRAFPORT)))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xA82A :D0 0 MC W ((+ (ASH 4 16) 19) :SIGNED-LONGINT)))

;   other stuff  

(deftrap _MCMOVIECHANGED ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC M ((+ (ASH 4 16) 20) :SIGNED-LONGINT)))

(deftrap _MCSETDURATION ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DURATION :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC DURATION ((+ (ASH 4 16) 21) :SIGNED-LONGINT)))

(deftrap _MCGETCURRENTTIME ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SCALE (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC SCALE ((+ (ASH 4 16) 22) :SIGNED-LONGINT)))

(deftrap _MCNEWATTACHEDCONTROLLER ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (M (:POINTER :MOVIERECORD)) (W (:POINTER :GRAFPORT)) (WHERE :POINT))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC M W WHERE ((+ (ASH 12 16) 23) :SIGNED-LONGINT)))

;   direct event handlers  

(deftrap _MCDRAW ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (W (:POINTER :GRAFPORT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC W ((+ (ASH 4 16) 24) :SIGNED-LONGINT)))

(deftrap _MCACTIVATE ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (W (:POINTER :GRAFPORT)) (ACTIVATE :BOOLEAN))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC W ACTIVATE ((+ (ASH 6 16) 25) :SIGNED-LONGINT)))

(deftrap _MCIDLE ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 26) :SIGNED-LONGINT)))

(deftrap _MCKEY ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (KEY :SIGNED-BYTE) (MODIFIERS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC KEY MODIFIERS ((+ (ASH 6 16) 27) :SIGNED-LONGINT)))

(deftrap _MCCLICK ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (W (:POINTER :GRAFPORT)) (WHERE :POINT) (WHEN :SIGNED-LONG) (MODIFIERS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC W WHERE WHEN MODIFIERS ((+ (ASH 16 16) 28) :SIGNED-LONGINT)))

;    calls for editing  

(deftrap _MCENABLEEDITING ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (ENABLED :BOOLEAN))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC ENABLED ((+ (ASH 2 16) 29) :SIGNED-LONGINT)))

(deftrap _MCISEDITINGENABLED ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 30) :SIGNED-LONGINT)))

(deftrap _MCCOPY ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK (:POINTER :MOVIERECORD))
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 31) :SIGNED-LONGINT)))

(deftrap _MCCUT ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK (:POINTER :MOVIERECORD))
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 32) :SIGNED-LONGINT)))

(deftrap _MCPASTE ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SRCMOVIE (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC SRCMOVIE ((+ (ASH 4 16) 33) :SIGNED-LONGINT)))

(deftrap _MCCLEAR ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 34) :SIGNED-LONGINT)))

(deftrap _MCUNDO ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 35) :SIGNED-LONGINT)))

(deftrap _MCPOSITIONCONTROLLER ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (MOVIERECT (:POINTER :RECT)) (CONTROLLERRECT (:POINTER :RECT)) (CONTROLLERCREATIONFLAGS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC MOVIERECT CONTROLLERRECT CONTROLLERCREATIONFLAGS ((+ (ASH 12 16) 36) :SIGNED-LONGINT)))

;   menu related stuff  

(deftrap _MCGETCONTROLLERINFO ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (MCINFOFLAGS (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC MCINFOFLAGS ((+ (ASH 4 16) 37) :SIGNED-LONGINT)))


(deftrap _MCSETCLIP ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (THECLIP (:HANDLE :REGION)) (MOVIECLIP (:HANDLE :REGION)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC THECLIP MOVIECLIP ((+ (ASH 8 16) 40) :SIGNED-LONGINT)))

(deftrap _MCGETCLIP ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (THECLIP (:POINTER (:HANDLE :REGION))) (MOVIECLIP (:POINTER (:HANDLE :REGION))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC THECLIP MOVIECLIP ((+ (ASH 8 16) 41) :SIGNED-LONGINT)))


(deftrap _MCDRAWBADGE ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (MOVIERGN (:HANDLE :REGION)) (BADGERGN (:POINTER (:HANDLE :REGION))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC MOVIERGN BADGERGN ((+ (ASH 8 16) 42) :SIGNED-LONGINT)))


(deftrap _MCSETUPEDITMENU ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (MODIFIERS :SIGNED-LONG) (MH (:HANDLE :MENUINFO)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC MODIFIERS MH ((+ (ASH 8 16) 43) :SIGNED-LONGINT)))

(deftrap _MCGETMENUSTRING ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (MODIFIERS :SIGNED-LONG) (ITEM :SIGNED-INTEGER) (ASTRING (:POINTER (:STRING 255))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC MODIFIERS ITEM ASTRING ((+ (ASH 10 16) 44) :SIGNED-LONGINT)))

(deftrap _MCSETACTIONFILTERWITHREFCON ((MC (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BLOB :POINTER) (REFCON :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC BLOB REFCON ((+ (ASH 8 16) 45) :SIGNED-LONGINT)))

;  movie controller routine selectors 
(defconstant $kMCSetMovieSelect 2)
(defconstant $kMCRemoveMovieSelect 6)
(defconstant $kMCIsPlayerEventSelect 7)
(defconstant $kMCSetActionFilterSelect 8)
(defconstant $kMCDoActionSelect 9)
(defconstant $kMCSetControllerAttachedSelect #XA)
(defconstant $kMCIsControllerAttachedSelect #XB)
(defconstant $kMCSetControllerPortSelect #XC)
(defconstant $kMCGetControllerPortSelect #XD)
(defconstant $kMCGetVisibleSelect #XE)
(defconstant $kMCSetVisibleSelect #XF)
(defconstant $kMCGetControllerBoundsRectSelect #X10)
(defconstant $kMCSetControllerBoundsRectSelect #X11)
(defconstant $kMCGetControllerBoundsRgnSelect #X12)
(defconstant $kMCGetWindowRgnSelect #X13)
(defconstant $kMCMovieChangedSelect #X14)
(defconstant $kMCSetDurationSelect #X15)
(defconstant $kMCGetCurrentTimeSelect #X16)
(defconstant $kMCNewAttachedControllerSelect #X17)
(defconstant $kMCDrawSelect #X18)
(defconstant $kMCActivateSelect #X19)
(defconstant $kMCIdleSelect #X1A)
(defconstant $kMCKeySelect #X1B)
(defconstant $kMCClickSelect #X1C)
(defconstant $kMCEnableEditingSelect #X1D)
(defconstant $kMCIsEditingEnabledSelect #X1E)
(defconstant $kMCCopySelect #X1F)
(defconstant $kMCCutSelect #X20)
(defconstant $kMCPasteSelect #X21)
(defconstant $kMCClearSelect #X22)
(defconstant $kMCUndoSelect #X23)
(defconstant $kMCPositionControllerSelect #X24)
(defconstant $kMCGetControllerInfoSelect #X25)
(defconstant $kMCSetClipSelect #X28)
(defconstant $kMCGetClipSelect #X29)
(defconstant $kMCDrawBadgeSelect #X2A)
(defconstant $kMCSetUpEditMenuSelect #X2B)
(defconstant $kMCGetMenuStringSelect #X2C)
(defconstant $kMCSetActionFilterWithRefConSelect #X2D)

;   TimeBase Routines  

(deftrap _NEWTIMEBASE NIL
   (:STACK (:POINTER :TIMEBASERECORD))
   (:STACK-TRAP #xAAAA :D0 165))

(deftrap _DISPOSETIMEBASE ((TB (:POINTER :TIMEBASERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 182 TB))


(deftrap _GETTIMEBASETIME ((TB (:POINTER :TIMEBASERECORD)) (S :SIGNED-LONG) (OUT (:POINTER :TIMERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 166 TB S OUT))

(deftrap _SETTIMEBASETIME ((TB (:POINTER :TIMEBASERECORD)) (TR :TIMERECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 167 TB TR))

(deftrap _SETTIMEBASEVALUE ((TB (:POINTER :TIMEBASERECORD)) (Time :SIGNED-LONG) (S :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 168 TB Time S))


(deftrap _GETTIMEBASERATE ((TB (:POINTER :TIMEBASERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 169 TB))

(deftrap _SETTIMEBASERATE ((TB (:POINTER :TIMEBASERECORD)) (R :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 170 TB R))


(deftrap _GETTIMEBASESTARTTIME ((TB (:POINTER :TIMEBASERECORD)) (S :SIGNED-LONG) (OUT (:POINTER :TIMERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 171 TB S OUT))

(deftrap _SETTIMEBASESTARTTIME ((TB (:POINTER :TIMEBASERECORD)) (TR :TIMERECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 172 TB TR))

(deftrap _GETTIMEBASESTOPTIME ((TB (:POINTER :TIMEBASERECORD)) (S :SIGNED-LONG) (OUT (:POINTER :TIMERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 173 TB S OUT))

(deftrap _SETTIMEBASESTOPTIME ((TB (:POINTER :TIMEBASERECORD)) (TR :TIMERECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 174 TB TR))


(deftrap _GETTIMEBASEFLAGS ((TB (:POINTER :TIMEBASERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 177 TB))

(deftrap _SETTIMEBASEFLAGS ((TB (:POINTER :TIMEBASERECORD)) (TIMEBASEFLAGS :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 178 TB TIMEBASEFLAGS))


(deftrap _SETTIMEBASEMASTERTIMEBASE ((SLAVE (:POINTER :TIMEBASERECORD)) (MASTER (:POINTER :TIMEBASERECORD)) (SLAVEZERO :TIMERECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 180 SLAVE MASTER SLAVEZERO))

(deftrap _GETTIMEBASEMASTERTIMEBASE ((TB (:POINTER :TIMEBASERECORD)))
   (:STACK (:POINTER :TIMEBASERECORD))
   (:STACK-TRAP #xAAAA :D0 175 TB))

(deftrap _SETTIMEBASEMASTERCLOCK ((SLAVE (:POINTER :TIMEBASERECORD)) (CLOCKMEISTER (:POINTER :PRIVATECOMPONENTRECORD)) (SLAVEZERO :TIMERECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 179 SLAVE CLOCKMEISTER SLAVEZERO))

(deftrap _GETTIMEBASEMASTERCLOCK ((TB (:POINTER :TIMEBASERECORD)))
   (:STACK (:POINTER :PRIVATECOMPONENTINSTANCERECORD))
   (:STACK-TRAP #xAAAA :D0 176 TB))


(deftrap _CONVERTTIME ((INOUT (:POINTER :TIMERECORD)) (NEWBASE (:POINTER :TIMEBASERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 181 INOUT NEWBASE))

(deftrap _CONVERTTIMESCALE ((INOUT (:POINTER :TIMERECORD)) (NEWSCALE :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 183 INOUT NEWSCALE))

(deftrap _ADDTIME ((DST (:POINTER :TIMERECORD)) (SRC :TIMERECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 268 DST SRC))

(deftrap _SUBTRACTTIME ((DST (:POINTER :TIMERECORD)) (SRC :TIMERECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 269 DST SRC))


(deftrap _GETTIMEBASESTATUS ((TB (:POINTER :TIMEBASERECORD)) (UNPINNEDTIME (:POINTER :TIMERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 267 TB UNPINNEDTIME))


(deftrap _SETTIMEBASEZERO ((TB (:POINTER :TIMEBASERECORD)) (ZERO (:POINTER :TIMERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 296 TB ZERO))

(deftrap _GETTIMEBASEEFFECTIVERATE ((TB (:POINTER :TIMEBASERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 292 TB))

;   CallBack Routines  

(deftrap _NEWCALLBACK ((TB (:POINTER :TIMEBASERECORD)) (CBTYPE :SIGNED-INTEGER))
   (:STACK (:POINTER :CALLBACKRECORD))
   (:STACK-TRAP #xAAAA :D0 235 TB CBTYPE))


(deftrap _DISPOSECALLBACK ((QTCALL (:POINTER :CALLBACKRECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 236 QTCALL))


(deftrap _GETCALLBACKTYPE ((QTCALL (:POINTER :CALLBACKRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 237 QTCALL))

(deftrap _GETCALLBACKTIMEBASE ((QTCALL (:POINTER :CALLBACKRECORD)))
   (:STACK (:POINTER :TIMEBASERECORD))
   (:STACK-TRAP #xAAAA :D0 238 QTCALL))


(deftrap _CALLMEWHEN ((QTCALL (:POINTER :CALLBACKRECORD)) (CALLBACKPROC :POINTER) (REFCON :SIGNED-LONG) (PARAM1 :SIGNED-LONG) (PARAM2 :SIGNED-LONG) (PARAM3 :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 184 QTCALL CALLBACKPROC REFCON PARAM1 PARAM2 PARAM3))


(deftrap _CANCELCALLBACK ((CB (:POINTER :CALLBACKRECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 185 CB))

;   Clock CallBack support Routines  

(deftrap _ADDCALLBACKTOTIMEBASE ((CB (:POINTER :CALLBACKRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 297 CB))

(deftrap _REMOVECALLBACKFROMTIMEBASE ((CB (:POINTER :CALLBACKRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 298 CB))

(deftrap _GETFIRSTCALLBACK ((TB (:POINTER :TIMEBASERECORD)))
   (:STACK (:POINTER :CALLBACKRECORD))
   (:STACK-TRAP #xAAAA :D0 299 TB))

(deftrap _GETNEXTCALLBACK ((CB (:POINTER :CALLBACKRECORD)))
   (:STACK (:POINTER :CALLBACKRECORD))
   (:STACK-TRAP #xAAAA :D0 300 CB))

(deftrap _EXECUTECALLBACK ((CB (:POINTER :CALLBACKRECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 301 CB))

; $ENDC                         ;  UsingMovies 

; $IFC NOT UsingIncludes

; $ENDC


(export '($KMCSETACTIONFILTERWITHREFCONSELECT $KMCGETMENUSTRINGSELECT
          $KMCSETUPEDITMENUSELECT $KMCDRAWBADGESELECT $KMCGETCLIPSELECT
          $KMCSETCLIPSELECT $KMCGETCONTROLLERINFOSELECT
          $KMCPOSITIONCONTROLLERSELECT $KMCUNDOSELECT $KMCCLEARSELECT
          $KMCPASTESELECT $KMCCUTSELECT $KMCCOPYSELECT
          $KMCISEDITINGENABLEDSELECT $KMCENABLEEDITINGSELECT $KMCCLICKSELECT
          $KMCKEYSELECT $KMCIDLESELECT $KMCACTIVATESELECT $KMCDRAWSELECT
          $KMCNEWATTACHEDCONTROLLERSELECT $KMCGETCURRENTTIMESELECT
          $KMCSETDURATIONSELECT $KMCMOVIECHANGEDSELECT $KMCGETWINDOWRGNSELECT
          $KMCGETCONTROLLERBOUNDSRGNSELECT $KMCSETCONTROLLERBOUNDSRECTSELECT
          $KMCGETCONTROLLERBOUNDSRECTSELECT $KMCSETVISIBLESELECT
          $KMCGETVISIBLESELECT $KMCGETCONTROLLERPORTSELECT
          $KMCSETCONTROLLERPORTSELECT $KMCISCONTROLLERATTACHEDSELECT
          $KMCSETCONTROLLERATTACHEDSELECT $KMCDOACTIONSELECT
          $KMCSETACTIONFILTERSELECT $KMCISPLAYEREVENTSELECT
          $KMCREMOVEMOVIESELECT $KMCSETMOVIESELECT $BADCONTROLLERHEIGHT
          $EDITINGNOTALLOWED $CONTROLLERBOUNDSNOTEXACT
          $CANNOTSETWIDTHOFATTACHEDCONTROLLER $CONTROLLERHASFIXEDHEIGHT
          $CANNOTMOVEATTACHEDCONTROLLER $MCMENUCLEAR $MCMENUPASTE $MCMENUCOPY
          $MCMENUCUT $MCMENUUNDO $MCINFOEDITINGENABLED $MCINFOISINPALINDROME
          $MCINFOISLOOPING $MCINFOISPLAYING $MCINFOHASSOUND
          $MCINFOCLEARAVAILABLE $MCINFOPASTEAVAILABLE $MCINFOCOPYAVAILABLE
          $MCINFOCUTAVAILABLE $MCINFOUNDOAVAILABLE $MCPOSITIONDONTINVALIDATE
          $MCFLAGSUSEWINDOWPALETTE $MCFLAGSUPPRESSSPEAKERBUTTON
          $MCFLAGSUPPRESSSTEPBUTTONS $MCFLAGSUPPRESSMOVIEFRAME $MCACTIONRESUME
          $MCACTIONSUSPEND $MCACTIONMOVIECLICK $MCACTIONBADGECLICK
          $MCACTIONSHOWBALLOON $MCACTIONGETPLAYRATE $MCACTIONGETPLAYEVERYFRAME
          $MCACTIONSETPLAYEVERYFRAME $MCACTIONGETFLAGS $MCACTIONSETFLAGS
          $MCACTIONGETUSEBADGE $MCACTIONSETUSEBADGE $MCACTIONGETPLAYSELECTION
          $MCACTIONSETPLAYSELECTION $MCACTIONGETKEYSENABLED
          $MCACTIONSETKEYSENABLED $MCACTIONSETPOSTERTIME
          $MCACTIONSETSELECTIONDURATION $MCACTIONSETSELECTIONBEGIN
          $MCACTIONCONTROLLERSIZECHANGED $MCACTIONSETGROWBOXBOUNDS
          $MCACTIONGETLOOPISPALINDROME $MCACTIONSETLOOPISPALINDROME
          $MCACTIONGETLOOPING $MCACTIONSETLOOPING $MCACTIONSTEP
          $MCACTIONGETVOLUME $MCACTIONSETVOLUME $MCACTIONGOTOTIME $MCACTIONPLAY
          $MCACTIONKEY $MCACTIONMOUSEDOWN $MCACTIONDEACTIVATE $MCACTIONACTIVATE
          $MCACTIONDRAW $MCACTIONIDLE $MCWITHFRAME $MCNOTVISIBLE $MCWITHBADGE
          $MCSCALEMOVIETOFIT $MCTOPLEFTMOVIE $MOVIECONTROLLERCOMPONENTTYPE
          $NORECORDOFAPP $LASTMOVIESERROR $UNSUPPORTEDAUXILIARYIMPORTDATA
          $FEATUREUNSUPPORTED $COULDNOTUSEANEXISTINGSAMPLE $NODEFAULTDATAREF
          $BADDATAREFINDEX $INVALIDDATAREFCONTAINER $NOMOVIEFOUND
          $DATANODATAREF $ENDOFDATAREACHED $DATAALREADYCLOSED
          $DATAALREADYOPENFORWRITE $DATANOTOPENFORWRITE $DATANOTOPENFORREAD
          $INVALIDSAMPLEDESCRIPTION $INVALIDCHUNKCACHE $INVALIDSAMPLEDESCINDEX
          $INVALIDCHUNKNUM $INVALIDSAMPLENUM $INVALIDRECT $CANTENABLETRACK
          $INTERNALQUICKTIMEERROR $BADEDITINDEX $TIMENOTINMEDIA $TIMENOTINTRACK
          $TRACKNOTINMOVIE $TRACKIDNOTFOUND $BADTRACKINDEX
          $MAXSIZETOGROWTOOSMALL $USERDATAITEMNOTFOUND $STALEEDITSTATE
          $NONMATCHINGEDITSTATE $INVALIDEDITSTATE $CANTCREATESINGLEFORKFILE
          $WFFILENOTFOUND $MOVIETOOLBOXUNINITIALIZED $PROGRESSPROCABORTED
          $MEDIATYPESDONTMATCH $BADEDITLIST $CANTPUTPUBLICMOVIEATOM
          $INVALIDTIME $INVALIDDURATION $INVALIDHANDLER $INVALIDDATAREF
          $INVALIDSAMPLETABLE $INVALIDMOVIE $INVALIDTRACK $INVALIDMEDIA
          $NODATAHANDLER $NOMEDIAHANDLER $BADCOMPONENTTYPE $CANTOPENHANDLER
          $CANTFINDHANDLER $BADPUBLICMOVIEATOM $BADIMAGEDESCRIPTION
          $COULDNOTRESOLVEDATAREF $FIRSTMOVIESERROR $DATAREFWASNOTRESOLVED
          $DATAREFSELFREFERENCE $FINDTEXTWRAPAROUND $FINDTEXTREVERSESEARCH
          $FINDTEXTCASESENSITIVE $FINDTEXTEDGEOK $TXTPROCDODISPLAY
          $TXTPROCDONTDISPLAY $TXTPROCDEFAULTDISPLAY
          $MEDIAHANDLERFLAGGENERICCLIENT $HINTSUSESOUNDLERP
          $HINTSALLOWINTERLACE $HINTSUSESCREENBUFFER $HINTSSCRUBMODE
          $MOVIESCRAPONLYPUTMOVIE $MOVIESCRAPDONTZEROSCRAP
          $MOVIEINDATAFORKRESID $FLATTENDONTINTERLEAVEFLATTEN
          $FLATTENACTIVETRACKSONLY $FLATTENADDMOVIETODATAFORK
          $CREATEMOVIEFILEDONTOPENFILE $CREATEMOVIEFILEDONTCREATEMOVIE
          $CREATEMOVIEFILEDELETECURFILE $NEXTTIMEIGNOREACTIVESEGMENT
          $NEXTTIMEEDGEOK $NEXTTIMESYNCSAMPLE $NEXTTIMETRACKEDIT
          $NEXTTIMEMEDIAEDIT $NEXTTIMEMEDIASAMPLE $PASTEINPARALLEL
          $MEDIASAMPLESHADOWSYNC $MEDIASAMPLENOTSYNC $TRACKUSAGEINPOSTER
          $TRACKUSAGEINPREVIEW $TRACKUSAGEINMOVIE $NEWMOVIEDONTAUTOALTERNATES
          $NEWMOVIEDONTASKUNRESOLVEDDATAREFS $NEWMOVIEDONTRESOLVEDATAREFS
          $NEWMOVIEACTIVE $LOADBACKWARDTRACKEDITS $LOADFORWARDTRACKEDITS
          $FLUSHFROMRAM $UNKEEPINRAM $KEEPINRAM $QTCBNEEDSSTARTSTOPCHANGES
          $QTCBNEEDSTIMECHANGES $QTCBNEEDSRATECHANGES $CALLBACKATINTERRUPT
          $CALLBACKATEXTREMES $CALLBACKATTIMEJUMP $CALLBACKATRATE
          $CALLBACKATTIME $TIMEBASEAFTERSTOPTIME $TIMEBASEBEFORESTARTTIME
          $TRIGGERATSTOP $TRIGGERATSTART $TRIGGERRATECHANGE
          $TRIGGERRATENOTEQUAL $TRIGGERRATEGTE $TRIGGERRATELTE
          $TRIGGERRATEEQUAL $TRIGGERRATEGT $TRIGGERRATELT $TRIGGERTIMEEITHER
          $TRIGGERTIMEBWD $TRIGGERTIMEFWD $PALINDROMELOOPTIMEBASE $LOOPTIMEBASE
          $MEDIAQUALITYBEST $MEDIAQUALITYBETTER $MEDIAQUALITYNORMAL
          $MEDIAQUALITYDRAFT $PROGRESSOPEXPORTMOVIE $PROGRESSOPIMPORTMOVIE
          $PROGRESSOPLOADMEDIAINTORAM $PROGRESSOPLOADTRACKINTORAM
          $PROGRESSOPLOADMOVIEINTORAM $PROGRESSOPCUT $PROGRESSOPCOPY
          $PROGRESSOPADDMOVIESELECTION $PROGRESSOPPASTE
          $PROGRESSOPINSERTMOVIESEGMENT $PROGRESSOPINSERTTRACKSEGMENT
          $PROGRESSOPFLATTEN $MOVIEPROGRESSCLOSE $MOVIEPROGRESSUPDATEPERCENT
          $MOVIEPROGRESSOPEN $DFREVERSESCROLL $DFHORIZSCROLL $DFSCROLLOUT
          $DFSCROLLIN $DFSHRINKTEXTBOXTOFIT $DFUSEMOVIEBGCOLOR $DFCLIPTOTEXTBOX
          $DFDONTAUTOSCALE $DFDONTDISPLAY $KNOVOLUME $KFULLVOLUME
          $DOTHERIGHTTHING $GENERICMEDIATYPE $TEXTMEDIATYPE $SOUNDMEDIATYPE
          $VIDEOMEDIATYPE $DATAHANDLERTYPE $MEDIAHANDLERTYPE $MOVIEFILETYPE
          $GESTALTQUICKTIME $KFIX1))
(provide-interface 'Movies)