
(in-package :TRAPS)
; 
; Created: Tuesday, October 13, 1992
;  QuickTimeComponents.p
;  Pascal Interface to the Macintosh Libraries
; 
;  Copyright Apple Computer, Inc. 1991, 1992
;  All rights reserved
; 
; 
; 

; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED UsingQuickTimeComponents
; $SETC UsingQuickTimeComponents := 1

; $I+
; $SETC QuickTimeComponentsIncludes := UsingIncludes
; $SETC UsingIncludes := 1
; $IFC UNDEFINED UsingComponents

(require-interface 'COMPONENTS) ; $I $$Shell(PInterfaces)Components.p
; $ENDC
; $IFC UNDEFINED UsingImageCompression

(require-interface 'IMAGECOMPRESSION); $I $$Shell(PInterfaces)ImageCompression.p
; $ENDC
; $IFC UNDEFINED UsingMovies

(require-interface 'MOVIES)     ; $I $$Shell(PInterfaces)Movies.p
; $ENDC
; $IFC UNDEFINED UsingQuickDraw

(require-interface 'QUICKDRAW)  ; $I $$Shell(PInterfaces)QuickDraw.p
; $ENDC
; $IFC UNDEFINED UsingMenus

(require-interface 'MENUS)      ; $I $$Shell(PInterfaces)Menus.p
; $ENDC
; $IFC UNDEFINED UsingVideo

(require-interface 'VIDEO)      ; $I $$Shell(PInterfaces)Video.p
; $ENDC
; $SETC UsingIncludes := QuickTimeComponentsIncludes

; ****
; 
;  Clock Component
; 
; ****
(defconstant $clockComponentType :|clok|)
(defconstant $systemTickClock :|tick|);  subtype: 60ths since boot 
(defconstant $systemSecondClock :|seco|);  subtype: 1000000ths since boot 
(defconstant $systemMillisecondClock :|mill|);  subtype: 1000ths since boot	
(defconstant $systemMicrosecondClock :|micr|);  subtype: 1000000ths since boot 

(defconstant $kClockRateIsLinear 1)
(defconstant $kClockImplementsCallBacks 2)

(defconstant $kClockGetClockTimeSelect #X1)
(defconstant $kClockNewCallBackSelect #X2)
(defconstant $kClockDisposeCallBackSelect #X3)
(defconstant $kClockCallMeWhenSelect #X4)
(defconstant $kClockCancelCallBackSelect #X5)
(defconstant $kClockRateChangedSelect #X6)
(defconstant $kClockTimeChangedSelect #X7)
(defconstant $kClockSetTimeBaseSelect #X8)
(defconstant $kClockStartStopChangedSelect #X9)
(defconstant $kClockGetRateSelect #XA)

;  Same Calls 

(deftrap _CLOCKGETTIME ((ACLOCK (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (OUT (:POINTER :TIMERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 ACLOCK OUT ((+ (ASH 4 16) 1) :SIGNED-LONGINT)))

(deftrap _GETCLOCKTIME ((ACLOCK (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (OUT (:POINTER :TIMERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 ACLOCK OUT ((+ (ASH 4 16) 1) :SIGNED-LONGINT)))


(deftrap _CLOCKNEWCALLBACK ((ACLOCK (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (TB (:POINTER :TIMEBASERECORD)) (CALLBACKTYPE :SIGNED-INTEGER))
   (:STACK (:POINTER :CALLBACKRECORD))
   (:STACK-TRAP #xA82A :D0 0 ACLOCK TB CALLBACKTYPE ((+ (ASH 6 16) 2) :SIGNED-LONGINT)))

(deftrap _CLOCKDISPOSECALLBACK ((ACLOCK (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (CB (:POINTER :CALLBACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 ACLOCK CB ((+ (ASH 4 16) 3) :SIGNED-LONGINT)))

(deftrap _CLOCKCALLMEWHEN ((CLOCK (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (CB (:POINTER :CALLBACKRECORD)) (PARAM1 :SIGNED-LONG) (PARAM2 :SIGNED-LONG) (PARAM3 :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CLOCK CB PARAM1 PARAM2 PARAM3 ((+ (ASH 16 16) 4) :SIGNED-LONGINT)))

(deftrap _CLOCKCANCELCALLBACK ((CLOCK (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (CB (:POINTER :CALLBACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CLOCK CB ((+ (ASH 4 16) 5) :SIGNED-LONGINT)))

(deftrap _CLOCKRATECHANGED ((CLOCK (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (CB (:POINTER :CALLBACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CLOCK CB ((+ (ASH 4 16) 6) :SIGNED-LONGINT)))

(deftrap _CLOCKTIMECHANGED ((CLOCK (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (CB (:POINTER :CALLBACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CLOCK CB ((+ (ASH 4 16) 7) :SIGNED-LONGINT)))

(deftrap _CLOCKSETTIMEBASE ((CLOCK (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (TB (:POINTER :TIMEBASERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CLOCK TB ((+ (ASH 4 16) 8) :SIGNED-LONGINT)))

(deftrap _CLOCKSTARTSTOPCHANGED ((CLOCK (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (CB (:POINTER :CALLBACKRECORD)) (STARTCHANGED :BOOLEAN) (STOPCHANGED :BOOLEAN))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CLOCK CB STARTCHANGED STOPCHANGED ((+ (ASH 8 16) 9) :SIGNED-LONGINT)))

(deftrap _CLOCKGETRATE ((ACLOCK (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (RATE (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 ACLOCK RATE ((+ (ASH 4 16) 10) :SIGNED-LONGINT)))

;  Sequence Grab Component 
(def-mactype :SEQGRABCOMPONENT (find-mactype :POINTER))
(def-mactype :SGCHANNEL (find-mactype :POINTER))

(defconstant $SeqGrabComponentType :|barg|)
(defconstant $SeqGrabChannelType :|sgch|)

(defconstant $SeqGrabPanelType :|sgpn|)
(defconstant $SeqGrabCompressionPanelType :|comp|)
(defconstant $SeqGrabSourcePanelType :|sour|)

(defconstant $seqGrabToDisk 1)
(defconstant $seqGrabToMemory 2)
(defconstant $seqGrabUseTempMemory 4)
(defconstant $seqGrabAppendToFile 8)
(defconstant $seqGrabDontAddMovieResource #X10)
(defconstant $seqGrabDontMakeMovie #X20)
(defconstant $seqGrabPreExtendFile #X40)

(def-mactype :SEQGRABDATAOUTPUTENUM (find-mactype :SIGNED-LONG))

(defconstant $seqGrabRecord 1)
(defconstant $seqGrabPreview 2)
(defconstant $seqGrabPlayDuringRecord 4)

(def-mactype :SEQGRABUSAGEENUM (find-mactype :SIGNED-LONG))

(defconstant $seqGrabHasBounds 1)
(defconstant $seqGrabHasVolume 2)
(defconstant $seqGrabHasDiscreteSamples 4)

(def-mactype :SEQGRABCHANNELINFOENUM (find-mactype :SIGNED-LONG))

(defrecord SeqGrabFrameInfo 
   (frameOffset :SIGNED-LONG)
   (frameTime :SIGNED-LONG)
   (frameSize :SIGNED-LONG)
   (frameChannel (:POINTER :PRIVATECOMPONENTINSTANCERECORD))
   (frameRefCon :SIGNED-LONG)
   )

(defconstant $grabPictOffScreen 1)
(defconstant $grabPictIgnoreClip 2)

(defconstant $sgFlagControlledGrab 1)

(def-mactype :SGDATAPROC (find-mactype :POINTER))

(defrecord SGDeviceName 
   (name (:STRING 63))
   (icon :HANDLE)
   (flags :SIGNED-LONG)
   (refCon :SIGNED-LONG)
   (reserved :SIGNED-LONG)      ;  zero 
   )

(defconstant $sgDeviceNameFlagDeviceUnavailable 1)

(def-mactype :SGDEVICELISTPTR (find-mactype :POINTER))
(def-mactype :SGDEVICELIST (find-mactype :HANDLE))
(defrecord (SGDeviceListRecord :handle) 
   (count :SIGNED-INTEGER)
   (selectedIndex :SIGNED-INTEGER)
   (reserved :SIGNED-LONG)
   (entry (:ARRAY :SGDEVICENAME 1))
   )
(def-mactype :ALIGNMENTPROCRECORDPTR (find-mactype :POINTER))

(defconstant $sgDeviceListWithIcons 1)
(defconstant $sgDeviceListDontCheckAvailability 2)

(defconstant $seqGrabWriteAppend 0)
(defconstant $seqGrabWriteReserve 1)
(defconstant $seqGrabWrite 2)

(defconstant $seqGrabUnpause 0)
(defconstant $seqGrabPause 1)
(defconstant $seqGrabPauseForMenu 3)

(defconstant $channelFlagDontOpenResFile 2)
(defconstant $channelFlagHasDependency 4)

(def-mactype :SGMODALFILTERPROCPTR (find-mactype :POINTER))

(defconstant $sgPanelFlagForPanel 1)

(defconstant $channelPlayNormal 0)
(defconstant $channelPlayFast 1)
(defconstant $channelPlayHighQuality 2)
(defconstant $channelPlayAllData 4)


(deftrap _SGINITIALIZE ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S ((+ (ASH 0 16) 1) :SIGNED-LONGINT)))


(deftrap _SGSETDATAOUTPUT ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (MOVIEFILE :FSSPEC) (WHEREFLAGS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S MOVIEFILE WHEREFLAGS ((+ (ASH 8 16) 2) :SIGNED-LONGINT)))

(deftrap _SGGETDATAOUTPUT ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (MOVIEFILE (:POINTER :FSSPEC)) (WHEREFLAGS (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S MOVIEFILE WHEREFLAGS ((+ (ASH 8 16) 3) :SIGNED-LONGINT)))


(deftrap _SGSETGWORLD ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (GP (:POINTER :CGRAFPORT)) (GD (:HANDLE :GDEVICE)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S GP GD ((+ (ASH 8 16) 4) :SIGNED-LONGINT)))

(deftrap _SGGETGWORLD ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (GP (:POINTER (:POINTER :CGRAFPORT))) (GD (:POINTER (:HANDLE :GDEVICE))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S GP GD ((+ (ASH 8 16) 5) :SIGNED-LONGINT)))


(deftrap _SGNEWCHANNEL ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (CHANNELTYPE :OSTYPE) (REF (:POINTER (:POINTER :PRIVATECOMPONENTINSTANCERECORD))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S CHANNELTYPE REF ((+ (ASH 8 16) 6) :SIGNED-LONGINT)))

(deftrap _SGDISPOSECHANNEL ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S C ((+ (ASH 4 16) 7) :SIGNED-LONGINT)))


(deftrap _SGSTARTPREVIEW ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S ((+ (ASH 0 16) 16) :SIGNED-LONGINT)))

(deftrap _SGSTARTRECORD ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S ((+ (ASH 0 16) 17) :SIGNED-LONGINT)))

(deftrap _SGIDLE ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S ((+ (ASH 0 16) 18) :SIGNED-LONGINT)))

(deftrap _SGSTOP ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S ((+ (ASH 0 16) 19) :SIGNED-LONGINT)))


(deftrap _SGPAUSE ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (PAUSE :BOOLEAN))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S PAUSE ((+ (ASH 2 16) 20) :SIGNED-LONGINT)))


(deftrap _SGPREPARE ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (PREPAREFORPREVIEW :BOOLEAN) (PREPAREFORRECORD :BOOLEAN))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S PREPAREFORPREVIEW PREPAREFORRECORD ((+ (ASH 4 16) 21) :SIGNED-LONGINT)))

(deftrap _SGRELEASE ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S ((+ (ASH 0 16) 22) :SIGNED-LONGINT)))


(deftrap _SGGETMOVIE ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK (:POINTER :MOVIERECORD))
   (:STACK-TRAP #xA82A :D0 0 S ((+ (ASH 0 16) 23) :SIGNED-LONGINT)))


(deftrap _SGSETMAXIMUMRECORDTIME ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (TICKS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S TICKS ((+ (ASH 4 16) 24) :SIGNED-LONGINT)))

(deftrap _SGGETMAXIMUMRECORDTIME ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (TICKS (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S TICKS ((+ (ASH 4 16) 25) :SIGNED-LONGINT)))


(deftrap _SGGETSTORAGESPACEREMAINING ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BYTES (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S BYTES ((+ (ASH 4 16) 26) :SIGNED-LONGINT)))

(deftrap _SGGETTIMEREMAINING ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (TICKSLEFT (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S TICKSLEFT ((+ (ASH 4 16) 27) :SIGNED-LONGINT)))


(deftrap _SGGRABPICT ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (P (:POINTER (:HANDLE :PICTURE))) (BOUNDS :RECT) (OFFSCREENDEPTH :SIGNED-INTEGER) (GRABPICTFLAGS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S P BOUNDS OFFSCREENDEPTH GRABPICTFLAGS ((+ (ASH 14 16) 28) :SIGNED-LONGINT)))


(deftrap _SGGETLASTMOVIERESID ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (RESID (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S RESID ((+ (ASH 4 16) 29) :SIGNED-LONGINT)))


(deftrap _SGSETFLAGS ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SGFLAGS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S SGFLAGS ((+ (ASH 4 16) 30) :SIGNED-LONGINT)))

(deftrap _SGGETFLAGS ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SGFLAGS (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S SGFLAGS ((+ (ASH 4 16) 31) :SIGNED-LONGINT)))


(deftrap _SGSETDATAPROC ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (PROC :POINTER) (REFCON :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S PROC REFCON ((+ (ASH 8 16) 32) :SIGNED-LONGINT)))

(deftrap _SGNEWCHANNELFROMCOMPONENT ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (NEWCHANNEL (:POINTER (:POINTER :PRIVATECOMPONENTINSTANCERECORD))) (SGCHANNELCOMPONENT (:POINTER :PRIVATECOMPONENTRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S NEWCHANNEL SGCHANNELCOMPONENT ((+ (ASH 8 16) 33) :SIGNED-LONGINT)))

(deftrap _SGDISPOSEDEVICELIST ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (LIST (:HANDLE :SGDEVICELISTRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S LIST ((+ (ASH 4 16) 34) :SIGNED-LONGINT)))

(deftrap _SGAPPENDDEVICELISTTOMENU ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (LIST (:HANDLE :SGDEVICELISTRECORD)) (MH (:HANDLE :MENUINFO)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S LIST MH ((+ (ASH 8 16) 35) :SIGNED-LONGINT)))

(deftrap _SGSETSETTINGS ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (UD (:POINTER :USERDATARECORD)) (FLAGS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S UD FLAGS ((+ (ASH 8 16) 36) :SIGNED-LONGINT)))

(deftrap _SGGETSETTINGS ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (UD (:POINTER (:POINTER :USERDATARECORD))) (FLAGS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S UD FLAGS ((+ (ASH 8 16) 37) :SIGNED-LONGINT)))

(deftrap _SGGETINDCHANNEL ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (INDEX :SIGNED-INTEGER) (REF (:POINTER (:POINTER :PRIVATECOMPONENTINSTANCERECORD))) (CHANTYPE (:POINTER :OSTYPE)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S INDEX REF CHANTYPE ((+ (ASH 10 16) 38) :SIGNED-LONGINT)))

(deftrap _SGUPDATE ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (UPDATERGN (:HANDLE :REGION)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S UPDATERGN ((+ (ASH 4 16) 39) :SIGNED-LONGINT)))

(deftrap _SGGETPAUSE ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (PAUSED (:POINTER :UNSIGNED-BYTE)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S PAUSED ((+ (ASH 4 16) 40) :SIGNED-LONGINT)))

(deftrap _SGSETTINGSDIALOG ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (NUMPANELS :SIGNED-INTEGER) (PANELLIST (:POINTER (:POINTER :PRIVATECOMPONENTRECORD))) (FLAGS :SIGNED-LONG) (PROC :POINTER) (PROCREFNUM :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S C NUMPANELS PANELLIST FLAGS PROC PROCREFNUM ((+ (ASH 22 16) 41) :SIGNED-LONGINT)))

#| Not in ROM - INLINE =  #x0F3C #x0004 #x002A #x7000 #xA82A |#
; Typo in source: "$f3c" should have been "$2f3c"
(deftrap _SGGETALIGNMENTPROC ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (ALIGNMENTPROC :POINTER))
   (:STACK :SIGNED-LONG)
   (:stack-trap #xa82a :d0 0 s alignmentproc (#x4002a :signed-longint)))

(deftrap _SGSETCHANNELSETTINGS ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (UD (:POINTER :USERDATARECORD)) (FLAGS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S C UD FLAGS ((+ (ASH 12 16) 43) :SIGNED-LONGINT)))

(deftrap _SGGETCHANNELSETTINGS ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (UD (:POINTER (:POINTER :USERDATARECORD))) (FLAGS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S C UD FLAGS ((+ (ASH 12 16) 44) :SIGNED-LONGINT)))

;    calls from Channel to seqGrab   

(deftrap _SGWRITEMOVIEDATA ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (P :POINTER) (LEN :SIGNED-LONG) (OFFSET (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S C P LEN OFFSET ((+ (ASH 16 16) 256) :SIGNED-LONGINT)))

(deftrap _SGADDFRAMEREFERENCE ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (FRAMEINFO (:POINTER :SEQGRABFRAMEINFO)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S FRAMEINFO ((+ (ASH 4 16) 257) :SIGNED-LONGINT)))

(deftrap _SGGETNEXTFRAMEREFERENCE ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (FRAMEINFO (:POINTER :SEQGRABFRAMEINFO)) (FRAMEDURATION (:POINTER :SIGNED-LONG)) (FRAMENUMBER (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S FRAMEINFO FRAMEDURATION FRAMENUMBER ((+ (ASH 12 16) 258) :SIGNED-LONGINT)))

(deftrap _SGGETTIMEBASE ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (TB (:POINTER (:POINTER :TIMEBASERECORD))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S TB ((+ (ASH 4 16) 259) :SIGNED-LONGINT)))

(deftrap _SGSORTDEVICELIST ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (LIST (:HANDLE :SGDEVICELISTRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S LIST ((+ (ASH 4 16) 260) :SIGNED-LONGINT)))

(deftrap _SGADDMOVIEDATA ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (P :POINTER) (LEN :SIGNED-LONG) (OFFSET (:POINTER :SIGNED-LONG)) (CHREFCON :SIGNED-LONG) (TIME :SIGNED-LONG) (WRITETYPE :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S C P LEN OFFSET CHREFCON TIME WRITETYPE ((+ (ASH 26 16) 261) :SIGNED-LONGINT)))

(deftrap _SGCHANGEDSOURCE ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S C ((+ (ASH 4 16) 262) :SIGNED-LONGINT)))

;    General Channel Routines   

(deftrap _SGSETCHANNELUSAGE ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (USAGE :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C USAGE ((+ (ASH 4 16) 128) :SIGNED-LONGINT)))

(deftrap _SGGETCHANNELUSAGE ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (USAGE (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C USAGE ((+ (ASH 4 16) 129) :SIGNED-LONGINT)))


(deftrap _SGSETCHANNELBOUNDS ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BOUNDS :RECT))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BOUNDS ((+ (ASH 4 16) 130) :SIGNED-LONGINT)))

(deftrap _SGGETCHANNELBOUNDS ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BOUNDS (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BOUNDS ((+ (ASH 4 16) 131) :SIGNED-LONGINT)))


(deftrap _SGSETCHANNELVOLUME ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (VOLUME :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C VOLUME ((+ (ASH 2 16) 132) :SIGNED-LONGINT)))

(deftrap _SGGETCHANNELVOLUME ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (VOLUME (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C VOLUME ((+ (ASH 4 16) 133) :SIGNED-LONGINT)))


(deftrap _SGGETCHANNELINFO ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (CHANNELINFO (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C CHANNELINFO ((+ (ASH 4 16) 134) :SIGNED-LONGINT)))


(deftrap _SGSETCHANNELPLAYFLAGS ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (PLAYFLAGS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C PLAYFLAGS ((+ (ASH 4 16) 135) :SIGNED-LONGINT)))

(deftrap _SGGETCHANNELPLAYFLAGS ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (PLAYFLAGS (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C PLAYFLAGS ((+ (ASH 4 16) 136) :SIGNED-LONGINT)))


(deftrap _SGSETCHANNELMAXFRAMES ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (FRAMECOUNT :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C FRAMECOUNT ((+ (ASH 4 16) 137) :SIGNED-LONGINT)))

(deftrap _SGGETCHANNELMAXFRAMES ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (FRAMECOUNT (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C FRAMECOUNT ((+ (ASH 4 16) 138) :SIGNED-LONGINT)))


(deftrap _SGSETCHANNELREFCON ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (REFCON :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C REFCON ((+ (ASH 4 16) 139) :SIGNED-LONGINT)))


(deftrap _SGSETCHANNELCLIP ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (THECLIP (:HANDLE :REGION)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C THECLIP ((+ (ASH 4 16) 140) :SIGNED-LONGINT)))


(deftrap _SGGETCHANNELCLIP ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (THECLIP (:POINTER (:HANDLE :REGION))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C THECLIP ((+ (ASH 4 16) 141) :SIGNED-LONGINT)))


(deftrap _SGGETCHANNELSAMPLEDESCRIPTION ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SAMPLEDESC :HANDLE))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C SAMPLEDESC ((+ (ASH 4 16) 142) :SIGNED-LONGINT)))


(deftrap _SGGETCHANNELDEVICELIST ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SELECTIONFLAGS :SIGNED-LONG) (LIST (:POINTER (:HANDLE :SGDEVICELISTRECORD))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C SELECTIONFLAGS LIST ((+ (ASH 8 16) 143) :SIGNED-LONGINT)))


(deftrap _SGSETCHANNELDEVICE ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (NAME (:POINTER (:STRING 255))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C NAME ((+ (ASH 4 16) 144) :SIGNED-LONGINT)))


(deftrap _SGSETCHANNELMATRIX ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (M (:POINTER :MATRIXRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C M ((+ (ASH 4 16) 145) :SIGNED-LONGINT)))


(deftrap _SGGETCHANNELMATRIX ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (M (:POINTER :MATRIXRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C M ((+ (ASH 4 16) 146) :SIGNED-LONGINT)))


(deftrap _SGGETCHANNELTIMESCALE ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SCALE (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C SCALE ((+ (ASH 4 16) 147) :SIGNED-LONGINT)))

;    calls from seqGrab to Channel   

(deftrap _SGINITCHANNEL ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (OWNER (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C OWNER ((+ (ASH 4 16) 384) :SIGNED-LONGINT)))

(deftrap _SGWRITESAMPLES ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (M (:POINTER :MOVIERECORD)) (THEFILE (:HANDLE :ALIASRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C M THEFILE ((+ (ASH 8 16) 385) :SIGNED-LONGINT)))

(deftrap _SGGETDATARATE ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BYTESPERSECOND (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BYTESPERSECOND ((+ (ASH 4 16) 386) :SIGNED-LONGINT)))

(deftrap _SGALIGNCHANNELRECT ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (R (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C R ((+ (ASH 4 16) 387) :SIGNED-LONGINT)))


(deftrap _SGPANELGETDITL ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DITL (:POINTER :HANDLE)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S DITL ((+ (ASH 4 16) 512) :SIGNED-LONGINT)))

(deftrap _SGPANELGETTITLE ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (TITLE (:STRING 255)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S TITLE ((+ (ASH 4 16) 513) :SIGNED-LONGINT)))

(deftrap _SGPANELCANRUN ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S C ((+ (ASH 4 16) 514) :SIGNED-LONGINT)))

(deftrap _SGPANELINSTALL ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (D (:POINTER :GRAFPORT)) (ITEMOFFSET :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S C D ITEMOFFSET ((+ (ASH 10 16) 515) :SIGNED-LONGINT)))

(deftrap _SGPANELEVENT ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (D (:POINTER :GRAFPORT)) (ITEMOFFSET :SIGNED-INTEGER) (THEEVENT (:POINTER :EVENTRECORD)) (ITEMHIT (:POINTER :SIGNED-INTEGER)) (HANDLED (:POINTER :BOOLEAN)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S C D ITEMOFFSET THEEVENT ITEMHIT HANDLED ((+ (ASH 22 16) 516) :SIGNED-LONGINT)))

(deftrap _SGPANELITEM ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (D (:POINTER :GRAFPORT)) (ITEMOFFSET :SIGNED-INTEGER) (ITEMNUM :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S C D ITEMOFFSET ITEMNUM ((+ (ASH 12 16) 517) :SIGNED-LONGINT)))

(deftrap _SGPANELREMOVE ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (D (:POINTER :GRAFPORT)) (ITEMOFFSET :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S C D ITEMOFFSET ((+ (ASH 10 16) 518) :SIGNED-LONGINT)))

(deftrap _SGPANELSETGRABBER ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SG (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S SG ((+ (ASH 4 16) 519) :SIGNED-LONGINT)))

(deftrap _SGPANELSETRESFILE ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (RESREF :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S RESREF ((+ (ASH 2 16) 520) :SIGNED-LONGINT)))

(deftrap _SGPANELGETSETTINGS ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (UD (:POINTER (:POINTER :USERDATARECORD))) (FLAGS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S C UD FLAGS ((+ (ASH 12 16) 521) :SIGNED-LONGINT)))

(deftrap _SGPANELSETSETTINGS ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (UD (:POINTER :USERDATARECORD)) (FLAGS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S C UD FLAGS ((+ (ASH 12 16) 522) :SIGNED-LONGINT)))

(deftrap _SGPANELVALIDATEINPUT ((S (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (OK (:POINTER :BOOLEAN)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S OK ((+ (ASH 4 16) 523) :SIGNED-LONGINT)))

;  Video Routines 

(defrecord SGCompressInfo 
   (buffer :POINTER)
   (bufferSize :SIGNED-LONG)
   (similarity :CHARACTER)
   (reserved :CHARACTER)
   )

(def-mactype :GRABPROC (find-mactype :POINTER))
(def-mactype :GRABCOMPLETEPROC (find-mactype :POINTER))
(def-mactype :DISPLAYPROC (find-mactype :POINTER))
(def-mactype :COMPRESSPROC (find-mactype :POINTER))
(def-mactype :COMPRESSCOMPLETEPROC (find-mactype :POINTER))
(def-mactype :ADDFRAMEPROC (find-mactype :POINTER))
(def-mactype :TRANSFERFRAMEPROC (find-mactype :POINTER))
(def-mactype :GRABCOMPRESSCOMPLETEPROC (find-mactype :POINTER))
(def-mactype :DISPLAYCOMPRESSPROC (find-mactype :POINTER))

(defrecord VideoBottles 
   (procCount :SIGNED-INTEGER)
   (GrabProc :POINTER)
   (GrabCompleteProc :POINTER)
   (DisplayProc :POINTER)
   (CompressProc :POINTER)
   (CompressCompleteProc :POINTER)
   (AddFrameProc :POINTER)
   (TransferFrameProc :POINTER)
   (GrabCompressCompleteProc :POINTER)
   (DisplayCompressProc :POINTER)
   )


(deftrap _SGGETSRCVIDEOBOUNDS ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (R (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C R ((+ (ASH 4 16) 256) :SIGNED-LONGINT)))

(deftrap _SGSETVIDEORECT ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (R :RECT))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C R ((+ (ASH 4 16) 257) :SIGNED-LONGINT)))

(deftrap _SGGETVIDEORECT ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (R (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C R ((+ (ASH 4 16) 258) :SIGNED-LONGINT)))


(deftrap _SGGETVIDEOCOMPRESSORTYPE ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (COMPRESSORTYPE (:POINTER :OSTYPE)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C COMPRESSORTYPE ((+ (ASH 4 16) 259) :SIGNED-LONGINT)))

(deftrap _SGSETVIDEOCOMPRESSORTYPE ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (COMPRESSORTYPE :OSTYPE))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C COMPRESSORTYPE ((+ (ASH 4 16) 260) :SIGNED-LONGINT)))


(deftrap _SGSETVIDEOCOMPRESSOR ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DEPTH :SIGNED-INTEGER) (COMPRESSOR (:POINTER :PRIVATECOMPONENTRECORD)) (SPATIALQUALITY :SIGNED-LONG) (TEMPORALQUALITY :SIGNED-LONG) (KEYFRAMERATE :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C DEPTH COMPRESSOR SPATIALQUALITY TEMPORALQUALITY KEYFRAMERATE ((+ (ASH 18 16) 261) :SIGNED-LONGINT)))

(deftrap _SGGETVIDEOCOMPRESSOR ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DEPTH (:POINTER :SIGNED-INTEGER)) (COMPRESSOR (:POINTER (:POINTER :PRIVATECOMPONENTRECORD))) (SPATIALQUALITY (:POINTER :SIGNED-LONG)) (TEMPORALQUALITY (:POINTER :SIGNED-LONG)) (KEYFRAMERATE (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C DEPTH COMPRESSOR SPATIALQUALITY TEMPORALQUALITY KEYFRAMERATE ((+ (ASH 20 16) 262) :SIGNED-LONGINT)))


(deftrap _SGGETVIDEODIGITIZERCOMPONENT ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK (:POINTER :PRIVATECOMPONENTINSTANCERECORD))
   (:STACK-TRAP #xA82A :D0 0 C ((+ (ASH 0 16) 263) :SIGNED-LONGINT)))

(deftrap _SGSETVIDEODIGITIZERCOMPONENT ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (VDIG (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C VDIG ((+ (ASH 4 16) 264) :SIGNED-LONGINT)))

(deftrap _SGVIDEODIGITIZERCHANGED ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C ((+ (ASH 0 16) 265) :SIGNED-LONGINT)))


(deftrap _SGSETVIDEOBOTTLENECKS ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (VB (:POINTER :VIDEOBOTTLES)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C VB ((+ (ASH 4 16) 266) :SIGNED-LONGINT)))

(deftrap _SGGETVIDEOBOTTLENECKS ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (VB (:POINTER :VIDEOBOTTLES)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C VB ((+ (ASH 4 16) 267) :SIGNED-LONGINT)))


(deftrap _SGGRABFRAME ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BUFFERNUM :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BUFFERNUM ((+ (ASH 2 16) 268) :SIGNED-LONGINT)))

(deftrap _SGGRABFRAMECOMPLETE ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BUFFERNUM :SIGNED-INTEGER) (DONE (:POINTER :BOOLEAN)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BUFFERNUM DONE ((+ (ASH 6 16) 269) :SIGNED-LONGINT)))


(deftrap _SGDISPLAYFRAME ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BUFFERNUM :SIGNED-INTEGER) (MP :MATRIXRECORD) (CLIPRGN (:HANDLE :REGION)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BUFFERNUM MP CLIPRGN ((+ (ASH 10 16) 270) :SIGNED-LONGINT)))

(deftrap _SGCOMPRESSFRAME ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BUFFERNUM :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BUFFERNUM ((+ (ASH 2 16) 271) :SIGNED-LONGINT)))

(deftrap _SGCOMPRESSFRAMECOMPLETE ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BUFFERNUM :SIGNED-INTEGER) (DONE (:POINTER :BOOLEAN)) (CI (:POINTER :SGCOMPRESSINFO)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BUFFERNUM DONE CI ((+ (ASH 10 16) 272) :SIGNED-LONGINT)))

(deftrap _SGADDFRAME ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BUFFERNUM :SIGNED-INTEGER) (ATTIME :SIGNED-LONG) (SCALE :SIGNED-LONG) (CI :SGCOMPRESSINFO))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BUFFERNUM ATTIME SCALE CI ((+ (ASH 14 16) 273) :SIGNED-LONGINT)))


(deftrap _SGTRANSFERFRAMEFORCOMPRESS ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BUFFERNUM :SIGNED-INTEGER) (MP :MATRIXRECORD) (CLIPRGN (:HANDLE :REGION)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BUFFERNUM MP CLIPRGN ((+ (ASH 10 16) 274) :SIGNED-LONGINT)))


(deftrap _SGSETCOMPRESSBUFFER ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DEPTH :SIGNED-INTEGER) (COMPRESSSIZE :RECT))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C DEPTH COMPRESSSIZE ((+ (ASH 6 16) 275) :SIGNED-LONGINT)))


(deftrap _SGGETCOMPRESSBUFFER ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DEPTH (:POINTER :SIGNED-INTEGER)) (COMPRESSSIZE (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C DEPTH COMPRESSSIZE ((+ (ASH 8 16) 276) :SIGNED-LONGINT)))


(deftrap _SGGETBUFFERINFO ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BUFFERNUM :SIGNED-INTEGER) (BUFFERPM (:POINTER (:HANDLE :PIXMAP))) (BUFFERRECT (:POINTER :RECT)) (COMPRESSBUFFER (:POINTER (:POINTER :CGRAFPORT))) (COMPRESSBUFFERRECT (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BUFFERNUM BUFFERPM BUFFERRECT COMPRESSBUFFER COMPRESSBUFFERRECT ((+ (ASH 18 16) 277) :SIGNED-LONGINT)))


(deftrap _SGSETUSESCREENBUFFER ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (USESCREENBUFFER :BOOLEAN))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C USESCREENBUFFER ((+ (ASH 2 16) 278) :SIGNED-LONGINT)))


(deftrap _SGGETUSESCREENBUFFER ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (USESCREENBUFFER (:POINTER :BOOLEAN)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C USESCREENBUFFER ((+ (ASH 4 16) 279) :SIGNED-LONGINT)))


(deftrap _SGGRABCOMPRESSCOMPLETE ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DONE (:POINTER :BOOLEAN)) (CI (:POINTER :SGCOMPRESSINFO)) (TR (:POINTER :TIMERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C DONE CI TR ((+ (ASH 12 16) 280) :SIGNED-LONGINT)))

(deftrap _SGDISPLAYCOMPRESS ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DATAPTR :POINTER) (DESC (:HANDLE :IMAGEDESCRIPTION)) (MP (:POINTER :MATRIXRECORD)) (CLIPRGN (:HANDLE :REGION)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C DATAPTR DESC MP CLIPRGN ((+ (ASH 16 16) 281) :SIGNED-LONGINT)))


(deftrap _SGSETFRAMERATE ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (FRAMERATE :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C FRAMERATE ((+ (ASH 4 16) 282) :SIGNED-LONGINT)))


(deftrap _SGGETFRAMERATE ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (FRAMERATE (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C FRAMERATE ((+ (ASH 4 16) 283) :SIGNED-LONGINT)))

;    Sound Routines   

(deftrap _SGSETSOUNDINPUTDRIVER ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DRIVERNAME (:STRING 255)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C DRIVERNAME ((+ (ASH 4 16) 256) :SIGNED-LONGINT)))

(deftrap _SGGETSOUNDINPUTDRIVER ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C ((+ (ASH 0 16) 257) :SIGNED-LONGINT)))

(deftrap _SGSOUNDINPUTDRIVERCHANGED ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C ((+ (ASH 0 16) 258) :SIGNED-LONGINT)))


(deftrap _SGSETSOUNDRECORDCHUNKSIZE ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SECONDS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C SECONDS ((+ (ASH 4 16) 259) :SIGNED-LONGINT)))

(deftrap _SGGETSOUNDRECORDCHUNKSIZE ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C ((+ (ASH 0 16) 260) :SIGNED-LONGINT)))


(deftrap _SGSETSOUNDINPUTRATE ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (RATE :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C RATE ((+ (ASH 4 16) 261) :SIGNED-LONGINT)))

(deftrap _SGGETSOUNDINPUTRATE ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C ((+ (ASH 0 16) 262) :SIGNED-LONGINT)))


(deftrap _SGSETSOUNDINPUTPARAMETERS ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SAMPLESIZE :SIGNED-INTEGER) (NUMCHANNELS :SIGNED-INTEGER) (COMPRESSIONTYPE :OSTYPE))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C SAMPLESIZE NUMCHANNELS COMPRESSIONTYPE ((+ (ASH 8 16) 263) :SIGNED-LONGINT)))

(deftrap _SGGETSOUNDINPUTPARAMETERS ((C (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SAMPLESIZE (:POINTER :SIGNED-INTEGER)) (NUMCHANNELS (:POINTER :SIGNED-INTEGER)) (COMPRESSIONTYPE (:POINTER :OSTYPE)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C SAMPLESIZE NUMCHANNELS COMPRESSIONTYPE ((+ (ASH 12 16) 264) :SIGNED-LONGINT)))

(defconstant $sgChannelAtom :|chan|)

(defconstant $sgChannelSettingsAtom :|ctom|)
(defconstant $sgChannelDescription :|cdsc|)
(defconstant $sgChannelSettings :|cset|)

(defconstant $sgDeviceNameType :|name|)
(defconstant $sgUsageType :|use |)
(defconstant $sgPlayFlagsType :|plyf|)
(defconstant $sgClipType :|clip|)
(defconstant $sgMatrixType :|mtrx|)
(defconstant $sgVolumeType :|volu|)

(defconstant $sgPanelSettingsAtom :|ptom|)
(defconstant $sgPanelDescription :|pdsc|)
(defconstant $sgPanelSettings :|pset|)

(defconstant $sgcSoundCompressionType :|scmp|)
(defconstant $sgcSoundSampleRateType :|srat|)
(defconstant $sgcSoundChannelCountType :|schn|)
(defconstant $sgcSoundSampleSizeType :|ssiz|)
(defconstant $sgcSoundInputType :|sinp|)
(defconstant $sgcSoundGainType :|gain|)

(defconstant $sgcVideoHueType :|hue |)
(defconstant $sgcVideoSaturationType :|satr|)
(defconstant $sgcVideoContrastType :|trst|)
(defconstant $sgcVideoSharpnessType :|shrp|)
(defconstant $sgcVideoBrigtnessType :|brit|)
(defconstant $sgcVideoBlackLevelType :|blkl|)
(defconstant $sgcVideoWhiteLevelType :|whtl|)

(defconstant $sgcVideoInputType :|vinp|)
(defconstant $sgcVideoFormatType :|vstd|)
(defconstant $sgcVideoFilterType :|vflt|)

(defconstant $sgcVideoRectType :|vrct|)
(defconstant $sgVideoDigitizerType :|vdig|)

(defconstant $noDeviceForChannel -9400)
(defconstant $grabTimeComplete -9401)
(defconstant $cantDoThatInCurrentMode -9402)
(defconstant $notEnoughMemoryToGrab -9403)
(defconstant $notEnoughDiskSpaceToGrab -9404)
(defconstant $couldntGetRequiredComponent -9405)
(defconstant $badSGChannel -9406)
(defconstant $seqGrabInfoNotAvailable -9407)
(defconstant $deviceCantMeetRequest -9408)

(defconstant $kSGInitializeSelect #X1)
(defconstant $kSGSetDataOutputSelect #X2)
(defconstant $kSGGetDataOutputSelect #X3)
(defconstant $kSGSetGWorldSelect #X4)
(defconstant $kSGGetGWorldSelect #X5)
(defconstant $kSGNewChannelSelect #X6)
(defconstant $kSGDisposeChannelSelect #X7)
(defconstant $kSGStartPreviewSelect #X10)
(defconstant $kSGStartRecordSelect #X11)
(defconstant $kSGIdleSelect #X12)
(defconstant $kSGStopSelect #X13)
(defconstant $kSGPauseSelect #X14)
(defconstant $kSGPrepareSelect #X15)
(defconstant $kSGReleaseSelect #X16)
(defconstant $kSGGetMovieSelect #X17)
(defconstant $kSGSetMaximumRecordTimeSelect #X18)
(defconstant $kSGGetMaximumRecordTimeSelect #X19)
(defconstant $kSGGetStorageSpaceRemainingSelect #X1A)
(defconstant $kSGGetTimeRemainingSelect #X1B)
(defconstant $kSGGrabPictSelect #X1C)
(defconstant $kSGGetLastMovieResIDSelect #X1D)
(defconstant $kSGSetFlagsSelect #X1E)
(defconstant $kSGGetFlagsSelect #X1F)

(defconstant $kSGSetDataProcSelect #X20)
(defconstant $kSGNewChannelFromComponentSelect #X21)
(defconstant $kSGDisposeDeviceListSelect #X22)
(defconstant $kSGAppendDeviceListToMenuSelect #X23)
(defconstant $kSGSetSettingsSelect #X24)
(defconstant $kSGGetSettingsSelect #X25)
(defconstant $kSGGetIndChannelSelect #X26)
(defconstant $kSGUpdateSelect #X27)
(defconstant $kSGGetPauseSelect #X28)
(defconstant $kSGSettingsDialogSelect #X29)
(defconstant $kSGGetAlignmentProcSelect #X2A)
(defconstant $kSGSetChannelSettingsSelect #X2B)
(defconstant $kSGGetChannelSettingsSelect #X2C)

(defconstant $kSGWriteMovieDataSelect #X100)
(defconstant $kSGAddFrameReferenceSelect #X101)
(defconstant $kSGGetNextFrameReferenceSelect #X102)
(defconstant $kSGGetTimeBaseSelect #X103)
(defconstant $kSGSortDeviceListSelect #X104)
(defconstant $kSGAddMovieDataSelect #X105)
(defconstant $kSGChangedSourceSelect #X106)

(defconstant $kSGCSetChannelUsageSelect #X80)
(defconstant $kSGCGetChannelUsageSelect #X81)
(defconstant $kSGCSetChannelBoundsSelect #X82)
(defconstant $kSGCGetChannelBoundsSelect #X83)
(defconstant $kSGCSetChannelVolumeSelect #X84)
(defconstant $kSGCGetChannelVolumeSelect #X85)
(defconstant $kSGCGetChannelInfoSelect #X86)
(defconstant $kSGCSetChannelPlayFlagsSelect #X87)
(defconstant $kSGCGetChannelPlayFlagsSelect #X88)
(defconstant $kSGCSetChannelMaxFramesSelect #X89)
(defconstant $kSGCGetChannelMaxFramesSelect #X8A)
(defconstant $kSGCSetChannelRefConSelect #X8B)
(defconstant $kSGCSetChannelClipSelect #X8C)
(defconstant $kSGCGetChannelClipSelect #X8D)
(defconstant $kSGCGetChannelSampleDescriptionSelect #X8E)
(defconstant $kSGCGetChannelDeviceListSelect #X8F)
(defconstant $kSGCSetChannelDeviceSelect #X90)
(defconstant $kSGCSetChannelMatrixSelect #X91)
(defconstant $kSGCGetChannelMatrixSelect #X92)
(defconstant $kSGCGetChannelTimeScaleSelect #X93)

(defconstant $kSGCInitChannelSelect #X180)
(defconstant $kSGCWriteSamplesSelect #X181)
(defconstant $kSGCGetDataRateSelect #X182)
(defconstant $kSGCAlignChannelRectSelect #X183)

(defconstant $kSGCPanelGetDitlSelect #X200)
(defconstant $kSGCPanelGetTitleSelect #X201)
(defconstant $kSGCPanelCanRunSelect #X202)
(defconstant $kSGCPanelInstallSelect #X203)
(defconstant $kSGCPanelEventSelect #X204)
(defconstant $kSGCPanelItemSelect #X205)
(defconstant $kSGCPanelRemoveSelect #X206)
(defconstant $kSGCPanelSetGrabberSelect #X207)
(defconstant $kSGCPanelSetResFileSelect #X208)
(defconstant $kSGCPanelGetSettingsSelect #X209)
(defconstant $kSGCPanelSetSettingsSelect #X20A)
(defconstant $kSGCPanelValidateInputSelect #X20B)

(defconstant $kSGCGetSrcVideoBoundsSelect #X100)
(defconstant $kSGCSetVideoRectSelect #X101)
(defconstant $kSGCGetVideoRectSelect #X102)
(defconstant $kSGCGetVideoCompressorTypeSelect #X103)
(defconstant $kSGCSetVideoCompressorTypeSelect #X104)
(defconstant $kSGCSetVideoCompressorSelect #X105)
(defconstant $kSGCGetVideoCompressorSelect #X106)
(defconstant $kSGCGetVideoDigitizerComponentSelect #X107)
(defconstant $kSGCSetVideoDigitizerComponentSelect #X108)
(defconstant $kSGCVideoDigitizerChangedSelect #X109)
(defconstant $kSGCSetVideoBottlenecksSelect #X10A)
(defconstant $kSGCGetVideoBottlenecksSelect #X10B)
(defconstant $kSGCGrabFrameSelect #X10C)
(defconstant $kSGCGrabFrameCompleteSelect #X10D)
(defconstant $kSGCDisplayFrameSelect #X10E)
(defconstant $kSGCCompressFrameSelect #X10F)
(defconstant $kSGCCompressFrameCompleteSelect #X110)
(defconstant $kSGCAddFrameSelect #X111)
(defconstant $kSGCTransferFrameForCompressSelect #X112)
(defconstant $kSGCSetCompressBufferSelect #X113)
(defconstant $kSGCGetCompressBufferSelect #X114)
(defconstant $kSGCGetBufferInfoSelect #X115)
(defconstant $kSGCSetUseScreenBufferSelect #X116)
(defconstant $kSGCGetUseScreenBufferSelect #X117)
(defconstant $kSGCGrabCompressCompleteSelect #X118)
(defconstant $kSGCDisplayCompressSelect #X119)
(defconstant $kSGCSetFrameRateSelect #X11A)
(defconstant $kSGCGetFrameRateSelect #X11B)

(defconstant $kSGCSetSoundInputDriverSelect #X100)
(defconstant $kSGCGetSoundInputDriverSelect #X101)
(defconstant $kSGCSoundInputDriverChangedSelect #X102)
(defconstant $kSGCSetSoundRecordChunkSizeSelect #X103)
(defconstant $kSGCGetSoundRecordChunkSizeSelect #X104)
(defconstant $kSGCSetSoundInputRateSelect #X105)
(defconstant $kSGCGetSoundInputRateSelect #X106)
(defconstant $kSGCSetSoundInputParametersSelect #X107)
(defconstant $kSGCGetSoundInputParametersSelect #X108)

; 
;  Video Digitizer Component
; 
; 
;   Standard type for video digitizers 
(defconstant $videoDigitizerComponentType :|vdig|)
(defconstant $vdigInterfaceRev 2)

;  Input Format Standards 
(defconstant $ntscIn 0)         ;  ntsc input format 
(defconstant $currentIn 0)
(defconstant $palIn 1)          ;  pal input format 
(defconstant $secamIn 2)        ;  secam input format 
(defconstant $ntscReallyIn 3)

;  Input Formats 
(defconstant $compositeIn 0)    ;  input is composite format 
(defconstant $sVideoIn 1)       ;  input is sVideo format 
(defconstant $rgbComponentIn 2) ;  input is rgb component format 

;  Video Digitizer PlayThru States 
(defconstant $vdPlayThruOff 0)
(defconstant $vdPlayThruOn 1)

;  Input Color Space Modes 
(defconstant $vdDigitizerBW 0)  ;  black and white 
(defconstant $vdDigitizerRGB 1) ;  rgb color 

;  Phase Lock Loop Modes 
(defconstant $vdBroadcastMode 0);  Broadcast / Laser Disk video mode 
(defconstant $vdVTRMode 1)      ;  VCR / Magnetic media mode 

;  Field Select Options 
(defconstant $vdUseAnyField 0)
(defconstant $vdUseOddField 1)
(defconstant $vdUseEvenField 2)

;  vdig types 
(defconstant $vdTypeBasic 0)    ;  basic, no clipping 
(defconstant $vdTypeAlpha 1)    ;  supports clipping with alpha channel 
(defconstant $vdTypeMask 2)     ;  supports clipping with mask plane 
(defconstant $vdTypeKey 3)      ;  supports clipping with key color(s) 

;  Digitizer Error Codes 
(defconstant $digiUnimpErr -2201);  feature unimplemented 
(defconstant $qtParamErr -2202) ;  bad input parameter ( out of range, etc ) 
(defconstant $matrixErr -2203)  ;  bad matrix, digitizer did nothing 
(defconstant $notExactMatrix -2204);  warning of bad matrix, digitizer did its best 
(defconstant $noMoreKeyColors -2205);  all key indexes in use 
(defconstant $notExactSize -2206);  Cant do exact size requested 
(defconstant $badDepth -2207)   ;  Cant digitize into this depth 
(defconstant $noDMA -2208)      ;  Cant do DMA digitizing ( i.e. can't go to requested dest 
(defconstant $badCallOrder -2209);  Usually due to a status call being called prior to being setup first 

;  Digitizer Input Capability/Current Flags 
(defconstant $digiInDoesNTSC #X1);  digitizer supports NTSC input format 
(defconstant $digiInDoesPAL #X2);  digitizer supports PAL input format 
(defconstant $digiInDoesSECAM #X4);  digitizer supports SECAM input format 
(defconstant $digiInDoesGenLock #X80);  digitizer does genlock 

(defconstant $digiInDoesComposite #X100);  digitizer supports composite input type 
(defconstant $digiInDoesSVideo #X200);  digitizer supports S-Video input type 
(defconstant $digiInDoesComponent #X400);  digitizer supports component (rgb) input type 
(defconstant $digiInVTR_Broadcast #X800);  digitizer can differentiate between the two 

(defconstant $digiInDoesColor #X1000);  digitizer supports color 
(defconstant $digiInDoesBW #X2000);  digitizer supports black & white 

;  Digitizer Input Current Flags (these are valid only during active operating conditions) 
(defconstant $digiInSignalLock #X80000000);  digitizer detects input signal is locked - this bit = horiz lock || vertical lock 

;  Digitizer Output Capability/Current Flags 
(defconstant $digiOutDoes1 #X1) ;  digitizer supports 1 bit pixels 
(defconstant $digiOutDoes2 #X2) ;  digitizer supports 2 bit pixels 
(defconstant $digiOutDoes4 #X4) ;  digitizer supports 4 bit pixels 
(defconstant $digiOutDoes8 #X8) ;  digitizer supports 8 bit pixels 
(defconstant $digiOutDoes16 #X10);  digitizer supports 16 bit pixels 
(defconstant $digiOutDoes32 #X20);  digitizer supports 32 bit pixels 
(defconstant $digiOutDoesDither #X40);  digitizer dithers in indexed modes 
(defconstant $digiOutDoesStretch #X80);  digitizer can arbitrarily stretch 
(defconstant $digiOutDoesShrink #X100);  digitizer can arbitrarily shrink 
(defconstant $digiOutDoesMask #X200);  digitizer can mask to clipping regions 

(defconstant $digiOutDoesDouble #X800);  digitizer can stretch to exactly double size 
(defconstant $digiOutDoesQuad #X1000);  digitizer can stretch exactly quadruple size 
(defconstant $digiOutDoesQuarter #X2000);  digitizer can shrink to exactly quarter size 
(defconstant $digiOutDoesSixteenth #X4000);  digitizer can shrink to exactly sixteenth size 

(defconstant $digiOutDoesRotate #X8000);  digitizer supports rotate transformations 
(defconstant $digiOutDoesHorizFlip #X10000);  digitizer supports horizontal flips Sx < 0 
(defconstant $digiOutDoesVertFlip #X20000);  digitizer supports vertical flips Sy < 0 
(defconstant $digiOutDoesSkew #X40000);  digitizer supports skew (shear, twist) 
(defconstant $digiOutDoesBlend #X80000)
(defconstant $digiOutDoesWarp #X100000)

(defconstant $digiOutDoesHW_DMA #X200000);  digitizer not constrained to local device 
(defconstant $digiOutDoesHWPlayThru #X400000);  digitizer doesn't need time to play thru 
(defconstant $digiOutDoesILUT #X800000);  digitizer does inverse LUT for index modes 
(defconstant $digiOutDoesKeyColor #X1000000);  digitizer does key color functions too 
(defconstant $digiOutDoesAsyncGrabs #X2000000);  digitizer supports async grabs 
(defconstant $digiOutDoesUnreadableScreenBits #X4000000); playthru doesn't generate readable bits on screen
(defconstant $digiOutDoesCompress #X8000000);  supports alternate output data types 
(defconstant $digiOutDoesCompressOnly #X10000000);  can't provide raw frames anywhere 
(defconstant $digiOutDoesPlayThruDuringCompress #X2000000);  digi can do playthru while providing compressed data 

(def-mactype :VIDEODIGITIZERCOMPONENT (find-mactype :POINTER))
(def-mactype :VIDEODIGITIZERERROR (find-mactype :SIGNED-LONG))

;  Types 
(defrecord DigitizerInfo 
   (vdigType :SIGNED-INTEGER)
   (inputCapabilityFlags :SIGNED-LONG)
   (outputCapabilityFlags :SIGNED-LONG)
   (inputCurrentFlags :SIGNED-LONG)
   (outputCurrentFlags :SIGNED-LONG)
   (slot :SIGNED-INTEGER)       ;  temporary for connection purposes 
   (gdh (:HANDLE :GDEVICE))     ;  temporary for digitizers that have preferred screen 
   (maskgdh (:HANDLE :GDEVICE)) ;  temporary for digitizers that have mask planes 
   (minDestHeight :SIGNED-INTEGER);  Smallest resizable height 
   (minDestWidth :SIGNED-INTEGER);  Smallest resizable width 
   (maxDestHeight :SIGNED-INTEGER);  Largest resizable height 
   (maxDestWidth :SIGNED-INTEGER);  Largest resizable height 
   (blendLevels :SIGNED-INTEGER);  Number of blend levels supported (2 if 1 bit mask) 
   (Private :SIGNED-LONG)       ;  reserved 
   )

(defrecord VdigType 
   (digType :SIGNED-LONG)
   (Private :SIGNED-LONG)
   )

(def-mactype :VDIGTYPELISTPTR (find-mactype :POINTER))
(def-mactype :VDIGTYPELISTHANDLE (find-mactype :HANDLE))
(defrecord (VdigTypeList :handle) 
   (count :SIGNED-INTEGER)
   (list (:ARRAY :VDIGTYPE 1))
   )

(defrecord VdigBufferRec 
   (dest (:HANDLE :PIXMAP))
   (location :POINT)
   (reserved :SIGNED-LONG)
   )

(def-mactype :VDIGBUFFERRECLISTPTR (find-mactype :POINTER))
(def-mactype :VDIGBUFFERRECLISTHANDLE (find-mactype :HANDLE))
(defrecord (VdigBufferRecList :handle) 
   (count :SIGNED-INTEGER)
   (matrix (:POINTER :MATRIXRECORD))
   (mask (:HANDLE :REGION))
   (list (:ARRAY :VDIGBUFFERREC 1))
   )

(def-mactype :VDIGINTPROC (find-mactype :POINTER))

(def-mactype :VDCOMPRESSIONLISTPTR (find-mactype :POINTER))
(def-mactype :VDCOMPRESSIONLISTHANDLE (find-mactype :HANDLE))
(defrecord (VDCompressionList :handle) 
   (codec (:POINTER :PRIVATECOMPONENTRECORD))
   (cType :OSTYPE)
   (typeName (:STRING 63))
   (name (:STRING 63))
   (formatFlags :SIGNED-LONG)
   (compressFlags :SIGNED-LONG)
   (reserved :SIGNED-LONG)
   )

(defconstant $dmaDepth1 1)
(defconstant $dmaDepth2 2)
(defconstant $dmaDepth4 4)
(defconstant $dmaDepth8 8)
(defconstant $dmaDepth16 #X10)
(defconstant $dmaDepth32 #X20)
(defconstant $dmaDepth2Gray #X40)
(defconstant $dmaDepth4Gray #X80)
(defconstant $dmaDepth8Gray #X100)

(defconstant $kvdigSelectors #X52)


(deftrap _VDGETMAXSRCRECT ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (INPUTSTD :SIGNED-INTEGER) (MAXSRCRECT (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUTSTD MAXSRCRECT ((+ (ASH 6 16) 1) :SIGNED-LONGINT)))

(deftrap _VDGETACTIVESRCRECT ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (INPUTSTD :SIGNED-INTEGER) (ACTIVESRCRECT (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUTSTD ACTIVESRCRECT ((+ (ASH 6 16) 2) :SIGNED-LONGINT)))

(deftrap _VDSETDIGITIZERRECT ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DIGITIZERRECT (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI DIGITIZERRECT ((+ (ASH 4 16) 3) :SIGNED-LONGINT)))

(deftrap _VDGETDIGITIZERRECT ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DIGITIZERRECT (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI DIGITIZERRECT ((+ (ASH 4 16) 4) :SIGNED-LONGINT)))

(deftrap _VDGETVBLANKRECT ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (INPUTSTD :SIGNED-INTEGER) (VBLANKRECT (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUTSTD VBLANKRECT ((+ (ASH 6 16) 5) :SIGNED-LONGINT)))

(deftrap _VDGETMASKPIXMAP ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (MASKPIXMAP (:HANDLE :PIXMAP)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI MASKPIXMAP ((+ (ASH 4 16) 6) :SIGNED-LONGINT)))

(deftrap _VDGETPLAYTHRUDESTINATION ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DEST (:POINTER (:HANDLE :PIXMAP))) (DESTRECT (:POINTER :RECT)) (M (:POINTER :MATRIXRECORD)) (MASK (:POINTER (:HANDLE :REGION))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI DEST DESTRECT M MASK ((+ (ASH 16 16) 8) :SIGNED-LONGINT)))

(deftrap _VDUSETHISCLUT ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (COLORTABLEHANDLE (:HANDLE :COLORTABLE)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI COLORTABLEHANDLE ((+ (ASH 4 16) 9) :SIGNED-LONGINT)))

(deftrap _VDSETINPUTGAMMAVALUE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (CHANNEL1 :SIGNED-LONG) (CHANNEL2 :SIGNED-LONG) (CHANNEL3 :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI CHANNEL1 CHANNEL2 CHANNEL3 ((+ (ASH 12 16) 10) :SIGNED-LONGINT)))

(deftrap _VDGETINPUTGAMMAVALUE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (CHANNEL1 (:POINTER :SIGNED-LONG)) (CHANNEL2 (:POINTER :SIGNED-LONG)) (CHANNEL3 (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI CHANNEL1 CHANNEL2 CHANNEL3 ((+ (ASH 12 16) 11) :SIGNED-LONGINT)))

(deftrap _VDSETBRIGHTNESS ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BRIGHTNESS (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BRIGHTNESS ((+ (ASH 4 16) 12) :SIGNED-LONGINT)))

(deftrap _VDGETBRIGHTNESS ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BRIGHTNESS (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BRIGHTNESS ((+ (ASH 4 16) 13) :SIGNED-LONGINT)))

(deftrap _VDSETCONTRAST ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (CONTRAST (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI CONTRAST ((+ (ASH 4 16) 14) :SIGNED-LONGINT)))

(deftrap _VDSETHUE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (HUE (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI HUE ((+ (ASH 4 16) 15) :SIGNED-LONGINT)))

(deftrap _VDSETSHARPNESS ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SHARPNESS (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI SHARPNESS ((+ (ASH 4 16) 16) :SIGNED-LONGINT)))

(deftrap _VDSETSATURATION ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SATURATION (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI SATURATION ((+ (ASH 4 16) 17) :SIGNED-LONGINT)))

(deftrap _VDGETCONTRAST ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (CONTRAST (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI CONTRAST ((+ (ASH 4 16) 18) :SIGNED-LONGINT)))

(deftrap _VDGETHUE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (HUE (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI HUE ((+ (ASH 4 16) 19) :SIGNED-LONGINT)))

(deftrap _VDGETSHARPNESS ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SHARPNESS (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI SHARPNESS ((+ (ASH 4 16) 20) :SIGNED-LONGINT)))

(deftrap _VDGETSATURATION ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SATURATION (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI SATURATION ((+ (ASH 4 16) 21) :SIGNED-LONGINT)))

(deftrap _VDGRABONEFRAME ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI ((+ (ASH 0 16) 22) :SIGNED-LONGINT)))

(deftrap _VDGETMAXAUXBUFFER ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (PM (:POINTER (:HANDLE :PIXMAP))) (R (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI PM R ((+ (ASH 8 16) 23) :SIGNED-LONGINT)))

(deftrap _VDGETDIGITIZERINFO ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (INFO (:POINTER :DIGITIZERINFO)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INFO ((+ (ASH 4 16) 25) :SIGNED-LONGINT)))

(deftrap _VDGETCURRENTFLAGS ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (INPUTCURRENTFLAG (:POINTER :SIGNED-LONG)) (OUTPUTCURRENTFLAG (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUTCURRENTFLAG OUTPUTCURRENTFLAG ((+ (ASH 8 16) 26) :SIGNED-LONGINT)))

(deftrap _VDSETKEYCOLOR ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (INDEX :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INDEX ((+ (ASH 4 16) 27) :SIGNED-LONGINT)))

(deftrap _VDGETKEYCOLOR ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (INDEX (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INDEX ((+ (ASH 4 16) 28) :SIGNED-LONGINT)))

(deftrap _VDADDKEYCOLOR ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (INDEX (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INDEX ((+ (ASH 4 16) 29) :SIGNED-LONGINT)))

(deftrap _VDGETNEXTKEYCOLOR ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (INDEX :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INDEX ((+ (ASH 4 16) 30) :SIGNED-LONGINT)))

(deftrap _VDSETKEYCOLORRANGE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (MINRGB (:POINTER :RGBCOLOR)) (MAXRGB (:POINTER :RGBCOLOR)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI MINRGB MAXRGB ((+ (ASH 8 16) 31) :SIGNED-LONGINT)))

(deftrap _VDGETKEYCOLORRANGE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (MINRGB (:POINTER :RGBCOLOR)) (MAXRGB (:POINTER :RGBCOLOR)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI MINRGB MAXRGB ((+ (ASH 8 16) 32) :SIGNED-LONGINT)))

(deftrap _VDSETDIGITIZERUSERINTERRUPT ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (FLAGS :SIGNED-LONG) (USERINTERRUPTPROC :POINTER) (REFCON :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI FLAGS USERINTERRUPTPROC REFCON ((+ (ASH 12 16) 33) :SIGNED-LONGINT)))

(deftrap _VDSETINPUTCOLORSPACEMODE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (COLORSPACEMODE :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI COLORSPACEMODE ((+ (ASH 2 16) 34) :SIGNED-LONGINT)))

(deftrap _VDGETINPUTCOLORSPACEMODE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (COLORSPACEMODE (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI COLORSPACEMODE ((+ (ASH 4 16) 35) :SIGNED-LONGINT)))

(deftrap _VDSETCLIPSTATE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (CLIPENABLE :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI CLIPENABLE ((+ (ASH 2 16) 36) :SIGNED-LONGINT)))

(deftrap _VDGETCLIPSTATE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (CLIPENABLE (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI CLIPENABLE ((+ (ASH 4 16) 37) :SIGNED-LONGINT)))

(deftrap _VDSETCLIPRGN ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (CLIPREGION (:HANDLE :REGION)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI CLIPREGION ((+ (ASH 4 16) 38) :SIGNED-LONGINT)))

(deftrap _VDCLEARCLIPRGN ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (CLIPREGION (:HANDLE :REGION)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI CLIPREGION ((+ (ASH 4 16) 39) :SIGNED-LONGINT)))

(deftrap _VDGETCLUTINUSE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (COLORTABLEHANDLE (:POINTER (:HANDLE :COLORTABLE))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI COLORTABLEHANDLE ((+ (ASH 4 16) 40) :SIGNED-LONGINT)))

(deftrap _VDSETPLLFILTERTYPE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (PLLTYPE :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI PLLTYPE ((+ (ASH 2 16) 41) :SIGNED-LONGINT)))

(deftrap _VDGETPLLFILTERTYPE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (PLLTYPE (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI PLLTYPE ((+ (ASH 4 16) 42) :SIGNED-LONGINT)))

(deftrap _VDGETMASKANDVALUE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BLENDLEVEL :SIGNED-INTEGER) (MASK (:POINTER :SIGNED-LONG)) (VALUE (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BLENDLEVEL MASK VALUE ((+ (ASH 10 16) 43) :SIGNED-LONGINT)))

(deftrap _VDSETMASTERBLENDLEVEL ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BLENDLEVEL (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BLENDLEVEL ((+ (ASH 4 16) 44) :SIGNED-LONGINT)))

(deftrap _VDSETPLAYTHRUDESTINATION ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DEST (:HANDLE :PIXMAP)) (DESTRECT (:POINTER :RECT)) (M (:POINTER :MATRIXRECORD)) (MASK (:HANDLE :REGION)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI DEST DESTRECT M MASK ((+ (ASH 16 16) 45) :SIGNED-LONGINT)))

(deftrap _VDSETPLAYTHRUONOFF ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (STATE :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI STATE ((+ (ASH 2 16) 46) :SIGNED-LONGINT)))

(deftrap _VDSETFIELDPREFERENCE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (FIELDFLAG :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI FIELDFLAG ((+ (ASH 2 16) 47) :SIGNED-LONGINT)))

(deftrap _VDGETFIELDPREFERENCE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (FIELDFLAG (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI FIELDFLAG ((+ (ASH 4 16) 48) :SIGNED-LONGINT)))

(deftrap _VDPREFLIGHTDESTINATION ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DIGITIZERRECT (:POINTER :RECT)) (DEST (:HANDLE :PIXMAP)) (DESTRECT (:POINTER :RECT)) (M (:POINTER :MATRIXRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI DIGITIZERRECT DEST DESTRECT M ((+ (ASH 16 16) 50) :SIGNED-LONGINT)))

(deftrap _VDPREFLIGHTGLOBALRECT ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (THEWINDOW (:POINTER :GRAFPORT)) (GLOBALRECT (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI THEWINDOW GLOBALRECT ((+ (ASH 8 16) 51) :SIGNED-LONGINT)))

(deftrap _VDSETPLAYTHRUGLOBALRECT ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (THEWINDOW (:POINTER :GRAFPORT)) (GLOBALRECT (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI THEWINDOW GLOBALRECT ((+ (ASH 8 16) 52) :SIGNED-LONGINT)))

(deftrap _VDSETINPUTGAMMARECORD ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (INPUTGAMMAPTR (:POINTER :VDGAMMARECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUTGAMMAPTR ((+ (ASH 4 16) 53) :SIGNED-LONGINT)))

(deftrap _VDGETINPUTGAMMARECORD ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (INPUTGAMMAPTR (:POINTER (:POINTER :VDGAMMARECORD))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUTGAMMAPTR ((+ (ASH 4 16) 54) :SIGNED-LONGINT)))

(deftrap _VDSETBLACKLEVELVALUE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BLACKLEVEL (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BLACKLEVEL ((+ (ASH 4 16) 55) :SIGNED-LONGINT)))

(deftrap _VDGETBLACKLEVELVALUE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BLACKLEVEL (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BLACKLEVEL ((+ (ASH 4 16) 56) :SIGNED-LONGINT)))

(deftrap _VDSETWHITELEVELVALUE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (WHITELEVEL (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI WHITELEVEL ((+ (ASH 4 16) 57) :SIGNED-LONGINT)))

(deftrap _VDGETWHITELEVELVALUE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (WHITELEVEL (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI WHITELEVEL ((+ (ASH 4 16) 58) :SIGNED-LONGINT)))

(deftrap _VDGETVIDEODEFAULTS ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BLACKLEVEL (:POINTER :SIGNED-INTEGER)) (WHITELEVEL (:POINTER :SIGNED-INTEGER)) (BRIGHTNESS (:POINTER :SIGNED-INTEGER)) (HUE (:POINTER :SIGNED-INTEGER)) (SATURATION (:POINTER :SIGNED-INTEGER)) (CONTRAST (:POINTER :SIGNED-INTEGER)) (SHARPNESS (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BLACKLEVEL WHITELEVEL BRIGHTNESS HUE SATURATION CONTRAST SHARPNESS ((+ (ASH 28 16) 59) :SIGNED-LONGINT)))

(deftrap _VDGETNUMBEROFINPUTS ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (INPUTS (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUTS ((+ (ASH 4 16) 60) :SIGNED-LONGINT)))

(deftrap _VDGETINPUTFORMAT ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (INPUT :SIGNED-INTEGER) (FORMAT (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUT FORMAT ((+ (ASH 6 16) 61) :SIGNED-LONGINT)))

(deftrap _VDSETINPUT ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (INPUT :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUT ((+ (ASH 2 16) 62) :SIGNED-LONGINT)))

(deftrap _VDGETINPUT ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (INPUT (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUT ((+ (ASH 4 16) 63) :SIGNED-LONGINT)))

(deftrap _VDSETINPUTSTANDARD ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (INPUTSTANDARD :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUTSTANDARD ((+ (ASH 2 16) 64) :SIGNED-LONGINT)))

(deftrap _VDSETUPBUFFERS ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BUFFERLIST (:HANDLE :VDIGBUFFERRECLIST)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BUFFERLIST ((+ (ASH 4 16) 65) :SIGNED-LONGINT)))

(deftrap _VDGRABONEFRAMEASYNC ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BUFFER :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BUFFER ((+ (ASH 2 16) 66) :SIGNED-LONGINT)))

(deftrap _VDDONE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BUFFER :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BUFFER ((+ (ASH 2 16) 67) :SIGNED-LONGINT)))

(deftrap _VDSETCOMPRESSION ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (COMPRESSTYPE :OSTYPE) (DEPTH :SIGNED-INTEGER) (BOUNDS (:POINTER :RECT)) (SPATIALQUALITY :SIGNED-LONG) (TEMPORALQUALITY :SIGNED-LONG) (KEYFRAMERATE :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI COMPRESSTYPE DEPTH BOUNDS SPATIALQUALITY TEMPORALQUALITY KEYFRAMERATE ((+ (ASH 22 16) 68) :SIGNED-LONGINT)))


(deftrap _VDCOMPRESSONEFRAMEASYNC ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI ((+ (ASH 0 16) 69) :SIGNED-LONGINT)))

;  See CompressSequenceFrame in ImageCompression.p for the reason behind this massive glue 

#| Not in ROM - INLINE =  #x206F #x0004 #x4250 #x52AF #x0004 #x2F3C #x0014 #x0046 #x7000 #xA82A |#
; hand translated
(deftrap _VDCOMPRESSDONE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DONE (:POINTER :BOOLEAN)) (THEDATA (:POINTER :POINTER)) (DATASIZE (:POINTER :SIGNED-LONG)) (SIMILARITY (:POINTER :UNSIGNED-BYTE)) (TIME (:POINTER :TIMERECORD)))
   (:no-trap :SIGNED-LONG)
   (:no-trap
    (ccl::with-macptrs ((incd-time (%inc-ptr time 1)))
      (setf (%get-word time) 0)
      (ccl::stack-trap #xa82a :d0 0
                       :long ci
                       :long done
                       :long thedata
                       :long datasize
                       :long similarity
                       :long incd-time
                       :long #x140046))))


(deftrap _VDRELEASECOMPRESSBUFFER ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BUFFERADDR :POINTER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BUFFERADDR ((+ (ASH 4 16) 71) :SIGNED-LONGINT)))


(deftrap _VDGETIMAGEDESCRIPTION ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DESC (:HANDLE :IMAGEDESCRIPTION)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI DESC ((+ (ASH 4 16) 72) :SIGNED-LONGINT)))


(deftrap _VDRESETCOMPRESSSEQUENCE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI ((+ (ASH 0 16) 73) :SIGNED-LONGINT)))


(deftrap _VDSETCOMPRESSIONONOFF ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (STATE :BOOLEAN))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI STATE ((+ (ASH 2 16) 74) :SIGNED-LONGINT)))


(deftrap _VDGETCOMPRESSIONTYPES ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (H (:HANDLE :VDCOMPRESSIONLIST)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI H ((+ (ASH 4 16) 75) :SIGNED-LONGINT)))


(deftrap _VDSETTIMEBASE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (TIME (:POINTER :TIMEBASERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI TIME ((+ (ASH 4 16) 76) :SIGNED-LONGINT)))


(deftrap _VDSETFRAMERATE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (FRAMESPERSECOND :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI FRAMESPERSECOND ((+ (ASH 4 16) 77) :SIGNED-LONGINT)))


(deftrap _VDGETDATARATE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (MILLISECPERFRAME (:POINTER :SIGNED-LONG)) (FRAMESPERSECOND (:POINTER :SIGNED-LONG)) (BYTESPERSECOND (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI MILLISECPERFRAME FRAMESPERSECOND BYTESPERSECOND ((+ (ASH 12 16) 78) :SIGNED-LONGINT)))


(deftrap _VDGETSOUNDINPUTDRIVER ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SOUNDDRIVERNAME (:STRING 255)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI SOUNDDRIVERNAME ((+ (ASH 4 16) 79) :SIGNED-LONGINT)))


(deftrap _VDGETDMADEPTHS ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DEPTHARRAY (:POINTER :SIGNED-LONG)) (PREFERREDDEPTH (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI DEPTHARRAY PREFERREDDEPTH ((+ (ASH 8 16) 80) :SIGNED-LONGINT)))


(deftrap _VDGETPREFERREDTIMESCALE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (PREFERRED (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI PREFERRED ((+ (ASH 4 16) 81) :SIGNED-LONGINT)))


(deftrap _VDRELEASEASYNCBUFFERS ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI ((+ (ASH 0 16) 82) :SIGNED-LONGINT)))

;  Video Digitizer Interface 
(defconstant $kSelectVDGetMaxSrcRect #X1)
(defconstant $kSelectVDGetActiveSrcRect #X2)
(defconstant $kSelectVDSetDigitizerRect #X3)
(defconstant $kSelectVDGetDigitizerRect #X4)
(defconstant $kSelectVDGetVBlankRect #X5)
(defconstant $kSelectVDGetMaskPixMap #X6)
(defconstant $kSelectVDGetPlayThruDestination #X8)
(defconstant $kSelectVDUseThisCLUT #X9)
(defconstant $kSelectVDSetInputGammaValue #XA)
(defconstant $kSelectVDGetInputGammaValue #XB)
(defconstant $kSelectVDSetBrightness #XC)
(defconstant $kSelectVDGetBrightness #XD)
(defconstant $kSelectVDSetContrast #XE)
(defconstant $kSelectVDSetHue #XF)
(defconstant $kSelectVDSetSharpness #X10)
(defconstant $kSelectVDSetSaturation #X11)
(defconstant $kSelectVDGetContrast #X12)
(defconstant $kSelectVDGetHue #X13)
(defconstant $kSelectVDGetSharpness #X14)
(defconstant $kSelectVDGetSaturation #X15)
(defconstant $kSelectVDGrabOneFrame #X16)
(defconstant $kSelectVDGetMaxAuxBuffer #X17)
(defconstant $kSelectVDGetDigitizerInfo #X19)
(defconstant $kSelectVDGetCurrentFlags #X1A)
(defconstant $kSelectVDSetKeyColor #X1B)
(defconstant $kSelectVDGetKeyColor #X1C)
(defconstant $kSelectVDAddKeyColor #X1D)
(defconstant $kSelectVDGetNextKeyColor #X1E)
(defconstant $kSelectVDSetKeyColorRange #X1F)
(defconstant $kSelectVDGetKeyColorRange #X20)
(defconstant $kSelectVDSetDigitizerUserInterrupt #X21)
(defconstant $kSelectVDSetInputColorSpaceMode #X22)
(defconstant $kSelectVDGetInputColorSpaceMode #X23)
(defconstant $kSelectVDSetClipState #X24)
(defconstant $kSelectVDGetClipState #X25)
(defconstant $kSelectVDSetClipRgn #X26)
(defconstant $kSelectVDClearClipRgn #X27)
(defconstant $kSelectVDGetCLUTInUse #X28)
(defconstant $kSelectVDSetPLLFilterType #X29)
(defconstant $kSelectVDGetPLLFilterType #X2A)
(defconstant $kSelectVDGetMaskandValue #X2B)
(defconstant $kSelectVDSetMasterBlendLevel #X2C)
(defconstant $kSelectVDSetPlayThruDestination #X2D)
(defconstant $kSelectVDSetPlayThruOnOff #X2E)
(defconstant $kSelectVDSetFieldPreference #X2F)
(defconstant $kSelectVDGetFieldPreference #X30)
(defconstant $kSelectVDPreflightDestination #X32)
(defconstant $kSelectVDPreflightGlobalRect #X33)
(defconstant $kSelectVDSetPlayThruGlobalRect #X34)
(defconstant $kSelectVDSetInputGammaRecord #X35)
(defconstant $kSelectVDGetInputGammaRecord #X36)
(defconstant $kSelectVDSetBlackLevelValue #X37)
(defconstant $kSelectVDGetBlackLevelValue #X38)
(defconstant $kSelectVDSetWhiteLevelValue #X39)
(defconstant $kSelectVDGetWhiteLevelValue #X3A)
(defconstant $kSelectVDGetVideoDefaults #X3B)
(defconstant $kSelectVDGetNumberOfInputs #X3C)
(defconstant $kSelectVDGetInputFormat #X3D)
(defconstant $kSelectVDSetInput #X3E)
(defconstant $kSelectVDGetInput #X3F)
(defconstant $kSelectVDSetInputStandard #X40)
(defconstant $kSelectVDSetupBuffers #X41)
(defconstant $kSelectVDGrabOneFrameAsync #X42)
(defconstant $kSelectVDDone #X43)
(defconstant $kSelectVDSetCompression #X44)
(defconstant $kSelectVDCompressOneFrameAsync #X45)
(defconstant $kSelectVDCompressDone #X46)
(defconstant $kSelectVDReleaseCompressBuffer #X47)
(defconstant $kSelectVDGetImageDescription #X48)
(defconstant $kSelectVDResetCompressSequence #X49)
(defconstant $kSelectVDSetCompressionOnOff #X4A)
(defconstant $kSelectVDGetCompressionTypes #X4B)
(defconstant $kSelectVDSetTimeBase #X4C)
(defconstant $kSelectVDSetFrameRate #X4D)
(defconstant $kSelectVDGetDataRate #X4E)
(defconstant $kSelectVDGetSoundInputDriver #X4F)
(defconstant $kSelectVDGetDMADepths #X50)
(defconstant $kSelectVDGetPreferredTimeScale #X51)
(defconstant $kSelectVDReleaseAsyncBuffers #X52)

(defconstant $StandardCompressionType :|scdi|)
(defconstant $StandardCompressionSubType :|imag|)

(def-mactype :SCMODALFILTERPROCPTR (find-mactype :POINTER))
(def-mactype :SCMODALHOOKPROCPTR (find-mactype :POINTER))

(defconstant $scListEveryCodec #X2)
(defconstant $scAllowZeroFrameRate #X4)
(defconstant $scAllowZeroKeyFrameRate #X8)
(defconstant $scShowBestDepth #X10)
(defconstant $scUseMovableModal #X20)

(defconstant $scPreferCropping 1)
(defconstant $scPreferScaling 2)
(defconstant $scPreferScalingAndCropping 3)

(defconstant $scTestImageWidth 80)
(defconstant $scTestImageHeight 80)

(defconstant $scOKItem 1)
(defconstant $scCancelItem 2)
(defconstant $scCustomItem 3)

(defconstant $scUserCancelled 1)

(defrecord SCSpatialSettings 
   (cType :OSTYPE)
   (codec (:POINTER :PRIVATECOMPONENTRECORD))
   (depth :SIGNED-INTEGER)
   (spatialQuality :SIGNED-LONG)
   )

(defrecord SCTemporalSettings 
   (temporalQuality :SIGNED-LONG)
   (frameRate :SIGNED-LONG)
   (keyFrameRate :SIGNED-LONG)
   )

(defrecord SCDataRateSettings 
   (dataRate :SIGNED-LONG)
   (frameDuration :SIGNED-LONG)
   (minSpatialQuality :SIGNED-LONG)
   (minTemporalQuality :SIGNED-LONG)
   )

(defrecord SCExtendedProcs 
   (filterProc :POINTER)
   (hookProc :POINTER)
   (refCon :SIGNED-LONG)
   (customName (:STRING 31))
   )

(defconstant $scSpatialSettingsType :|sptl|); 	pointer to SCSpatialSettings struct	
(defconstant $scTemporalSettingsType :|tprl|);  pointer to SCTemporalSettings struct	
(defconstant $scDataRateSettingsType :|drat|);  pointer to SCDataRateSettings struct	
(defconstant $scColorTableType :|clut|); 	Pointer to CTabHandle	
(defconstant $scProgressProcType :|prog|);  pointer to ProgressRecord struct	
(defconstant $scExtendedProcsType :|xprc|); 	pointer to SCExtendedProcs struct	
(defconstant $scPreferenceFlagsType :|pref|); 	pointer to long	
(defconstant $scSettingsStateType :|ssta|); 	pointer to Handle	
(defconstant $scSequenceIDType :|sequ|); 	pointer to ImageSequence	
(defconstant $scWindowPositionType :|wndw|); 	pointer to Point	
(defconstant $scCodecFlagsType :|cflg|); 	pointer to CodecFlags	

(defconstant $scInfoNotFoundErr -8971)


(deftrap _SCPOSITIONRECT ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (R :RECTPTR) (WHERE (:POINTER :POINT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI R WHERE ((+ (ASH 8 16) 2) :SIGNED-LONGINT)))

(deftrap _SCPOSITIONDIALOG ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (ID :SIGNED-INTEGER) (WHERE (:POINTER :POINT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI ID WHERE ((+ (ASH 6 16) 3) :SIGNED-LONGINT)))

(deftrap _SCSETTESTIMAGEPICTHANDLE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (TESTPICT (:HANDLE :PICTURE)) (TESTRECT :RECTPTR) (TESTFLAGS :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI TESTPICT TESTRECT TESTFLAGS ((+ (ASH 10 16) 4) :SIGNED-LONGINT)))

(deftrap _SCSETTESTIMAGEPICTFILE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (TESTFILEREF :SIGNED-INTEGER) (TESTRECT :RECTPTR) (TESTFLAGS :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI TESTFILEREF TESTRECT TESTFLAGS ((+ (ASH 8 16) 5) :SIGNED-LONGINT)))

(deftrap _SCSETTESTIMAGEPIXMAP ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (TESTPIXMAP (:HANDLE :PIXMAP)) (TESTRECT :RECTPTR) (TESTFLAGS :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI TESTPIXMAP TESTRECT TESTFLAGS ((+ (ASH 10 16) 6) :SIGNED-LONGINT)))

(deftrap _SCGETBESTDEVICERECT ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (R :RECTPTR))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI R ((+ (ASH 4 16) 7) :SIGNED-LONGINT)))

(deftrap _SCREQUESTIMAGESETTINGS ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI ((+ (ASH 0 16) 10) :SIGNED-LONGINT)))

(deftrap _SCCOMPRESSIMAGE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SRC (:HANDLE :PIXMAP)) (SRCRECT :RECT) (DESC (:POINTER (:HANDLE :IMAGEDESCRIPTION))) (DATA (:POINTER :HANDLE)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI SRC SRCRECT DESC DATA ((+ (ASH 16 16) 11) :SIGNED-LONGINT)))

(deftrap _SCCOMPRESSPICTURE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SRC (:HANDLE :PICTURE)) (DST (:HANDLE :PICTURE)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI SRC DST ((+ (ASH 8 16) 12) :SIGNED-LONGINT)))

(deftrap _SCCOMPRESSPICTUREFILE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SRCREF :SIGNED-INTEGER) (DSTREF :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI SRCREF DSTREF ((+ (ASH 4 16) 13) :SIGNED-LONGINT)))

(deftrap _SCREQUESTSEQUENCESETTINGS ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI ((+ (ASH 0 16) 14) :SIGNED-LONGINT)))

(deftrap _SCCOMPRESSSEQUENCEBEGIN ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SRC (:HANDLE :PIXMAP)) (SRCRECT :RECT) (DESC (:POINTER (:HANDLE :IMAGEDESCRIPTION))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI SRC SRCRECT DESC ((+ (ASH 12 16) 15) :SIGNED-LONGINT)))

(deftrap _SCCOMPRESSSEQUENCEFRAME ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SRC (:HANDLE :PIXMAP)) (SRCRECT :RECT) (DATA (:POINTER :HANDLE)) (DATASIZE (:POINTER :SIGNED-LONG)) (NOTSYNCFLAG (:POINTER :BOOLEAN)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI SRC SRCRECT DATA DATASIZE NOTSYNCFLAG ((+ (ASH 20 16) 16) :SIGNED-LONGINT)))

(deftrap _SCCOMPRESSSEQUENCEEND ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI ((+ (ASH 0 16) 17) :SIGNED-LONGINT)))

(deftrap _SCDEFAULTPICTHANDLESETTINGS ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SRC (:HANDLE :PICTURE)) (MOTION :BOOLEAN))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI SRC MOTION ((+ (ASH 6 16) 18) :SIGNED-LONGINT)))

(deftrap _SCDEFAULTPICTFILESETTINGS ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SRCREF :SIGNED-INTEGER) (MOTION :BOOLEAN))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI SRCREF MOTION ((+ (ASH 4 16) 19) :SIGNED-LONGINT)))

(deftrap _SCDEFAULTPIXMAPSETTINGS ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SRC (:HANDLE :PIXMAP)) (MOTION :BOOLEAN))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI SRC MOTION ((+ (ASH 4 16) 20) :SIGNED-LONGINT)))

(deftrap _SCGETINFO ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (INFOTYPE :OSTYPE) (INFO :POINTER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INFOTYPE INFO ((+ (ASH 8 16) 21) :SIGNED-LONGINT)))

(deftrap _SCSETINFO ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (INFOTYPE :OSTYPE) (INFO :POINTER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INFOTYPE INFO ((+ (ASH 8 16) 22) :SIGNED-LONGINT)))

(deftrap _SCNEWGWORLD ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (GWP (:POINTER (:POINTER :CGRAFPORT))) (RP (:POINTER :RECT)) (FLAGS :UNSIGNED-LONGINT))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI GWP RP FLAGS ((+ (ASH 12 16) 23) :SIGNED-LONGINT)))

(defconstant $kScPositionRect 2)
(defconstant $kScPositionDialog 3)
(defconstant $kScSetTestImagePictHandle 4)
(defconstant $kScSetTestImagePictFile 5)
(defconstant $kScSetTestImagePixMap 6)
(defconstant $kScGetBestDeviceRect 7)

(defconstant $kScRequestImageSettings #XA)
(defconstant $kScCompressImage #XB)
(defconstant $kScCompressPicture #XC)
(defconstant $kScCompressPictureFile #XD)
(defconstant $kScRequestSequenceSettings #XE)
(defconstant $kScCompressSequenceBegin #XF)
(defconstant $kScCompressSequenceFrame #X10)
(defconstant $kScCompressSequenceEnd #X11)
(defconstant $kScDefaultPictHandleSettings #X12)
(defconstant $kScDefaultPictFileSettings #X13)
(defconstant $kScDefaultPixMapSettings #X14)
(defconstant $kScGetInfo #X15)
(defconstant $kScSetInfo #X16)
(defconstant $kScNewGWorld #X17)

;  For compatibility 

(defrecord SCParams 
   (flags :SIGNED-LONG)
   (theCodecType :OSTYPE)
   (theCodec (:POINTER :PRIVATECOMPONENTRECORD))
   (spatialQuality :SIGNED-LONG)
   (temporalQuality :SIGNED-LONG)
   (depth :SIGNED-INTEGER)
   (frameRate :SIGNED-LONG)
   (keyFrameRate :SIGNED-LONG)
   (reserved1 :SIGNED-LONG)
   (reserved2 :SIGNED-LONG)
   )

(defconstant $kScShowMotionSettings 1)
(defconstant $kScGetCompression 1)
(defconstant $kScSettingsChangedItem -1)


#| Not in ROM
(deftrap _OPENSTDCOMPRESSION NIL
   (:STACK (:POINTER :PRIVATECOMPONENTINSTANCERECORD))
   (:STACK-TRAP #x0))
|#
(deftrap _SCGETCOMPRESSIONEXTENDED ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SPARAMS (:POINTER :SCPARAMS)) (WHERE :POINT) (FILTERPROC :POINTER) (HOOKPROC :POINTER) (REFCON :SIGNED-LONG) (CUSTOMNAME (:STRING 255)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI SPARAMS WHERE FILTERPROC HOOKPROC REFCON CUSTOMNAME ((+ (ASH 24 16) 1) :SIGNED-LONGINT)))

#| Not in ROM - INLINE =  #x42A7 #x42A7 #x42A7 #x42A7 #x2F3C #x0018 #x0001 #x7000 #xA82A
(deftrap _SCGETCOMPRESSION ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SPARAMS (:POINTER :SCPARAMS)) (WHERE :POINT))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #x0))
|#

; 
; 
; 		Movie Import Components
; 
; 

(def-mactype :MOVIEIMPORTCOMPONENT (find-mactype :POINTER))
(def-mactype :MOVIEEXPORTCOMPONENT (find-mactype :POINTER))

(defconstant $MovieImportType :|eat |)
(defconstant $MovieExportType :|spit|)

(defconstant $canMovieImportHandles 1)
(defconstant $canMovieImportFiles 2)
(defconstant $hasMovieImportUserInterface 4)
(defconstant $canMovieExportHandles 8)
(defconstant $canMovieExportFiles #X10)
(defconstant $hasMovieExportUserInterface #X20)
(defconstant $dontAutoFileMovieImport #X40)

(defconstant $kMovieImportExportOpenSelect #$KCOMPONENTOPENSELECT)
(defconstant $kMovieImportExportCloseSelect #$KCOMPONENTCLOSESELECT)
(defconstant $kMovieImportExportCanDoSelect #$KCOMPONENTCANDOSELECT)
(defconstant $kMovieImportExportVersionSelect #$KCOMPONENTVERSIONSELECT)

(defconstant $kMovieImportHandleSelect 1)
(defconstant $kMovieImportFileSelect 2)
(defconstant $kMovieImportSetFrameDurationSelect 3)
(defconstant $kMovieImportSetSampleDescriptionSelect 4)
(defconstant $kMovieImportSetMediaFileSelect 5)
(defconstant $kMovieImportSetDimensionsSelect 6)
(defconstant $kMovieImportSetChunkSizeSelect 7)
(defconstant $kMovieImportSetProgressProcSelect 8)
(defconstant $kMovieImportSetAuxiliaryDataSelect 9)
(defconstant $kMovieImportSetFromScrapSelect #XA)
(defconstant $kMovieImportDoUserDialogSelect #XB)
(defconstant $kMovieImportSetDuration #XC)

(defconstant $kMovieExportToHandleSelect #X80)
(defconstant $kMovieExportToFileSelect #X81)
(defconstant $kMovieExportDoUserDialogSelect #X82)
(defconstant $kMovieExportGetAuxiliaryDataSelect #X83)
(defconstant $kMovieExportSetProgressProcSelect #X84)

(defconstant $movieImportCreateTrack 1)
(defconstant $movieImportInParallel 2)
(defconstant $movieImportMustUseTrack 4)

(defconstant $movieImportResultUsedMultipleTracks 8)


(deftrap _MOVIEIMPORTHANDLE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DATAH :HANDLE) (THEMOVIE (:POINTER :MOVIERECORD)) (TARGETTRACK (:POINTER :TRACKRECORD)) (USEDTRACK (:POINTER (:POINTER :TRACKRECORD))) (ATTIME :SIGNED-LONG) (ADDEDDURATION (:POINTER :SIGNED-LONG)) (INFLAGS :SIGNED-LONG) (OUTFLAGS (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI DATAH THEMOVIE TARGETTRACK USEDTRACK ATTIME ADDEDDURATION INFLAGS OUTFLAGS ((+ (ASH 32 16) 1) :SIGNED-LONGINT)))


(deftrap _MOVIEIMPORTFILE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (THEFILE :FSSPEC) (THEMOVIE (:POINTER :MOVIERECORD)) (TARGETTRACK (:POINTER :TRACKRECORD)) (USEDTRACK (:POINTER (:POINTER :TRACKRECORD))) (ATTIME :SIGNED-LONG) (ADDEDDURATION (:POINTER :SIGNED-LONG)) (INFLAGS :SIGNED-LONG) (OUTFLAGS (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI THEFILE THEMOVIE TARGETTRACK USEDTRACK ATTIME ADDEDDURATION INFLAGS OUTFLAGS ((+ (ASH 32 16) 2) :SIGNED-LONGINT)))


(deftrap _MOVIEIMPORTSETSAMPLEDURATION ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DURATION :SIGNED-LONG) (SCALE :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI DURATION SCALE ((+ (ASH 8 16) 3) :SIGNED-LONGINT)))


(deftrap _MOVIEIMPORTSETSAMPLEDESCRIPTION ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DESC (:HANDLE :SAMPLEDESCRIPTION)) (MEDIATYPE :OSTYPE))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI DESC MEDIATYPE ((+ (ASH 8 16) 4) :SIGNED-LONGINT)))


(deftrap _MOVIEIMPORTSETMEDIAFILE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (ALIAS (:HANDLE :ALIASRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI ALIAS ((+ (ASH 4 16) 5) :SIGNED-LONGINT)))


(deftrap _MOVIEIMPORTSETDIMENSIONS ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (WIDTH :SIGNED-LONG) (HEIGHT :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI WIDTH HEIGHT ((+ (ASH 8 16) 6) :SIGNED-LONGINT)))


(deftrap _MOVIEIMPORTSETCHUNKSIZE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (CHUNKSIZE :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI CHUNKSIZE ((+ (ASH 4 16) 7) :SIGNED-LONGINT)))


(deftrap _MOVIEIMPORTSETPROGRESSPROC ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (PROC :POINTER) (REFCON :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI PROC REFCON ((+ (ASH 8 16) 8) :SIGNED-LONGINT)))


(deftrap _MOVIEIMPORTSETAUXILIARYDATA ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DATA :HANDLE) (HANDLETYPE :OSTYPE))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI DATA HANDLETYPE ((+ (ASH 8 16) 9) :SIGNED-LONGINT)))


(deftrap _MOVIEIMPORTSETFROMSCRAP ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (FROMSCRAP :BOOLEAN))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI FROMSCRAP ((+ (ASH 2 16) 10) :SIGNED-LONGINT)))


(deftrap _MOVIEIMPORTDOUSERDIALOG ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (SRCFILE :FSSPEC) (DATA :HANDLE) (CANCELED (:POINTER :BOOLEAN)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI SRCFILE DATA CANCELED ((+ (ASH 12 16) 11) :SIGNED-LONGINT)))


(deftrap _MOVIEIMPORTSETDURATION ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DURATION :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI DURATION ((+ (ASH 4 16) 12) :SIGNED-LONGINT)))


(deftrap _MOVIEEXPORTTOHANDLE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DATA :HANDLE) (THEMOVIE (:POINTER :MOVIERECORD)) (ONLYTHISTRACK (:POINTER :TRACKRECORD)) (STARTTIME :SIGNED-LONG) (DURATION :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI DATA THEMOVIE ONLYTHISTRACK STARTTIME DURATION ((+ (ASH 20 16) 128) :SIGNED-LONGINT)))


(deftrap _MOVIEEXPORTTOFILE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DSTFILE :FSSPEC) (THEMOVIE (:POINTER :MOVIERECORD)) (ONLYTHISTRACK (:POINTER :TRACKRECORD)) (STARTTIME :SIGNED-LONG) (DURATION :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI DSTFILE THEMOVIE ONLYTHISTRACK STARTTIME DURATION ((+ (ASH 20 16) 129) :SIGNED-LONGINT)))


(deftrap _MOVIEEXPORTDOUSERDIALOG ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DSTFILE :FSSPEC) (DATA :HANDLE) (CANCELED (:POINTER :BOOLEAN)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI DSTFILE DATA CANCELED ((+ (ASH 12 16) 130) :SIGNED-LONGINT)))


(deftrap _MOVIEEXPORTGETAUXILIARYDATA ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DSTFILE :HANDLE) (HANDLETYPE (:POINTER :OSTYPE)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI DSTFILE HANDLETYPE ((+ (ASH 8 16) 131) :SIGNED-LONGINT)))


(deftrap _MOVIEEXPORTSETPROGRESSPROC ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (PROC :POINTER) (REFCON :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI PROC REFCON ((+ (ASH 8 16) 132) :SIGNED-LONGINT)))

(def-mactype :PNOTCOMPONENT (find-mactype :POINTER))

(defconstant $pnotComponentWantsEvents 1)
(defconstant $pnotComponentNeedsNoCache 2)

(defconstant $kPreviewOpenSelector 0)
(defconstant $kPreviewCloseSelector -1)
(defconstant $kPreviewCanDoSelector -2)
(defconstant $kPreviewVersionSelector -3)

(defconstant $kPreviewShowDataSelector 1)
(defconstant $kPreviewMakePreviewSelector 2)
(defconstant $kPreviewMakePreviewReferenceSelector 3)
(defconstant $kPreviewEventSelector 4)

(defconstant $ShowFilePreviewComponentType :|pnot|)
(defconstant $CreateFilePreviewrComponentType :|pmak|)


(deftrap _PREVIEWSHOWDATA ((P (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (DATATYPE :OSTYPE) (DATA :HANDLE) (INHERE (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 P DATATYPE DATA INHERE ((+ (ASH 12 16) 1) :SIGNED-LONGINT)))


(deftrap _PREVIEWMAKEPREVIEW ((P (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (PREVIEWTYPE (:POINTER :OSTYPE)) (PREVIEWRESULT (:POINTER :HANDLE)) (SOURCEFILE (:POINTER :FSSPEC)) (PROGRESS (:POINTER :PROGRESSPROCRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 P PREVIEWTYPE PREVIEWRESULT SOURCEFILE PROGRESS ((+ (ASH 16 16) 2) :SIGNED-LONGINT)))


(deftrap _PREVIEWMAKEPREVIEWREFERENCE ((P (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (PREVIEWTYPE (:POINTER :OSTYPE)) (REID (:POINTER :SIGNED-INTEGER)) (SOURCEFILE (:POINTER :FSSPEC)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 P PREVIEWTYPE REID SOURCEFILE ((+ (ASH 12 16) 3) :SIGNED-LONGINT)))


(deftrap _PREVIEWEVENT ((P (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (E (:POINTER :EVENTRECORD)) (HANDLEDEVENT (:POINTER :BOOLEAN)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 P E HANDLEDEVENT ((+ (ASH 8 16) 4) :SIGNED-LONGINT)))

; $ENDC                         ;  UsingQuickTimeComponents 

; $IFC NOT UsingIncludes

; $ENDC


(export '($CREATEFILEPREVIEWRCOMPONENTTYPE $SHOWFILEPREVIEWCOMPONENTTYPE
          $KPREVIEWEVENTSELECTOR $KPREVIEWMAKEPREVIEWREFERENCESELECTOR
          $KPREVIEWMAKEPREVIEWSELECTOR $KPREVIEWSHOWDATASELECTOR
          $KPREVIEWVERSIONSELECTOR $KPREVIEWCANDOSELECTOR
          $KPREVIEWCLOSESELECTOR $KPREVIEWOPENSELECTOR
          $PNOTCOMPONENTNEEDSNOCACHE $PNOTCOMPONENTWANTSEVENTS
          $MOVIEIMPORTRESULTUSEDMULTIPLETRACKS $MOVIEIMPORTMUSTUSETRACK
          $MOVIEIMPORTINPARALLEL $MOVIEIMPORTCREATETRACK
          $KMOVIEEXPORTSETPROGRESSPROCSELECT
          $KMOVIEEXPORTGETAUXILIARYDATASELECT $KMOVIEEXPORTDOUSERDIALOGSELECT
          $KMOVIEEXPORTTOFILESELECT $KMOVIEEXPORTTOHANDLESELECT
          $KMOVIEIMPORTSETDURATION $KMOVIEIMPORTDOUSERDIALOGSELECT
          $KMOVIEIMPORTSETFROMSCRAPSELECT $KMOVIEIMPORTSETAUXILIARYDATASELECT
          $KMOVIEIMPORTSETPROGRESSPROCSELECT $KMOVIEIMPORTSETCHUNKSIZESELECT
          $KMOVIEIMPORTSETDIMENSIONSSELECT $KMOVIEIMPORTSETMEDIAFILESELECT
          $KMOVIEIMPORTSETSAMPLEDESCRIPTIONSELECT
          $KMOVIEIMPORTSETFRAMEDURATIONSELECT $KMOVIEIMPORTFILESELECT
          $KMOVIEIMPORTHANDLESELECT $KMOVIEIMPORTEXPORTVERSIONSELECT
          $KMOVIEIMPORTEXPORTCANDOSELECT $KMOVIEIMPORTEXPORTCLOSESELECT
          $KMOVIEIMPORTEXPORTOPENSELECT $DONTAUTOFILEMOVIEIMPORT
          $HASMOVIEEXPORTUSERINTERFACE $CANMOVIEEXPORTFILES
          $CANMOVIEEXPORTHANDLES $HASMOVIEIMPORTUSERINTERFACE
          $CANMOVIEIMPORTFILES $CANMOVIEIMPORTHANDLES $MOVIEEXPORTTYPE
          $MOVIEIMPORTTYPE $KSCSETTINGSCHANGEDITEM $KSCGETCOMPRESSION
          $KSCSHOWMOTIONSETTINGS $KSCNEWGWORLD $KSCSETINFO $KSCGETINFO
          $KSCDEFAULTPIXMAPSETTINGS $KSCDEFAULTPICTFILESETTINGS
          $KSCDEFAULTPICTHANDLESETTINGS $KSCCOMPRESSSEQUENCEEND
          $KSCCOMPRESSSEQUENCEFRAME $KSCCOMPRESSSEQUENCEBEGIN
          $KSCREQUESTSEQUENCESETTINGS $KSCCOMPRESSPICTUREFILE
          $KSCCOMPRESSPICTURE $KSCCOMPRESSIMAGE $KSCREQUESTIMAGESETTINGS
          $KSCGETBESTDEVICERECT $KSCSETTESTIMAGEPIXMAP $KSCSETTESTIMAGEPICTFILE
          $KSCSETTESTIMAGEPICTHANDLE $KSCPOSITIONDIALOG $KSCPOSITIONRECT
          $SCINFONOTFOUNDERR $SCCODECFLAGSTYPE $SCWINDOWPOSITIONTYPE
          $SCSEQUENCEIDTYPE $SCSETTINGSSTATETYPE $SCPREFERENCEFLAGSTYPE
          $SCEXTENDEDPROCSTYPE $SCPROGRESSPROCTYPE $SCCOLORTABLETYPE
          $SCDATARATESETTINGSTYPE $SCTEMPORALSETTINGSTYPE
          $SCSPATIALSETTINGSTYPE $SCUSERCANCELLED $SCCUSTOMITEM $SCCANCELITEM
          $SCOKITEM $SCTESTIMAGEHEIGHT $SCTESTIMAGEWIDTH
          $SCPREFERSCALINGANDCROPPING $SCPREFERSCALING $SCPREFERCROPPING
          $SCUSEMOVABLEMODAL $SCSHOWBESTDEPTH $SCALLOWZEROKEYFRAMERATE
          $SCALLOWZEROFRAMERATE $SCLISTEVERYCODEC $STANDARDCOMPRESSIONSUBTYPE
          $STANDARDCOMPRESSIONTYPE $KSELECTVDRELEASEASYNCBUFFERS
          $KSELECTVDGETPREFERREDTIMESCALE $KSELECTVDGETDMADEPTHS
          $KSELECTVDGETSOUNDINPUTDRIVER $KSELECTVDGETDATARATE
          $KSELECTVDSETFRAMERATE $KSELECTVDSETTIMEBASE
          $KSELECTVDGETCOMPRESSIONTYPES $KSELECTVDSETCOMPRESSIONONOFF
          $KSELECTVDRESETCOMPRESSSEQUENCE $KSELECTVDGETIMAGEDESCRIPTION
          $KSELECTVDRELEASECOMPRESSBUFFER $KSELECTVDCOMPRESSDONE
          $KSELECTVDCOMPRESSONEFRAMEASYNC $KSELECTVDSETCOMPRESSION
          $KSELECTVDDONE $KSELECTVDGRABONEFRAMEASYNC $KSELECTVDSETUPBUFFERS
          $KSELECTVDSETINPUTSTANDARD $KSELECTVDGETINPUT $KSELECTVDSETINPUT
          $KSELECTVDGETINPUTFORMAT $KSELECTVDGETNUMBEROFINPUTS
          $KSELECTVDGETVIDEODEFAULTS $KSELECTVDGETWHITELEVELVALUE
          $KSELECTVDSETWHITELEVELVALUE $KSELECTVDGETBLACKLEVELVALUE
          $KSELECTVDSETBLACKLEVELVALUE $KSELECTVDGETINPUTGAMMARECORD
          $KSELECTVDSETINPUTGAMMARECORD $KSELECTVDSETPLAYTHRUGLOBALRECT
          $KSELECTVDPREFLIGHTGLOBALRECT $KSELECTVDPREFLIGHTDESTINATION
          $KSELECTVDGETFIELDPREFERENCE $KSELECTVDSETFIELDPREFERENCE
          $KSELECTVDSETPLAYTHRUONOFF $KSELECTVDSETPLAYTHRUDESTINATION
          $KSELECTVDSETMASTERBLENDLEVEL $KSELECTVDGETMASKANDVALUE
          $KSELECTVDGETPLLFILTERTYPE $KSELECTVDSETPLLFILTERTYPE
          $KSELECTVDGETCLUTINUSE $KSELECTVDCLEARCLIPRGN $KSELECTVDSETCLIPRGN
          $KSELECTVDGETCLIPSTATE $KSELECTVDSETCLIPSTATE
          $KSELECTVDGETINPUTCOLORSPACEMODE $KSELECTVDSETINPUTCOLORSPACEMODE
          $KSELECTVDSETDIGITIZERUSERINTERRUPT $KSELECTVDGETKEYCOLORRANGE
          $KSELECTVDSETKEYCOLORRANGE $KSELECTVDGETNEXTKEYCOLOR
          $KSELECTVDADDKEYCOLOR $KSELECTVDGETKEYCOLOR $KSELECTVDSETKEYCOLOR
          $KSELECTVDGETCURRENTFLAGS $KSELECTVDGETDIGITIZERINFO
          $KSELECTVDGETMAXAUXBUFFER $KSELECTVDGRABONEFRAME
          $KSELECTVDGETSATURATION $KSELECTVDGETSHARPNESS $KSELECTVDGETHUE
          $KSELECTVDGETCONTRAST $KSELECTVDSETSATURATION $KSELECTVDSETSHARPNESS
          $KSELECTVDSETHUE $KSELECTVDSETCONTRAST $KSELECTVDGETBRIGHTNESS
          $KSELECTVDSETBRIGHTNESS $KSELECTVDGETINPUTGAMMAVALUE
          $KSELECTVDSETINPUTGAMMAVALUE $KSELECTVDUSETHISCLUT
          $KSELECTVDGETPLAYTHRUDESTINATION $KSELECTVDGETMASKPIXMAP
          $KSELECTVDGETVBLANKRECT $KSELECTVDGETDIGITIZERRECT
          $KSELECTVDSETDIGITIZERRECT $KSELECTVDGETACTIVESRCRECT
          $KSELECTVDGETMAXSRCRECT $KVDIGSELECTORS $DMADEPTH8GRAY $DMADEPTH4GRAY
          $DMADEPTH2GRAY $DMADEPTH32 $DMADEPTH16 $DMADEPTH8 $DMADEPTH4
          $DMADEPTH2 $DMADEPTH1 $DIGIOUTDOESPLAYTHRUDURINGCOMPRESS
          $DIGIOUTDOESCOMPRESSONLY $DIGIOUTDOESCOMPRESS
          $DIGIOUTDOESUNREADABLESCREENBITS $DIGIOUTDOESASYNCGRABS
          $DIGIOUTDOESKEYCOLOR $DIGIOUTDOESILUT $DIGIOUTDOESHWPLAYTHRU
          $DIGIOUTDOESHW_DMA $DIGIOUTDOESWARP $DIGIOUTDOESBLEND
          $DIGIOUTDOESSKEW $DIGIOUTDOESVERTFLIP $DIGIOUTDOESHORIZFLIP
          $DIGIOUTDOESROTATE $DIGIOUTDOESSIXTEENTH $DIGIOUTDOESQUARTER
          $DIGIOUTDOESQUAD $DIGIOUTDOESDOUBLE $DIGIOUTDOESMASK
          $DIGIOUTDOESSHRINK $DIGIOUTDOESSTRETCH $DIGIOUTDOESDITHER
          $DIGIOUTDOES32 $DIGIOUTDOES16 $DIGIOUTDOES8 $DIGIOUTDOES4
          $DIGIOUTDOES2 $DIGIOUTDOES1 $DIGIINSIGNALLOCK $DIGIINDOESBW
          $DIGIINDOESCOLOR $DIGIINVTR_BROADCAST $DIGIINDOESCOMPONENT
          $DIGIINDOESSVIDEO $DIGIINDOESCOMPOSITE $DIGIINDOESGENLOCK
          $DIGIINDOESSECAM $DIGIINDOESPAL $DIGIINDOESNTSC $BADCALLORDER $NODMA
          $BADDEPTH $NOTEXACTSIZE $NOMOREKEYCOLORS $NOTEXACTMATRIX $MATRIXERR
          $QTPARAMERR $DIGIUNIMPERR $VDTYPEKEY $VDTYPEMASK $VDTYPEALPHA
          $VDTYPEBASIC $VDUSEEVENFIELD $VDUSEODDFIELD $VDUSEANYFIELD $VDVTRMODE
          $VDBROADCASTMODE $VDDIGITIZERRGB $VDDIGITIZERBW $VDPLAYTHRUON
          $VDPLAYTHRUOFF $RGBCOMPONENTIN $SVIDEOIN $COMPOSITEIN $NTSCREALLYIN
          $SECAMIN $PALIN $CURRENTIN $NTSCIN $VDIGINTERFACEREV
          $VIDEODIGITIZERCOMPONENTTYPE $KSGCGETSOUNDINPUTPARAMETERSSELECT
          $KSGCSETSOUNDINPUTPARAMETERSSELECT $KSGCGETSOUNDINPUTRATESELECT
          $KSGCSETSOUNDINPUTRATESELECT $KSGCGETSOUNDRECORDCHUNKSIZESELECT
          $KSGCSETSOUNDRECORDCHUNKSIZESELECT $KSGCSOUNDINPUTDRIVERCHANGEDSELECT
          $KSGCGETSOUNDINPUTDRIVERSELECT $KSGCSETSOUNDINPUTDRIVERSELECT
          $KSGCGETFRAMERATESELECT $KSGCSETFRAMERATESELECT
          $KSGCDISPLAYCOMPRESSSELECT $KSGCGRABCOMPRESSCOMPLETESELECT
          $KSGCGETUSESCREENBUFFERSELECT $KSGCSETUSESCREENBUFFERSELECT
          $KSGCGETBUFFERINFOSELECT $KSGCGETCOMPRESSBUFFERSELECT
          $KSGCSETCOMPRESSBUFFERSELECT $KSGCTRANSFERFRAMEFORCOMPRESSSELECT
          $KSGCADDFRAMESELECT $KSGCCOMPRESSFRAMECOMPLETESELECT
          $KSGCCOMPRESSFRAMESELECT $KSGCDISPLAYFRAMESELECT
          $KSGCGRABFRAMECOMPLETESELECT $KSGCGRABFRAMESELECT
          $KSGCGETVIDEOBOTTLENECKSSELECT $KSGCSETVIDEOBOTTLENECKSSELECT
          $KSGCVIDEODIGITIZERCHANGEDSELECT
          $KSGCSETVIDEODIGITIZERCOMPONENTSELECT
          $KSGCGETVIDEODIGITIZERCOMPONENTSELECT $KSGCGETVIDEOCOMPRESSORSELECT
          $KSGCSETVIDEOCOMPRESSORSELECT $KSGCSETVIDEOCOMPRESSORTYPESELECT
          $KSGCGETVIDEOCOMPRESSORTYPESELECT $KSGCGETVIDEORECTSELECT
          $KSGCSETVIDEORECTSELECT $KSGCGETSRCVIDEOBOUNDSSELECT
          $KSGCPANELVALIDATEINPUTSELECT $KSGCPANELSETSETTINGSSELECT
          $KSGCPANELGETSETTINGSSELECT $KSGCPANELSETRESFILESELECT
          $KSGCPANELSETGRABBERSELECT $KSGCPANELREMOVESELECT
          $KSGCPANELITEMSELECT $KSGCPANELEVENTSELECT $KSGCPANELINSTALLSELECT
          $KSGCPANELCANRUNSELECT $KSGCPANELGETTITLESELECT
          $KSGCPANELGETDITLSELECT $KSGCALIGNCHANNELRECTSELECT
          $KSGCGETDATARATESELECT $KSGCWRITESAMPLESSELECT $KSGCINITCHANNELSELECT
          $KSGCGETCHANNELTIMESCALESELECT $KSGCGETCHANNELMATRIXSELECT
          $KSGCSETCHANNELMATRIXSELECT $KSGCSETCHANNELDEVICESELECT
          $KSGCGETCHANNELDEVICELISTSELECT
          $KSGCGETCHANNELSAMPLEDESCRIPTIONSELECT $KSGCGETCHANNELCLIPSELECT
          $KSGCSETCHANNELCLIPSELECT $KSGCSETCHANNELREFCONSELECT
          $KSGCGETCHANNELMAXFRAMESSELECT $KSGCSETCHANNELMAXFRAMESSELECT
          $KSGCGETCHANNELPLAYFLAGSSELECT $KSGCSETCHANNELPLAYFLAGSSELECT
          $KSGCGETCHANNELINFOSELECT $KSGCGETCHANNELVOLUMESELECT
          $KSGCSETCHANNELVOLUMESELECT $KSGCGETCHANNELBOUNDSSELECT
          $KSGCSETCHANNELBOUNDSSELECT $KSGCGETCHANNELUSAGESELECT
          $KSGCSETCHANNELUSAGESELECT $KSGCHANGEDSOURCESELECT
          $KSGADDMOVIEDATASELECT $KSGSORTDEVICELISTSELECT $KSGGETTIMEBASESELECT
          $KSGGETNEXTFRAMEREFERENCESELECT $KSGADDFRAMEREFERENCESELECT
          $KSGWRITEMOVIEDATASELECT $KSGGETCHANNELSETTINGSSELECT
          $KSGSETCHANNELSETTINGSSELECT $KSGGETALIGNMENTPROCSELECT
          $KSGSETTINGSDIALOGSELECT $KSGGETPAUSESELECT $KSGUPDATESELECT
          $KSGGETINDCHANNELSELECT $KSGGETSETTINGSSELECT $KSGSETSETTINGSSELECT
          $KSGAPPENDDEVICELISTTOMENUSELECT $KSGDISPOSEDEVICELISTSELECT
          $KSGNEWCHANNELFROMCOMPONENTSELECT $KSGSETDATAPROCSELECT
          $KSGGETFLAGSSELECT $KSGSETFLAGSSELECT $KSGGETLASTMOVIERESIDSELECT
          $KSGGRABPICTSELECT $KSGGETTIMEREMAININGSELECT
          $KSGGETSTORAGESPACEREMAININGSELECT $KSGGETMAXIMUMRECORDTIMESELECT
          $KSGSETMAXIMUMRECORDTIMESELECT $KSGGETMOVIESELECT $KSGRELEASESELECT
          $KSGPREPARESELECT $KSGPAUSESELECT $KSGSTOPSELECT $KSGIDLESELECT
          $KSGSTARTRECORDSELECT $KSGSTARTPREVIEWSELECT $KSGDISPOSECHANNELSELECT
          $KSGNEWCHANNELSELECT $KSGGETGWORLDSELECT $KSGSETGWORLDSELECT
          $KSGGETDATAOUTPUTSELECT $KSGSETDATAOUTPUTSELECT $KSGINITIALIZESELECT
          $DEVICECANTMEETREQUEST $SEQGRABINFONOTAVAILABLE $BADSGCHANNEL
          $COULDNTGETREQUIREDCOMPONENT $NOTENOUGHDISKSPACETOGRAB
          $NOTENOUGHMEMORYTOGRAB $CANTDOTHATINCURRENTMODE $GRABTIMECOMPLETE
          $NODEVICEFORCHANNEL $SGVIDEODIGITIZERTYPE $SGCVIDEORECTTYPE
          $SGCVIDEOFILTERTYPE $SGCVIDEOFORMATTYPE $SGCVIDEOINPUTTYPE
          $SGCVIDEOWHITELEVELTYPE $SGCVIDEOBLACKLEVELTYPE
          $SGCVIDEOBRIGTNESSTYPE $SGCVIDEOSHARPNESSTYPE $SGCVIDEOCONTRASTTYPE
          $SGCVIDEOSATURATIONTYPE $SGCVIDEOHUETYPE $SGCSOUNDGAINTYPE
          $SGCSOUNDINPUTTYPE $SGCSOUNDSAMPLESIZETYPE $SGCSOUNDCHANNELCOUNTTYPE
          $SGCSOUNDSAMPLERATETYPE $SGCSOUNDCOMPRESSIONTYPE $SGPANELSETTINGS
          $SGPANELDESCRIPTION $SGPANELSETTINGSATOM $SGVOLUMETYPE $SGMATRIXTYPE
          $SGCLIPTYPE $SGPLAYFLAGSTYPE $SGUSAGETYPE $SGDEVICENAMETYPE
          $SGCHANNELSETTINGS $SGCHANNELDESCRIPTION $SGCHANNELSETTINGSATOM
          $SGCHANNELATOM $CHANNELPLAYALLDATA $CHANNELPLAYHIGHQUALITY
          $CHANNELPLAYFAST $CHANNELPLAYNORMAL $SGPANELFLAGFORPANEL
          $CHANNELFLAGHASDEPENDENCY $CHANNELFLAGDONTOPENRESFILE
          $SEQGRABPAUSEFORMENU $SEQGRABPAUSE $SEQGRABUNPAUSE $SEQGRABWRITE
          $SEQGRABWRITERESERVE $SEQGRABWRITEAPPEND
          $SGDEVICELISTDONTCHECKAVAILABILITY $SGDEVICELISTWITHICONS
          $SGDEVICENAMEFLAGDEVICEUNAVAILABLE $SGFLAGCONTROLLEDGRAB
          $GRABPICTIGNORECLIP $GRABPICTOFFSCREEN $SEQGRABHASDISCRETESAMPLES
          $SEQGRABHASVOLUME $SEQGRABHASBOUNDS $SEQGRABPLAYDURINGRECORD
          $SEQGRABPREVIEW $SEQGRABRECORD $SEQGRABPREEXTENDFILE
          $SEQGRABDONTMAKEMOVIE $SEQGRABDONTADDMOVIERESOURCE
          $SEQGRABAPPENDTOFILE $SEQGRABUSETEMPMEMORY $SEQGRABTOMEMORY
          $SEQGRABTODISK $SEQGRABSOURCEPANELTYPE $SEQGRABCOMPRESSIONPANELTYPE
          $SEQGRABPANELTYPE $SEQGRABCHANNELTYPE $SEQGRABCOMPONENTTYPE
          $KCLOCKGETRATESELECT $KCLOCKSTARTSTOPCHANGEDSELECT
          $KCLOCKSETTIMEBASESELECT $KCLOCKTIMECHANGEDSELECT
          $KCLOCKRATECHANGEDSELECT $KCLOCKCANCELCALLBACKSELECT
          $KCLOCKCALLMEWHENSELECT $KCLOCKDISPOSECALLBACKSELECT
          $KCLOCKNEWCALLBACKSELECT $KCLOCKGETCLOCKTIMESELECT
          $KCLOCKIMPLEMENTSCALLBACKS $KCLOCKRATEISLINEAR
          $SYSTEMMICROSECONDCLOCK $SYSTEMMILLISECONDCLOCK $SYSTEMSECONDCLOCK
          $SYSTEMTICKCLOCK $CLOCKCOMPONENTTYPE))
(provide-interface 'QuickTimeComponents)